/* Dimensions.c generated by valac 0.44.3, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ZOOM_STATE (zoom_state_get_type ())
typedef struct _ZoomState ZoomState;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ZoomState {
	Dimensions content_dimensions;
	Dimensions viewport_dimensions;
	gdouble zoom_factor;
	gdouble interpolation_factor;
	gdouble min_factor;
	gdouble max_factor;
	GdkPoint viewport_center;
};

GType scale_constraint_get_type (void) G_GNUC_CONST;
gchar* scale_constraint_to_string (ScaleConstraint self);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
void dimensions_for_allocation (GtkAllocation* allocation,
                                Dimensions* result);
void dimensions_for_widget_allocation (GtkWidget* widget,
                                       Dimensions* result);
void dimensions_for_rectangle (GdkRectangle* rect,
                               Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
void dimensions_floor (Dimensions *self,
                       Dimensions* min,
                       Dimensions* result);
gchar* dimensions_to_string (Dimensions *self);
gboolean dimensions_equals (Dimensions *self,
                            Dimensions* dim);
gboolean dimensions_approx_equals (Dimensions *self,
                                   Dimensions* dim,
                                   gint fudge);
gboolean dimensions_approx_scaled (Dimensions *self,
                                   gint scale,
                                   gint fudge);
gint dimensions_major_axis (Dimensions *self);
gint dimensions_minor_axis (Dimensions *self);
void dimensions_with_min (Dimensions *self,
                          gint min_width,
                          gint min_height,
                          Dimensions* result);
void dimensions_with_max (Dimensions *self,
                          gint max_width,
                          gint max_height,
                          Dimensions* result);
void dimensions_get_scaled (Dimensions *self,
                            gint scale,
                            gboolean scale_up,
                            Dimensions* result);
void dimensions_get_scaled_by_width (Dimensions *self,
                                     gint scale,
                                     Dimensions* result);
void dimensions_get_scaled_by_height (Dimensions *self,
                                      gint scale,
                                      Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self,
                                  Dimensions* scaled,
                                  gdouble* width_ratio,
                                  gdouble* height_ratio);
gdouble dimensions_get_aspect_ratio (Dimensions *self);
void dimensions_get_scaled_proportional (Dimensions *self,
                                         Dimensions* viewport,
                                         Dimensions* result);
void dimensions_get_scaled_to_fill_viewport (Dimensions *self,
                                             Dimensions* viewport,
                                             Dimensions* result);
void dimensions_get_scaled_rectangle (Dimensions *self,
                                      Dimensions* scaled,
                                      GdkRectangle* rect,
                                      GdkRectangle* result);
void dimensions_get_scaled_similar (Dimensions *self,
                                    Dimensions* original,
                                    Dimensions* scaled,
                                    Dimensions* result);
void dimensions_get_scaled_by_constraint (Dimensions *self,
                                          gint scale,
                                          ScaleConstraint constraint,
                                          Dimensions* result);
GType scaling_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
#define SCALING_NO_SCALE 0
static void scaling_init (Scaling *self,
                   ScaleConstraint constraint,
                   gint scale,
                   Dimensions* viewport,
                   gboolean scale_up);
void scaling_for_original (Scaling* result);
void scaling_for_screen (GtkWindow* window,
                         gboolean scale_up,
                         Scaling* result);
void scaling_for_viewport (Dimensions* viewport,
                           gboolean scale_up,
                           Scaling* result);
void scaling_get_screen_dimensions (GtkWindow* window,
                                    Dimensions* result);
void scaling_for_best_fit (gint pixels,
                           gboolean scale_up,
                           Scaling* result);
void scaling_for_widget (GtkWidget* widget,
                         gboolean scale_up,
                         Scaling* result);
void scaling_to_fill_viewport (Dimensions* viewport,
                               Scaling* result);
void scaling_to_fill_screen (GtkWindow* window,
                             Scaling* result);
void scaling_for_constraint (ScaleConstraint constraint,
                             gint scale,
                             gboolean scale_up,
                             Scaling* result);
static gint scaling_scale_to_pixels (Scaling *self);
gboolean scaling_is_unscaled (Scaling *self);
gboolean scaling_is_best_fit (Scaling *self,
                              Dimensions* original,
                              gint* pixels);
gboolean scaling_is_best_fit_dimensions (Scaling *self,
                                         Dimensions* original,
                                         Dimensions* scaled);
gboolean scaling_is_for_viewport (Scaling *self,
                                  Dimensions* original,
                                  Dimensions* scaled);
gboolean scaling_is_fill_viewport (Scaling *self,
                                   Dimensions* original,
                                   Dimensions* scaled);
void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf,
                         gint scale,
                         GdkInterpType interp,
                         gboolean scale_up);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf,
                          Dimensions* resized,
                          GdkInterpType interp);
gchar* scaling_to_string (Scaling *self);
gboolean scaling_equals (Scaling *self,
                         Scaling* scaling);
GType zoom_state_get_type (void) G_GNUC_CONST;
ZoomState* zoom_state_dup (const ZoomState* self);
void zoom_state_free (ZoomState* self);
void zoom_state_init (ZoomState *self,
                      Dimensions* content_dimensions,
                      Dimensions* viewport_dimensions,
                      gdouble slider_val,
                      GdkPoint* viewport_center);
static void zoom_state_compute_zoom_factors (ZoomState *self);
static void zoom_state_center_viewport (ZoomState *self);
static void zoom_state_clamp_viewport_center (ZoomState *self);
void zoom_state_init_rescale (ZoomState *self,
                              ZoomState* existing,
                              gdouble new_slider_val);
void zoom_state_init_rescale_to_isomorphic (ZoomState *self,
                                            ZoomState* existing);
void zoom_state_init_pan (ZoomState *self,
                          ZoomState* existing,
                          GdkPoint* new_viewport_center);
gint zoom_state_get_zoomed_width (ZoomState *self);
gint zoom_state_get_zoomed_height (ZoomState *self);
gdouble zoom_state_get_interpolation_factor (ZoomState *self);
void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self,
                                                   GdkRectangle* result);
void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self,
                                                  GdkRectangle* result);
void zoom_state_get_viewing_rectangle_projection (ZoomState *self,
                                                  GdkPixbuf* for_pixbuf,
                                                  GdkRectangle* result);
gdouble zoom_state_get_zoom_factor (ZoomState *self);
void zoom_state_get_viewport_center (ZoomState *self,
                                     GdkPoint* result);
gchar* zoom_state_to_string (ZoomState *self);
gboolean zoom_state_is_min (ZoomState *self);
gboolean zoom_state_is_default (ZoomState *self);
gboolean zoom_state_is_isomorphic (ZoomState *self);
gboolean zoom_state_is_max (ZoomState *self);
gboolean zoom_state_equals (ZoomState *self,
                            ZoomState* other);

gchar*
scale_constraint_to_string (ScaleConstraint self)
{
	gchar* result = NULL;
#line 15 "../src/Dimensions.vala"
	switch (self) {
#line 15 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 253 "Dimensions.c"
		{
			gchar* _tmp0_;
#line 17 "../src/Dimensions.vala"
			_tmp0_ = g_strdup (_ ("Original size"));
#line 17 "../src/Dimensions.vala"
			result = _tmp0_;
#line 17 "../src/Dimensions.vala"
			return result;
#line 262 "Dimensions.c"
		}
#line 15 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 266 "Dimensions.c"
		{
			gchar* _tmp1_;
#line 20 "../src/Dimensions.vala"
			_tmp1_ = g_strdup (_ ("Longest edge"));
#line 20 "../src/Dimensions.vala"
			result = _tmp1_;
#line 20 "../src/Dimensions.vala"
			return result;
#line 275 "Dimensions.c"
		}
#line 15 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 279 "Dimensions.c"
		{
			gchar* _tmp2_;
#line 23 "../src/Dimensions.vala"
			_tmp2_ = g_strdup (_ ("Width"));
#line 23 "../src/Dimensions.vala"
			result = _tmp2_;
#line 23 "../src/Dimensions.vala"
			return result;
#line 288 "Dimensions.c"
		}
#line 15 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 292 "Dimensions.c"
		{
			gchar* _tmp3_;
#line 26 "../src/Dimensions.vala"
			_tmp3_ = g_strdup (_ ("Height"));
#line 26 "../src/Dimensions.vala"
			result = _tmp3_;
#line 26 "../src/Dimensions.vala"
			return result;
#line 301 "Dimensions.c"
		}
#line 15 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 305 "Dimensions.c"
		{
			gchar* _tmp4_;
#line 30 "../src/Dimensions.vala"
			_tmp4_ = g_strdup ("Fill Viewport");
#line 30 "../src/Dimensions.vala"
			result = _tmp4_;
#line 30 "../src/Dimensions.vala"
			return result;
#line 314 "Dimensions.c"
		}
		default:
#line 15 "../src/Dimensions.vala"
		break;
#line 319 "Dimensions.c"
	}
#line 33 "../src/Dimensions.vala"
	g_warn_if_reached ();
#line 35 "../src/Dimensions.vala"
	result = NULL;
#line 35 "../src/Dimensions.vala"
	return result;
#line 327 "Dimensions.c"
}

GType
scale_constraint_get_type (void)
{
	static volatile gsize scale_constraint_type_id__volatile = 0;
	if (g_once_init_enter (&scale_constraint_type_id__volatile)) {
		static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
		GType scale_constraint_type_id;
		scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
		g_once_init_leave (&scale_constraint_type_id__volatile, scale_constraint_type_id);
	}
	return scale_constraint_type_id__volatile;
}

void
dimensions_init (Dimensions *self,
                 gint width,
                 gint height)
{
	gboolean _tmp0_ = FALSE;
#line 43 "../src/Dimensions.vala"
	memset (self, 0, sizeof (Dimensions));
#line 44 "../src/Dimensions.vala"
	if (width < 0) {
#line 44 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 355 "Dimensions.c"
	} else {
#line 44 "../src/Dimensions.vala"
		_tmp0_ = height < 0;
#line 359 "Dimensions.c"
	}
#line 44 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 45 "../src/Dimensions.vala"
		g_warning ("Dimensions.vala:45: Tried to construct a Dimensions object with negati" \
"ve width or height - forcing sensible default values.");
#line 365 "Dimensions.c"
	}
#line 47 "../src/Dimensions.vala"
	(*self).width = CLAMP (width, 0, width);
#line 48 "../src/Dimensions.vala"
	(*self).height = CLAMP (height, 0, height);
#line 371 "Dimensions.c"
}

void
dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                       Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 51 "../src/Dimensions.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 52 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, gdk_pixbuf_get_width (pixbuf), gdk_pixbuf_get_height (pixbuf));
#line 52 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 52 "../src/Dimensions.vala"
	return;
#line 387 "Dimensions.c"
}

void
dimensions_for_allocation (GtkAllocation* allocation,
                           Dimensions* result)
{
	GtkAllocation _tmp0_;
	GtkAllocation _tmp1_;
	Dimensions _tmp2_ = {0};
#line 55 "../src/Dimensions.vala"
	g_return_if_fail (allocation != NULL);
#line 56 "../src/Dimensions.vala"
	_tmp0_ = *allocation;
#line 56 "../src/Dimensions.vala"
	_tmp1_ = *allocation;
#line 56 "../src/Dimensions.vala"
	dimensions_init (&_tmp2_, _tmp0_.width, _tmp1_.height);
#line 56 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 56 "../src/Dimensions.vala"
	return;
#line 409 "Dimensions.c"
}

void
dimensions_for_widget_allocation (GtkWidget* widget,
                                  Dimensions* result)
{
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
	Dimensions _tmp3_ = {0};
#line 59 "../src/Dimensions.vala"
	g_return_if_fail (GTK_IS_WIDGET (widget));
#line 61 "../src/Dimensions.vala"
	gtk_widget_get_allocation (widget, &_tmp0_);
#line 61 "../src/Dimensions.vala"
	allocation = _tmp0_;
#line 63 "../src/Dimensions.vala"
	_tmp1_ = allocation;
#line 63 "../src/Dimensions.vala"
	_tmp2_ = allocation;
#line 63 "../src/Dimensions.vala"
	dimensions_init (&_tmp3_, _tmp1_.width, _tmp2_.height);
#line 63 "../src/Dimensions.vala"
	*result = _tmp3_;
#line 63 "../src/Dimensions.vala"
	return;
#line 437 "Dimensions.c"
}

void
dimensions_for_rectangle (GdkRectangle* rect,
                          Dimensions* result)
{
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	Dimensions _tmp2_ = {0};
#line 66 "../src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 67 "../src/Dimensions.vala"
	_tmp0_ = *rect;
#line 67 "../src/Dimensions.vala"
	_tmp1_ = *rect;
#line 67 "../src/Dimensions.vala"
	dimensions_init (&_tmp2_, _tmp0_.width, _tmp1_.height);
#line 67 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 67 "../src/Dimensions.vala"
	return;
#line 459 "Dimensions.c"
}

gboolean
dimensions_has_area (Dimensions *self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 71 "../src/Dimensions.vala"
	if ((*self).width > 0) {
#line 71 "../src/Dimensions.vala"
		_tmp0_ = (*self).height > 0;
#line 471 "Dimensions.c"
	} else {
#line 71 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 475 "Dimensions.c"
	}
#line 71 "../src/Dimensions.vala"
	result = _tmp0_;
#line 71 "../src/Dimensions.vala"
	return result;
#line 481 "Dimensions.c"
}

void
dimensions_floor (Dimensions *self,
                  Dimensions* min,
                  Dimensions* result)
{
	gint _tmp0_ = 0;
	Dimensions _tmp1_;
	gint _tmp3_ = 0;
	Dimensions _tmp4_;
	Dimensions _tmp6_ = {0};
#line 74 "../src/Dimensions.vala"
	g_return_if_fail (min != NULL);
#line 75 "../src/Dimensions.vala"
	_tmp1_ = *min;
#line 75 "../src/Dimensions.vala"
	if ((*self).width > _tmp1_.width) {
#line 75 "../src/Dimensions.vala"
		_tmp0_ = (*self).width;
#line 502 "Dimensions.c"
	} else {
		Dimensions _tmp2_;
#line 75 "../src/Dimensions.vala"
		_tmp2_ = *min;
#line 75 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_.width;
#line 509 "Dimensions.c"
	}
#line 76 "../src/Dimensions.vala"
	_tmp4_ = *min;
#line 76 "../src/Dimensions.vala"
	if ((*self).height > _tmp4_.height) {
#line 76 "../src/Dimensions.vala"
		_tmp3_ = (*self).height;
#line 517 "Dimensions.c"
	} else {
		Dimensions _tmp5_;
#line 76 "../src/Dimensions.vala"
		_tmp5_ = *min;
#line 76 "../src/Dimensions.vala"
		_tmp3_ = _tmp5_.height;
#line 524 "Dimensions.c"
	}
#line 75 "../src/Dimensions.vala"
	dimensions_init (&_tmp6_, _tmp0_, _tmp3_);
#line 75 "../src/Dimensions.vala"
	*result = _tmp6_;
#line 75 "../src/Dimensions.vala"
	return;
#line 532 "Dimensions.c"
}

gchar*
dimensions_to_string (Dimensions *self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 80 "../src/Dimensions.vala"
	_tmp0_ = g_strdup_printf ("%dx%d", (*self).width, (*self).height);
#line 80 "../src/Dimensions.vala"
	result = _tmp0_;
#line 80 "../src/Dimensions.vala"
	return result;
#line 546 "Dimensions.c"
}

gboolean
dimensions_equals (Dimensions *self,
                   Dimensions* dim)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
#line 83 "../src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 84 "../src/Dimensions.vala"
	_tmp1_ = *dim;
#line 84 "../src/Dimensions.vala"
	if ((*self).width == _tmp1_.width) {
#line 562 "Dimensions.c"
		Dimensions _tmp2_;
#line 84 "../src/Dimensions.vala"
		_tmp2_ = *dim;
#line 84 "../src/Dimensions.vala"
		_tmp0_ = (*self).height == _tmp2_.height;
#line 568 "Dimensions.c"
	} else {
#line 84 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 572 "Dimensions.c"
	}
#line 84 "../src/Dimensions.vala"
	result = _tmp0_;
#line 84 "../src/Dimensions.vala"
	return result;
#line 578 "Dimensions.c"
}

gboolean
dimensions_approx_equals (Dimensions *self,
                          Dimensions* dim,
                          gint fudge)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
#line 88 "../src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 89 "../src/Dimensions.vala"
	_tmp1_ = *dim;
#line 89 "../src/Dimensions.vala"
	if (abs ((*self).width - _tmp1_.width) <= fudge) {
#line 595 "Dimensions.c"
		Dimensions _tmp2_;
#line 89 "../src/Dimensions.vala"
		_tmp2_ = *dim;
#line 89 "../src/Dimensions.vala"
		_tmp0_ = abs ((*self).height - _tmp2_.height) <= fudge;
#line 601 "Dimensions.c"
	} else {
#line 89 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 605 "Dimensions.c"
	}
#line 89 "../src/Dimensions.vala"
	result = _tmp0_;
#line 89 "../src/Dimensions.vala"
	return result;
#line 611 "Dimensions.c"
}

gboolean
dimensions_approx_scaled (Dimensions *self,
                          gint scale,
                          gint fudge)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 93 "../src/Dimensions.vala"
	if ((*self).width <= (scale + fudge)) {
#line 93 "../src/Dimensions.vala"
		_tmp0_ = (*self).height <= (scale + fudge);
#line 625 "Dimensions.c"
	} else {
#line 93 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 629 "Dimensions.c"
	}
#line 93 "../src/Dimensions.vala"
	result = _tmp0_;
#line 93 "../src/Dimensions.vala"
	return result;
#line 635 "Dimensions.c"
}

gint
dimensions_major_axis (Dimensions *self)
{
	gint result = 0;
#line 97 "../src/Dimensions.vala"
	result = MAX ((*self).width, (*self).height);
#line 97 "../src/Dimensions.vala"
	return result;
#line 646 "Dimensions.c"
}

gint
dimensions_minor_axis (Dimensions *self)
{
	gint result = 0;
#line 101 "../src/Dimensions.vala"
	result = MIN ((*self).width, (*self).height);
#line 101 "../src/Dimensions.vala"
	return result;
#line 657 "Dimensions.c"
}

void
dimensions_with_min (Dimensions *self,
                     gint min_width,
                     gint min_height,
                     Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 105 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, MAX ((*self).width, min_width), MAX ((*self).height, min_height));
#line 105 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 105 "../src/Dimensions.vala"
	return;
#line 673 "Dimensions.c"
}

void
dimensions_with_max (Dimensions *self,
                     gint max_width,
                     gint max_height,
                     Dimensions* result)
{
	Dimensions _tmp0_ = {0};
#line 109 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, MIN ((*self).width, max_width), MIN ((*self).height, max_height));
#line 109 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 109 "../src/Dimensions.vala"
	return;
#line 689 "Dimensions.c"
}

void
dimensions_get_scaled (Dimensions *self,
                       gint scale,
                       gboolean scale_up,
                       Dimensions* result)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 113 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 116 "../src/Dimensions.vala"
	if ((*self).width == scale) {
#line 116 "../src/Dimensions.vala"
		_tmp1_ = (*self).height < scale;
#line 707 "Dimensions.c"
	} else {
#line 116 "../src/Dimensions.vala"
		_tmp1_ = FALSE;
#line 711 "Dimensions.c"
	}
#line 116 "../src/Dimensions.vala"
	if (_tmp1_) {
#line 116 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 717 "Dimensions.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 116 "../src/Dimensions.vala"
		if ((*self).height == scale) {
#line 116 "../src/Dimensions.vala"
			_tmp2_ = (*self).width < scale;
#line 724 "Dimensions.c"
		} else {
#line 116 "../src/Dimensions.vala"
			_tmp2_ = FALSE;
#line 728 "Dimensions.c"
		}
#line 116 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_;
#line 732 "Dimensions.c"
	}
#line 116 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 736 "Dimensions.c"
		Dimensions _tmp3_ = {0};
#line 117 "../src/Dimensions.vala"
		dimensions_init (&_tmp3_, (*self).width, (*self).height);
#line 117 "../src/Dimensions.vala"
		*result = _tmp3_;
#line 117 "../src/Dimensions.vala"
		return;
#line 744 "Dimensions.c"
	}
#line 120 "../src/Dimensions.vala"
	if (!scale_up) {
#line 748 "Dimensions.c"
		gboolean _tmp5_ = FALSE;
#line 120 "../src/Dimensions.vala"
		if ((*self).width < scale) {
#line 120 "../src/Dimensions.vala"
			_tmp5_ = (*self).height < scale;
#line 754 "Dimensions.c"
		} else {
#line 120 "../src/Dimensions.vala"
			_tmp5_ = FALSE;
#line 758 "Dimensions.c"
		}
#line 120 "../src/Dimensions.vala"
		_tmp4_ = _tmp5_;
#line 762 "Dimensions.c"
	} else {
#line 120 "../src/Dimensions.vala"
		_tmp4_ = FALSE;
#line 766 "Dimensions.c"
	}
#line 120 "../src/Dimensions.vala"
	if (_tmp4_) {
#line 770 "Dimensions.c"
		Dimensions _tmp6_ = {0};
#line 121 "../src/Dimensions.vala"
		dimensions_init (&_tmp6_, (*self).width, (*self).height);
#line 121 "../src/Dimensions.vala"
		*result = _tmp6_;
#line 121 "../src/Dimensions.vala"
		return;
#line 778 "Dimensions.c"
	}
#line 123 "../src/Dimensions.vala"
	if (((*self).width - scale) > ((*self).height - scale)) {
#line 782 "Dimensions.c"
		Dimensions _tmp7_ = {0};
#line 124 "../src/Dimensions.vala"
		dimensions_get_scaled_by_width (&(*self), scale, &_tmp7_);
#line 124 "../src/Dimensions.vala"
		*result = _tmp7_;
#line 124 "../src/Dimensions.vala"
		return;
#line 790 "Dimensions.c"
	} else {
		Dimensions _tmp8_ = {0};
#line 126 "../src/Dimensions.vala"
		dimensions_get_scaled_by_height (&(*self), scale, &_tmp8_);
#line 126 "../src/Dimensions.vala"
		*result = _tmp8_;
#line 126 "../src/Dimensions.vala"
		return;
#line 799 "Dimensions.c"
	}
}

void
dimensions_get_scale_ratios (Dimensions *self,
                             Dimensions* scaled,
                             gdouble* width_ratio,
                             gdouble* height_ratio)
{
	gdouble _vala_width_ratio = 0.0;
	gdouble _vala_height_ratio = 0.0;
	Dimensions _tmp0_;
	Dimensions _tmp1_;
#line 129 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 130 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 130 "../src/Dimensions.vala"
	_vala_width_ratio = ((gdouble) _tmp0_.width) / ((gdouble) (*self).width);
#line 131 "../src/Dimensions.vala"
	_tmp1_ = *scaled;
#line 131 "../src/Dimensions.vala"
	_vala_height_ratio = ((gdouble) _tmp1_.height) / ((gdouble) (*self).height);
#line 129 "../src/Dimensions.vala"
	if (width_ratio) {
#line 129 "../src/Dimensions.vala"
		*width_ratio = _vala_width_ratio;
#line 827 "Dimensions.c"
	}
#line 129 "../src/Dimensions.vala"
	if (height_ratio) {
#line 129 "../src/Dimensions.vala"
		*height_ratio = _vala_height_ratio;
#line 833 "Dimensions.c"
	}
}

gdouble
dimensions_get_aspect_ratio (Dimensions *self)
{
	gdouble result = 0.0;
#line 135 "../src/Dimensions.vala"
	result = ((gdouble) (*self).width) / (*self).height;
#line 135 "../src/Dimensions.vala"
	return result;
#line 845 "Dimensions.c"
}

void
dimensions_get_scaled_proportional (Dimensions *self,
                                    Dimensions* viewport,
                                    Dimensions* result)
{
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	Dimensions scaled = {0};
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_;
	Dimensions _tmp9_;
	Dimensions _tmp10_;
	Dimensions _tmp11_;
#line 138 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 140 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 140 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 140 "../src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 140 "../src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 143 "../src/Dimensions.vala"
	if (width_ratio < height_ratio) {
#line 880 "Dimensions.c"
		Dimensions _tmp3_;
#line 144 "../src/Dimensions.vala"
		_tmp3_ = *viewport;
#line 144 "../src/Dimensions.vala"
		scaled_width = (gdouble) _tmp3_.width;
#line 145 "../src/Dimensions.vala"
		scaled_height = ((gdouble) (*self).height) * width_ratio;
#line 888 "Dimensions.c"
	} else {
		Dimensions _tmp4_;
#line 147 "../src/Dimensions.vala"
		scaled_width = ((gdouble) (*self).width) * height_ratio;
#line 148 "../src/Dimensions.vala"
		_tmp4_ = *viewport;
#line 148 "../src/Dimensions.vala"
		scaled_height = (gdouble) _tmp4_.height;
#line 897 "Dimensions.c"
	}
#line 151 "../src/Dimensions.vala"
	dimensions_init (&_tmp5_, (gint) round (scaled_width), (gint) round (scaled_height));
#line 151 "../src/Dimensions.vala"
	dimensions_init (&_tmp6_, 1, 1);
#line 151 "../src/Dimensions.vala"
	dimensions_floor (&_tmp5_, &_tmp6_, &_tmp7_);
#line 151 "../src/Dimensions.vala"
	scaled = _tmp7_;
#line 153 "../src/Dimensions.vala"
	_tmp8_ = scaled;
#line 153 "../src/Dimensions.vala"
	_tmp9_ = *viewport;
#line 153 "../src/Dimensions.vala"
	_vala_assert (_tmp8_.height <= _tmp9_.height, "scaled.height <= viewport.height");
#line 154 "../src/Dimensions.vala"
	_tmp10_ = scaled;
#line 154 "../src/Dimensions.vala"
	_tmp11_ = *viewport;
#line 154 "../src/Dimensions.vala"
	_vala_assert (_tmp10_.width <= _tmp11_.width, "scaled.width <= viewport.width");
#line 156 "../src/Dimensions.vala"
	*result = scaled;
#line 156 "../src/Dimensions.vala"
	return;
#line 923 "Dimensions.c"
}

void
dimensions_get_scaled_to_fill_viewport (Dimensions *self,
                                        Dimensions* viewport,
                                        Dimensions* result)
{
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gboolean _tmp3_ = FALSE;
	Dimensions _tmp4_;
	Dimensions _tmp11_ = {0};
	Dimensions _tmp12_ = {0};
	Dimensions _tmp13_ = {0};
#line 159 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 161 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 161 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 161 "../src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 161 "../src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 164 "../src/Dimensions.vala"
	_tmp4_ = *viewport;
#line 164 "../src/Dimensions.vala"
	if ((*self).width < _tmp4_.width) {
#line 957 "Dimensions.c"
		Dimensions _tmp5_;
#line 164 "../src/Dimensions.vala"
		_tmp5_ = *viewport;
#line 164 "../src/Dimensions.vala"
		_tmp3_ = (*self).height >= _tmp5_.height;
#line 963 "Dimensions.c"
	} else {
#line 164 "../src/Dimensions.vala"
		_tmp3_ = FALSE;
#line 967 "Dimensions.c"
	}
#line 164 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 971 "Dimensions.c"
		Dimensions _tmp6_;
#line 166 "../src/Dimensions.vala"
		_tmp6_ = *viewport;
#line 166 "../src/Dimensions.vala"
		scaled_width = (gdouble) _tmp6_.width;
#line 167 "../src/Dimensions.vala"
		scaled_height = ((gdouble) (*self).height) * width_ratio;
#line 979 "Dimensions.c"
	} else {
		gboolean _tmp7_ = FALSE;
		Dimensions _tmp8_;
#line 168 "../src/Dimensions.vala"
		_tmp8_ = *viewport;
#line 168 "../src/Dimensions.vala"
		if ((*self).width >= _tmp8_.width) {
#line 987 "Dimensions.c"
			Dimensions _tmp9_;
#line 168 "../src/Dimensions.vala"
			_tmp9_ = *viewport;
#line 168 "../src/Dimensions.vala"
			_tmp7_ = (*self).height < _tmp9_.height;
#line 993 "Dimensions.c"
		} else {
#line 168 "../src/Dimensions.vala"
			_tmp7_ = FALSE;
#line 997 "Dimensions.c"
		}
#line 168 "../src/Dimensions.vala"
		if (_tmp7_) {
#line 1001 "Dimensions.c"
			Dimensions _tmp10_;
#line 170 "../src/Dimensions.vala"
			scaled_width = ((gdouble) (*self).width) * height_ratio;
#line 171 "../src/Dimensions.vala"
			_tmp10_ = *viewport;
#line 171 "../src/Dimensions.vala"
			scaled_height = (gdouble) _tmp10_.height;
#line 1009 "Dimensions.c"
		} else {
			gdouble ratio = 0.0;
#line 174 "../src/Dimensions.vala"
			ratio = MAX (width_ratio, height_ratio);
#line 176 "../src/Dimensions.vala"
			scaled_width = ((gdouble) (*self).width) * ratio;
#line 177 "../src/Dimensions.vala"
			scaled_height = ((gdouble) (*self).height) * ratio;
#line 1018 "Dimensions.c"
		}
	}
#line 180 "../src/Dimensions.vala"
	dimensions_init (&_tmp11_, (gint) round (scaled_width), (gint) round (scaled_height));
#line 180 "../src/Dimensions.vala"
	dimensions_init (&_tmp12_, 1, 1);
#line 180 "../src/Dimensions.vala"
	dimensions_floor (&_tmp11_, &_tmp12_, &_tmp13_);
#line 180 "../src/Dimensions.vala"
	*result = _tmp13_;
#line 180 "../src/Dimensions.vala"
	return;
#line 1031 "Dimensions.c"
}

void
dimensions_get_scaled_rectangle (Dimensions *self,
                                 Dimensions* scaled,
                                 GdkRectangle* rect,
                                 GdkRectangle* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	GdkRectangle scaled_rect = {0};
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
#line 183 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 183 "../src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 185 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 185 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 185 "../src/Dimensions.vala"
	x_scale = _tmp1_;
#line 185 "../src/Dimensions.vala"
	y_scale = _tmp2_;
#line 187 "../src/Dimensions.vala"
	memset (&scaled_rect, 0, sizeof (GdkRectangle));
#line 188 "../src/Dimensions.vala"
	_tmp3_ = *rect;
#line 188 "../src/Dimensions.vala"
	scaled_rect.x = (gint) round (((gdouble) _tmp3_.x) * x_scale);
#line 189 "../src/Dimensions.vala"
	_tmp4_ = *rect;
#line 189 "../src/Dimensions.vala"
	scaled_rect.y = (gint) round (((gdouble) _tmp4_.y) * y_scale);
#line 190 "../src/Dimensions.vala"
	_tmp5_ = *rect;
#line 190 "../src/Dimensions.vala"
	scaled_rect.width = (gint) round (((gdouble) _tmp5_.width) * x_scale);
#line 191 "../src/Dimensions.vala"
	_tmp6_ = *rect;
#line 191 "../src/Dimensions.vala"
	scaled_rect.height = (gint) round (((gdouble) _tmp6_.height) * y_scale);
#line 193 "../src/Dimensions.vala"
	_tmp7_ = scaled_rect;
#line 193 "../src/Dimensions.vala"
	if (_tmp7_.width <= 0) {
#line 194 "../src/Dimensions.vala"
		scaled_rect.width = 1;
#line 1088 "Dimensions.c"
	}
#line 196 "../src/Dimensions.vala"
	_tmp8_ = scaled_rect;
#line 196 "../src/Dimensions.vala"
	if (_tmp8_.height <= 0) {
#line 197 "../src/Dimensions.vala"
		scaled_rect.height = 1;
#line 1096 "Dimensions.c"
	}
#line 199 "../src/Dimensions.vala"
	*result = scaled_rect;
#line 199 "../src/Dimensions.vala"
	return;
#line 1102 "Dimensions.c"
}

void
dimensions_get_scaled_similar (Dimensions *self,
                               Dimensions* original,
                               Dimensions* scaled,
                               Dimensions* result)
{
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scale = 0.0;
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
#line 203 "../src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 203 "../src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 205 "../src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 205 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
#line 205 "../src/Dimensions.vala"
	x_scale = _tmp1_;
#line 205 "../src/Dimensions.vala"
	y_scale = _tmp2_;
#line 207 "../src/Dimensions.vala"
	scale = MIN (x_scale, y_scale);
#line 209 "../src/Dimensions.vala"
	dimensions_init (&_tmp3_, (gint) round (((gdouble) (*self).width) * scale), (gint) round (((gdouble) (*self).height) * scale));
#line 209 "../src/Dimensions.vala"
	dimensions_init (&_tmp4_, 1, 1);
#line 209 "../src/Dimensions.vala"
	dimensions_floor (&_tmp3_, &_tmp4_, &_tmp5_);
#line 209 "../src/Dimensions.vala"
	*result = _tmp5_;
#line 209 "../src/Dimensions.vala"
	return;
#line 1144 "Dimensions.c"
}

void
dimensions_get_scaled_by_width (Dimensions *self,
                                gint scale,
                                Dimensions* result)
{
	gdouble ratio = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 214 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 216 "../src/Dimensions.vala"
	ratio = ((gdouble) scale) / ((gdouble) (*self).width);
#line 218 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, scale, (gint) round (((gdouble) (*self).height) * ratio));
#line 218 "../src/Dimensions.vala"
	dimensions_init (&_tmp1_, 1, 1);
#line 218 "../src/Dimensions.vala"
	dimensions_floor (&_tmp0_, &_tmp1_, &_tmp2_);
#line 218 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 218 "../src/Dimensions.vala"
	return;
#line 1170 "Dimensions.c"
}

void
dimensions_get_scaled_by_height (Dimensions *self,
                                 gint scale,
                                 Dimensions* result)
{
	gdouble ratio = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 222 "../src/Dimensions.vala"
	_vala_assert (scale > 0, "scale > 0");
#line 224 "../src/Dimensions.vala"
	ratio = ((gdouble) scale) / ((gdouble) (*self).height);
#line 226 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, (gint) round (((gdouble) (*self).width) * ratio), scale);
#line 226 "../src/Dimensions.vala"
	dimensions_init (&_tmp1_, 1, 1);
#line 226 "../src/Dimensions.vala"
	dimensions_floor (&_tmp0_, &_tmp1_, &_tmp2_);
#line 226 "../src/Dimensions.vala"
	*result = _tmp2_;
#line 226 "../src/Dimensions.vala"
	return;
#line 1196 "Dimensions.c"
}

void
dimensions_get_scaled_by_constraint (Dimensions *self,
                                     gint scale,
                                     ScaleConstraint constraint,
                                     Dimensions* result)
{
#line 230 "../src/Dimensions.vala"
	switch (constraint) {
#line 230 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 1209 "Dimensions.c"
		{
			Dimensions _tmp0_ = {0};
#line 232 "../src/Dimensions.vala"
			dimensions_init (&_tmp0_, (*self).width, (*self).height);
#line 232 "../src/Dimensions.vala"
			*result = _tmp0_;
#line 232 "../src/Dimensions.vala"
			return;
#line 1218 "Dimensions.c"
		}
#line 230 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 1222 "Dimensions.c"
		{
			Dimensions _tmp1_ = {0};
#line 235 "../src/Dimensions.vala"
			if ((*self).width >= (*self).height) {
#line 1227 "Dimensions.c"
				Dimensions _tmp2_ = {0};
#line 235 "../src/Dimensions.vala"
				dimensions_get_scaled_by_width (&(*self), scale, &_tmp2_);
#line 235 "../src/Dimensions.vala"
				_tmp1_ = _tmp2_;
#line 1233 "Dimensions.c"
			} else {
				Dimensions _tmp3_ = {0};
#line 235 "../src/Dimensions.vala"
				dimensions_get_scaled_by_height (&(*self), scale, &_tmp3_);
#line 235 "../src/Dimensions.vala"
				_tmp1_ = _tmp3_;
#line 1240 "Dimensions.c"
			}
#line 235 "../src/Dimensions.vala"
			*result = _tmp1_;
#line 235 "../src/Dimensions.vala"
			return;
#line 1246 "Dimensions.c"
		}
#line 230 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 1250 "Dimensions.c"
		{
			Dimensions _tmp4_ = {0};
#line 238 "../src/Dimensions.vala"
			dimensions_get_scaled_by_width (&(*self), scale, &_tmp4_);
#line 238 "../src/Dimensions.vala"
			*result = _tmp4_;
#line 238 "../src/Dimensions.vala"
			return;
#line 1259 "Dimensions.c"
		}
#line 230 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 1263 "Dimensions.c"
		{
			Dimensions _tmp5_ = {0};
#line 241 "../src/Dimensions.vala"
			dimensions_get_scaled_by_height (&(*self), scale, &_tmp5_);
#line 241 "../src/Dimensions.vala"
			*result = _tmp5_;
#line 241 "../src/Dimensions.vala"
			return;
#line 1272 "Dimensions.c"
		}
		default:
		{
#line 244 "../src/Dimensions.vala"
			g_error ("Dimensions.vala:244: Bad constraint: %d", (gint) constraint);
#line 1278 "Dimensions.c"
		}
	}
}

Dimensions*
dimensions_dup (const Dimensions* self)
{
	Dimensions* dup;
#line 39 "../src/Dimensions.vala"
	dup = g_new0 (Dimensions, 1);
#line 39 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (Dimensions));
#line 39 "../src/Dimensions.vala"
	return dup;
#line 1293 "Dimensions.c"
}

void
dimensions_free (Dimensions* self)
{
#line 39 "../src/Dimensions.vala"
	g_free (self);
#line 1301 "Dimensions.c"
}

GType
dimensions_get_type (void)
{
	static volatile gsize dimensions_type_id__volatile = 0;
	if (g_once_init_enter (&dimensions_type_id__volatile)) {
		GType dimensions_type_id;
		dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
		g_once_init_leave (&dimensions_type_id__volatile, dimensions_type_id);
	}
	return dimensions_type_id__volatile;
}

static void
scaling_init (Scaling *self,
              ScaleConstraint constraint,
              gint scale,
              Dimensions* viewport,
              gboolean scale_up)
{
	Dimensions _tmp0_;
#line 257 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 257 "../src/Dimensions.vala"
	memset (self, 0, sizeof (Scaling));
#line 258 "../src/Dimensions.vala"
	(*self).constraint = constraint;
#line 259 "../src/Dimensions.vala"
	(*self).scale = scale;
#line 260 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 260 "../src/Dimensions.vala"
	(*self).viewport = _tmp0_;
#line 261 "../src/Dimensions.vala"
	(*self).scale_up = scale_up;
#line 1338 "Dimensions.c"
}

void
scaling_for_original (Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 265 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 265 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, &_tmp0_, FALSE);
#line 265 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 265 "../src/Dimensions.vala"
	return;
#line 1354 "Dimensions.c"
}

void
scaling_for_screen (GtkWindow* window,
                    gboolean scale_up,
                    Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 268 "../src/Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 269 "../src/Dimensions.vala"
	scaling_get_screen_dimensions (window, &_tmp0_);
#line 269 "../src/Dimensions.vala"
	scaling_for_viewport (&_tmp0_, scale_up, &_tmp1_);
#line 269 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 269 "../src/Dimensions.vala"
	return;
#line 1374 "Dimensions.c"
}

void
scaling_for_best_fit (gint pixels,
                      gboolean scale_up,
                      Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 273 "../src/Dimensions.vala"
	_vala_assert (pixels > 0, "pixels > 0");
#line 275 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 275 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, pixels, &_tmp0_, scale_up);
#line 275 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 275 "../src/Dimensions.vala"
	return;
#line 1394 "Dimensions.c"
}

void
scaling_for_viewport (Dimensions* viewport,
                      gboolean scale_up,
                      Scaling* result)
{
	Dimensions _tmp0_;
	Scaling _tmp1_ = {0};
#line 278 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 279 "../src/Dimensions.vala"
	_vala_assert (dimensions_has_area (viewport), "viewport.has_area()");
#line 281 "../src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 281 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp0_, scale_up);
#line 281 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 281 "../src/Dimensions.vala"
	return;
#line 1416 "Dimensions.c"
}

void
scaling_for_widget (GtkWidget* widget,
                    gboolean scale_up,
                    Scaling* result)
{
	Dimensions viewport = {0};
	Dimensions _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp2_;
	Dimensions _tmp5_;
	Scaling _tmp6_ = {0};
#line 284 "../src/Dimensions.vala"
	g_return_if_fail (GTK_IS_WIDGET (widget));
#line 285 "../src/Dimensions.vala"
	dimensions_for_widget_allocation (widget, &_tmp0_);
#line 285 "../src/Dimensions.vala"
	viewport = _tmp0_;
#line 295 "../src/Dimensions.vala"
	_tmp2_ = viewport;
#line 295 "../src/Dimensions.vala"
	if (_tmp2_.width <= 1) {
#line 295 "../src/Dimensions.vala"
		_tmp1_ = TRUE;
#line 1442 "Dimensions.c"
	} else {
		Dimensions _tmp3_;
#line 295 "../src/Dimensions.vala"
		_tmp3_ = viewport;
#line 295 "../src/Dimensions.vala"
		_tmp1_ = _tmp3_.height <= 1;
#line 1449 "Dimensions.c"
	}
#line 295 "../src/Dimensions.vala"
	if (_tmp1_) {
#line 1453 "Dimensions.c"
		Scaling _tmp4_ = {0};
#line 296 "../src/Dimensions.vala"
		scaling_for_original (&_tmp4_);
#line 296 "../src/Dimensions.vala"
		*result = _tmp4_;
#line 296 "../src/Dimensions.vala"
		return;
#line 1461 "Dimensions.c"
	}
#line 298 "../src/Dimensions.vala"
	_tmp5_ = viewport;
#line 298 "../src/Dimensions.vala"
	scaling_init (&_tmp6_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp5_, scale_up);
#line 298 "../src/Dimensions.vala"
	*result = _tmp6_;
#line 298 "../src/Dimensions.vala"
	return;
#line 1471 "Dimensions.c"
}

void
scaling_to_fill_viewport (Dimensions* viewport,
                          Scaling* result)
{
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	Dimensions _tmp4_;
	Scaling _tmp5_ = {0};
#line 301 "../src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 304 "../src/Dimensions.vala"
	_tmp1_ = *viewport;
#line 304 "../src/Dimensions.vala"
	if (_tmp1_.width <= 1) {
#line 304 "../src/Dimensions.vala"
		_tmp0_ = TRUE;
#line 1490 "Dimensions.c"
	} else {
		Dimensions _tmp2_;
#line 304 "../src/Dimensions.vala"
		_tmp2_ = *viewport;
#line 304 "../src/Dimensions.vala"
		_tmp0_ = _tmp2_.height <= 1;
#line 1497 "Dimensions.c"
	}
#line 304 "../src/Dimensions.vala"
	if (_tmp0_) {
#line 1501 "Dimensions.c"
		Scaling _tmp3_ = {0};
#line 305 "../src/Dimensions.vala"
		scaling_for_original (&_tmp3_);
#line 305 "../src/Dimensions.vala"
		*result = _tmp3_;
#line 305 "../src/Dimensions.vala"
		return;
#line 1509 "Dimensions.c"
	}
#line 307 "../src/Dimensions.vala"
	_tmp4_ = *viewport;
#line 307 "../src/Dimensions.vala"
	scaling_init (&_tmp5_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, &_tmp4_, TRUE);
#line 307 "../src/Dimensions.vala"
	*result = _tmp5_;
#line 307 "../src/Dimensions.vala"
	return;
#line 1519 "Dimensions.c"
}

void
scaling_to_fill_screen (GtkWindow* window,
                        Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 310 "../src/Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 311 "../src/Dimensions.vala"
	scaling_get_screen_dimensions (window, &_tmp0_);
#line 311 "../src/Dimensions.vala"
	scaling_to_fill_viewport (&_tmp0_, &_tmp1_);
#line 311 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 311 "../src/Dimensions.vala"
	return;
#line 1538 "Dimensions.c"
}

void
scaling_for_constraint (ScaleConstraint constraint,
                        gint scale,
                        gboolean scale_up,
                        Scaling* result)
{
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 315 "../src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 315 "../src/Dimensions.vala"
	scaling_init (&_tmp1_, constraint, scale, &_tmp0_, scale_up);
#line 315 "../src/Dimensions.vala"
	*result = _tmp1_;
#line 315 "../src/Dimensions.vala"
	return;
#line 1557 "Dimensions.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 319 "../src/Dimensions.vala"
	return self ? g_object_ref (self) : NULL;
#line 1565 "Dimensions.c"
}

void
scaling_get_screen_dimensions (GtkWindow* window,
                               Dimensions* result)
{
	GdkDisplay* display = NULL;
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkMonitor* monitor = NULL;
	GdkWindow* _tmp3_;
	GdkMonitor* _tmp4_;
	GdkMonitor* _tmp5_;
	GdkRectangle geom = {0};
	GdkRectangle _tmp6_ = {0};
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	Dimensions _tmp9_ = {0};
#line 318 "../src/Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 319 "../src/Dimensions.vala"
	_tmp0_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (window, gtk_widget_get_type (), GtkWidget));
#line 319 "../src/Dimensions.vala"
	_tmp1_ = gdk_window_get_display (_tmp0_);
#line 319 "../src/Dimensions.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 319 "../src/Dimensions.vala"
	display = _tmp2_;
#line 320 "../src/Dimensions.vala"
	_tmp3_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (window, gtk_widget_get_type (), GtkWidget));
#line 320 "../src/Dimensions.vala"
	_tmp4_ = gdk_display_get_monitor_at_window (display, _tmp3_);
#line 320 "../src/Dimensions.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 320 "../src/Dimensions.vala"
	monitor = _tmp5_;
#line 321 "../src/Dimensions.vala"
	gdk_monitor_get_geometry (monitor, &_tmp6_);
#line 321 "../src/Dimensions.vala"
	geom = _tmp6_;
#line 323 "../src/Dimensions.vala"
	_tmp7_ = geom;
#line 323 "../src/Dimensions.vala"
	_tmp8_ = geom;
#line 323 "../src/Dimensions.vala"
	dimensions_init (&_tmp9_, _tmp7_.width, _tmp8_.height);
#line 323 "../src/Dimensions.vala"
	*result = _tmp9_;
#line 323 "../src/Dimensions.vala"
	_g_object_unref0 (monitor);
#line 323 "../src/Dimensions.vala"
	_g_object_unref0 (display);
#line 323 "../src/Dimensions.vala"
	return;
#line 1621 "Dimensions.c"
}

static gint
scaling_scale_to_pixels (Scaling *self)
{
	gint result = 0;
	gint _tmp0_ = 0;
#line 327 "../src/Dimensions.vala"
	if ((*self).scale >= 0) {
#line 327 "../src/Dimensions.vala"
		_tmp0_ = (*self).scale;
#line 1633 "Dimensions.c"
	} else {
#line 327 "../src/Dimensions.vala"
		_tmp0_ = 0;
#line 1637 "Dimensions.c"
	}
#line 327 "../src/Dimensions.vala"
	result = _tmp0_;
#line 327 "../src/Dimensions.vala"
	return result;
#line 1643 "Dimensions.c"
}

gboolean
scaling_is_unscaled (Scaling *self)
{
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
#line 331 "../src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 331 "../src/Dimensions.vala"
	result = _tmp0_ == SCALE_CONSTRAINT_ORIGINAL;
#line 331 "../src/Dimensions.vala"
	return result;
#line 1657 "Dimensions.c"
}

gboolean
scaling_is_best_fit (Scaling *self,
                     Dimensions* original,
                     gint* pixels)
{
	gint _vala_pixels = 0;
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
#line 334 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 335 "../src/Dimensions.vala"
	_vala_pixels = 0;
#line 337 "../src/Dimensions.vala"
	if ((*self).scale == SCALING_NO_SCALE) {
#line 338 "../src/Dimensions.vala"
		result = FALSE;
#line 338 "../src/Dimensions.vala"
		if (pixels) {
#line 338 "../src/Dimensions.vala"
			*pixels = _vala_pixels;
#line 1680 "Dimensions.c"
		}
#line 338 "../src/Dimensions.vala"
		return result;
#line 1684 "Dimensions.c"
	}
#line 340 "../src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 340 "../src/Dimensions.vala"
	switch (_tmp0_) {
#line 340 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 340 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 1694 "Dimensions.c"
		{
#line 343 "../src/Dimensions.vala"
			result = FALSE;
#line 343 "../src/Dimensions.vala"
			if (pixels) {
#line 343 "../src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 1702 "Dimensions.c"
			}
#line 343 "../src/Dimensions.vala"
			return result;
#line 1706 "Dimensions.c"
		}
		default:
		{
#line 346 "../src/Dimensions.vala"
			_vala_pixels = scaling_scale_to_pixels (&(*self));
#line 347 "../src/Dimensions.vala"
			_vala_assert (_vala_pixels > 0, "pixels > 0");
#line 349 "../src/Dimensions.vala"
			result = TRUE;
#line 349 "../src/Dimensions.vala"
			if (pixels) {
#line 349 "../src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 1720 "Dimensions.c"
			}
#line 349 "../src/Dimensions.vala"
			return result;
#line 1724 "Dimensions.c"
		}
	}
#line 334 "../src/Dimensions.vala"
	if (pixels) {
#line 334 "../src/Dimensions.vala"
		*pixels = _vala_pixels;
#line 1731 "Dimensions.c"
	}
}

gboolean
scaling_is_best_fit_dimensions (Scaling *self,
                                Dimensions* original,
                                Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
#line 353 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 354 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 356 "../src/Dimensions.vala"
	if ((*self).scale == SCALING_NO_SCALE) {
#line 357 "../src/Dimensions.vala"
		result = FALSE;
#line 357 "../src/Dimensions.vala"
		if (scaled) {
#line 357 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 1755 "Dimensions.c"
		}
#line 357 "../src/Dimensions.vala"
		return result;
#line 1759 "Dimensions.c"
	}
#line 359 "../src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 359 "../src/Dimensions.vala"
	switch (_tmp0_) {
#line 359 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 359 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 1769 "Dimensions.c"
		{
#line 362 "../src/Dimensions.vala"
			result = FALSE;
#line 362 "../src/Dimensions.vala"
			if (scaled) {
#line 362 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1777 "Dimensions.c"
			}
#line 362 "../src/Dimensions.vala"
			return result;
#line 1781 "Dimensions.c"
		}
		default:
		{
			gint pixels = 0;
			ScaleConstraint _tmp1_;
			Dimensions _tmp2_ = {0};
#line 365 "../src/Dimensions.vala"
			pixels = scaling_scale_to_pixels (&(*self));
#line 366 "../src/Dimensions.vala"
			_vala_assert (pixels > 0, "pixels > 0");
#line 368 "../src/Dimensions.vala"
			_tmp1_ = (*self).constraint;
#line 368 "../src/Dimensions.vala"
			dimensions_get_scaled_by_constraint (original, pixels, _tmp1_, &_tmp2_);
#line 368 "../src/Dimensions.vala"
			_vala_scaled = _tmp2_;
#line 370 "../src/Dimensions.vala"
			result = TRUE;
#line 370 "../src/Dimensions.vala"
			if (scaled) {
#line 370 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1804 "Dimensions.c"
			}
#line 370 "../src/Dimensions.vala"
			return result;
#line 1808 "Dimensions.c"
		}
	}
#line 353 "../src/Dimensions.vala"
	if (scaled) {
#line 353 "../src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 1815 "Dimensions.c"
	}
}

gboolean
scaling_is_for_viewport (Scaling *self,
                         Dimensions* original,
                         Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
#line 374 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 375 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 377 "../src/Dimensions.vala"
	if ((*self).scale != SCALING_NO_SCALE) {
#line 378 "../src/Dimensions.vala"
		result = FALSE;
#line 378 "../src/Dimensions.vala"
		if (scaled) {
#line 378 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 1839 "Dimensions.c"
		}
#line 378 "../src/Dimensions.vala"
		return result;
#line 1843 "Dimensions.c"
	}
#line 380 "../src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 380 "../src/Dimensions.vala"
	switch (_tmp0_) {
#line 380 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 380 "../src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 1853 "Dimensions.c"
		{
#line 383 "../src/Dimensions.vala"
			result = FALSE;
#line 383 "../src/Dimensions.vala"
			if (scaled) {
#line 383 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1861 "Dimensions.c"
			}
#line 383 "../src/Dimensions.vala"
			return result;
#line 1865 "Dimensions.c"
		}
		default:
		{
			gboolean _tmp1_ = FALSE;
			gboolean _tmp2_ = FALSE;
#line 386 "../src/Dimensions.vala"
			_vala_assert (dimensions_has_area (&(*self).viewport), "viewport.has_area()");
#line 388 "../src/Dimensions.vala"
			if (!(*self).scale_up) {
#line 1875 "Dimensions.c"
				Dimensions _tmp3_;
				Dimensions _tmp4_;
#line 388 "../src/Dimensions.vala"
				_tmp3_ = *original;
#line 388 "../src/Dimensions.vala"
				_tmp4_ = (*self).viewport;
#line 388 "../src/Dimensions.vala"
				_tmp2_ = _tmp3_.width < _tmp4_.width;
#line 1884 "Dimensions.c"
			} else {
#line 388 "../src/Dimensions.vala"
				_tmp2_ = FALSE;
#line 1888 "Dimensions.c"
			}
#line 388 "../src/Dimensions.vala"
			if (_tmp2_) {
#line 1892 "Dimensions.c"
				Dimensions _tmp5_;
				Dimensions _tmp6_;
#line 388 "../src/Dimensions.vala"
				_tmp5_ = *original;
#line 388 "../src/Dimensions.vala"
				_tmp6_ = (*self).viewport;
#line 388 "../src/Dimensions.vala"
				_tmp1_ = _tmp5_.height < _tmp6_.height;
#line 1901 "Dimensions.c"
			} else {
#line 388 "../src/Dimensions.vala"
				_tmp1_ = FALSE;
#line 1905 "Dimensions.c"
			}
#line 388 "../src/Dimensions.vala"
			if (_tmp1_) {
#line 1909 "Dimensions.c"
				Dimensions _tmp7_;
#line 389 "../src/Dimensions.vala"
				_tmp7_ = *original;
#line 389 "../src/Dimensions.vala"
				_vala_scaled = _tmp7_;
#line 1915 "Dimensions.c"
			} else {
				Dimensions _tmp8_;
				Dimensions _tmp9_ = {0};
#line 391 "../src/Dimensions.vala"
				_tmp8_ = (*self).viewport;
#line 391 "../src/Dimensions.vala"
				dimensions_get_scaled_proportional (original, &_tmp8_, &_tmp9_);
#line 391 "../src/Dimensions.vala"
				_vala_scaled = _tmp9_;
#line 1925 "Dimensions.c"
			}
#line 393 "../src/Dimensions.vala"
			result = TRUE;
#line 393 "../src/Dimensions.vala"
			if (scaled) {
#line 393 "../src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 1933 "Dimensions.c"
			}
#line 393 "../src/Dimensions.vala"
			return result;
#line 1937 "Dimensions.c"
		}
	}
#line 374 "../src/Dimensions.vala"
	if (scaled) {
#line 374 "../src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 1944 "Dimensions.c"
	}
}

gboolean
scaling_is_fill_viewport (Scaling *self,
                          Dimensions* original,
                          Dimensions* scaled)
{
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
#line 397 "../src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 398 "../src/Dimensions.vala"
	dimensions_init (&_vala_scaled, 0, 0);
#line 400 "../src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 400 "../src/Dimensions.vala"
	if (_tmp0_ != SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 401 "../src/Dimensions.vala"
		result = FALSE;
#line 401 "../src/Dimensions.vala"
		if (scaled) {
#line 401 "../src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 1972 "Dimensions.c"
		}
#line 401 "../src/Dimensions.vala"
		return result;
#line 1976 "Dimensions.c"
	}
#line 403 "../src/Dimensions.vala"
	_vala_assert (dimensions_has_area (&(*self).viewport), "viewport.has_area()");
#line 404 "../src/Dimensions.vala"
	_tmp1_ = (*self).viewport;
#line 404 "../src/Dimensions.vala"
	dimensions_get_scaled_to_fill_viewport (original, &_tmp1_, &_tmp2_);
#line 404 "../src/Dimensions.vala"
	_vala_scaled = _tmp2_;
#line 406 "../src/Dimensions.vala"
	result = TRUE;
#line 406 "../src/Dimensions.vala"
	if (scaled) {
#line 406 "../src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 1992 "Dimensions.c"
	}
#line 406 "../src/Dimensions.vala"
	return result;
#line 1996 "Dimensions.c"
}

void
scaling_get_scaled_dimensions (Scaling *self,
                               Dimensions* original,
                               Dimensions* result)
{
	Dimensions scaled = {0};
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
	gboolean _tmp3_;
	Dimensions _tmp4_;
	Dimensions _tmp5_ = {0};
	gboolean _tmp6_;
	gboolean is_viewport = FALSE;
	Dimensions _tmp7_;
	Dimensions _tmp8_ = {0};
	gboolean _tmp9_;
#line 409 "../src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 410 "../src/Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 2019 "Dimensions.c"
		Dimensions _tmp0_;
#line 411 "../src/Dimensions.vala"
		_tmp0_ = *original;
#line 411 "../src/Dimensions.vala"
		*result = _tmp0_;
#line 411 "../src/Dimensions.vala"
		return;
#line 2027 "Dimensions.c"
	}
#line 414 "../src/Dimensions.vala"
	_tmp1_ = *original;
#line 414 "../src/Dimensions.vala"
	_tmp3_ = scaling_is_fill_viewport (&(*self), &_tmp1_, &_tmp2_);
#line 414 "../src/Dimensions.vala"
	scaled = _tmp2_;
#line 414 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 415 "../src/Dimensions.vala"
		*result = scaled;
#line 415 "../src/Dimensions.vala"
		return;
#line 2041 "Dimensions.c"
	}
#line 417 "../src/Dimensions.vala"
	_tmp4_ = *original;
#line 417 "../src/Dimensions.vala"
	_tmp6_ = scaling_is_best_fit_dimensions (&(*self), &_tmp4_, &_tmp5_);
#line 417 "../src/Dimensions.vala"
	scaled = _tmp5_;
#line 417 "../src/Dimensions.vala"
	if (_tmp6_) {
#line 418 "../src/Dimensions.vala"
		*result = scaled;
#line 418 "../src/Dimensions.vala"
		return;
#line 2055 "Dimensions.c"
	}
#line 420 "../src/Dimensions.vala"
	_tmp7_ = *original;
#line 420 "../src/Dimensions.vala"
	_tmp9_ = scaling_is_for_viewport (&(*self), &_tmp7_, &_tmp8_);
#line 420 "../src/Dimensions.vala"
	scaled = _tmp8_;
#line 420 "../src/Dimensions.vala"
	is_viewport = _tmp9_;
#line 421 "../src/Dimensions.vala"
	_vala_assert (is_viewport, "is_viewport");
#line 423 "../src/Dimensions.vala"
	*result = scaled;
#line 423 "../src/Dimensions.vala"
	return;
#line 2071 "Dimensions.c"
}

GdkPixbuf*
scaling_perform_on_pixbuf (Scaling *self,
                           GdkPixbuf* pixbuf,
                           GdkInterpType interp,
                           gboolean scale_up)
{
	GdkPixbuf* result = NULL;
	Dimensions pixbuf_dim = {0};
	Dimensions _tmp1_ = {0};
	gint pixels = 0;
	Dimensions _tmp2_;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	Dimensions scaled = {0};
	Dimensions _tmp6_;
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	gboolean is_viewport = FALSE;
	Dimensions _tmp11_;
	Dimensions _tmp12_ = {0};
	gboolean _tmp13_;
	Dimensions _tmp14_;
	GdkPixbuf* _tmp15_;
#line 426 "../src/Dimensions.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 427 "../src/Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 2101 "Dimensions.c"
		GdkPixbuf* _tmp0_;
#line 428 "../src/Dimensions.vala"
		_tmp0_ = _g_object_ref0 (pixbuf);
#line 428 "../src/Dimensions.vala"
		result = _tmp0_;
#line 428 "../src/Dimensions.vala"
		return result;
#line 2109 "Dimensions.c"
	}
#line 430 "../src/Dimensions.vala"
	dimensions_for_pixbuf (pixbuf, &_tmp1_);
#line 430 "../src/Dimensions.vala"
	pixbuf_dim = _tmp1_;
#line 433 "../src/Dimensions.vala"
	_tmp2_ = pixbuf_dim;
#line 433 "../src/Dimensions.vala"
	_tmp4_ = scaling_is_best_fit (&(*self), &_tmp2_, &_tmp3_);
#line 433 "../src/Dimensions.vala"
	pixels = _tmp3_;
#line 433 "../src/Dimensions.vala"
	if (_tmp4_) {
#line 2123 "Dimensions.c"
		GdkPixbuf* _tmp5_;
#line 434 "../src/Dimensions.vala"
		_tmp5_ = scale_pixbuf (pixbuf, pixels, interp, scale_up);
#line 434 "../src/Dimensions.vala"
		result = _tmp5_;
#line 434 "../src/Dimensions.vala"
		return result;
#line 2131 "Dimensions.c"
	}
#line 437 "../src/Dimensions.vala"
	_tmp6_ = pixbuf_dim;
#line 437 "../src/Dimensions.vala"
	_tmp8_ = scaling_is_fill_viewport (&(*self), &_tmp6_, &_tmp7_);
#line 437 "../src/Dimensions.vala"
	scaled = _tmp7_;
#line 437 "../src/Dimensions.vala"
	if (_tmp8_) {
#line 2141 "Dimensions.c"
		Dimensions _tmp9_;
		GdkPixbuf* _tmp10_;
#line 438 "../src/Dimensions.vala"
		_tmp9_ = scaled;
#line 438 "../src/Dimensions.vala"
		_tmp10_ = resize_pixbuf (pixbuf, &_tmp9_, interp);
#line 438 "../src/Dimensions.vala"
		result = _tmp10_;
#line 438 "../src/Dimensions.vala"
		return result;
#line 2152 "Dimensions.c"
	}
#line 440 "../src/Dimensions.vala"
	_tmp11_ = pixbuf_dim;
#line 440 "../src/Dimensions.vala"
	_tmp13_ = scaling_is_for_viewport (&(*self), &_tmp11_, &_tmp12_);
#line 440 "../src/Dimensions.vala"
	scaled = _tmp12_;
#line 440 "../src/Dimensions.vala"
	is_viewport = _tmp13_;
#line 441 "../src/Dimensions.vala"
	_vala_assert (is_viewport, "is_viewport");
#line 443 "../src/Dimensions.vala"
	_tmp14_ = scaled;
#line 443 "../src/Dimensions.vala"
	_tmp15_ = resize_pixbuf (pixbuf, &_tmp14_, interp);
#line 443 "../src/Dimensions.vala"
	result = _tmp15_;
#line 443 "../src/Dimensions.vala"
	return result;
#line 2172 "Dimensions.c"
}

gchar*
scaling_to_string (Scaling *self)
{
	gchar* result = NULL;
	ScaleConstraint _tmp0_;
#line 447 "../src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 447 "../src/Dimensions.vala"
	if (_tmp0_ == SCALE_CONSTRAINT_ORIGINAL) {
#line 2184 "Dimensions.c"
		gchar* _tmp1_;
#line 448 "../src/Dimensions.vala"
		_tmp1_ = g_strdup ("scaling: UNSCALED");
#line 448 "../src/Dimensions.vala"
		result = _tmp1_;
#line 448 "../src/Dimensions.vala"
		return result;
#line 2192 "Dimensions.c"
	} else {
		ScaleConstraint _tmp2_;
#line 449 "../src/Dimensions.vala"
		_tmp2_ = (*self).constraint;
#line 449 "../src/Dimensions.vala"
		if (_tmp2_ == SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 2199 "Dimensions.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 450 "../src/Dimensions.vala"
			_tmp3_ = dimensions_to_string (&(*self).viewport);
#line 450 "../src/Dimensions.vala"
			_tmp4_ = _tmp3_;
#line 450 "../src/Dimensions.vala"
			_tmp5_ = g_strdup_printf ("scaling: fill viewport %s", _tmp4_);
#line 450 "../src/Dimensions.vala"
			_tmp6_ = _tmp5_;
#line 450 "../src/Dimensions.vala"
			_g_free0 (_tmp4_);
#line 450 "../src/Dimensions.vala"
			result = _tmp6_;
#line 450 "../src/Dimensions.vala"
			return result;
#line 2218 "Dimensions.c"
		} else {
#line 451 "../src/Dimensions.vala"
			if ((*self).scale != SCALING_NO_SCALE) {
#line 2222 "Dimensions.c"
				const gchar* _tmp7_ = NULL;
				ScaleConstraint _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
#line 453 "../src/Dimensions.vala"
				if ((*self).scale_up) {
#line 453 "../src/Dimensions.vala"
					_tmp7_ = "scaled up";
#line 2233 "Dimensions.c"
				} else {
#line 453 "../src/Dimensions.vala"
					_tmp7_ = "not scaled up";
#line 2237 "Dimensions.c"
				}
#line 452 "../src/Dimensions.vala"
				_tmp8_ = (*self).constraint;
#line 452 "../src/Dimensions.vala"
				_tmp9_ = scale_constraint_to_string (_tmp8_);
#line 452 "../src/Dimensions.vala"
				_tmp10_ = _tmp9_;
#line 452 "../src/Dimensions.vala"
				_tmp11_ = g_strdup_printf ("scaling: best-fit (%s %d pixels %s)", _tmp10_, scaling_scale_to_pixels (&(*self)), _tmp7_);
#line 452 "../src/Dimensions.vala"
				_tmp12_ = _tmp11_;
#line 452 "../src/Dimensions.vala"
				_g_free0 (_tmp10_);
#line 452 "../src/Dimensions.vala"
				result = _tmp12_;
#line 452 "../src/Dimensions.vala"
				return result;
#line 2255 "Dimensions.c"
			} else {
				const gchar* _tmp13_ = NULL;
				gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
#line 456 "../src/Dimensions.vala"
				if ((*self).scale_up) {
#line 456 "../src/Dimensions.vala"
					_tmp13_ = "scaled up";
#line 2266 "Dimensions.c"
				} else {
#line 456 "../src/Dimensions.vala"
					_tmp13_ = "not scaled up";
#line 2270 "Dimensions.c"
				}
#line 455 "../src/Dimensions.vala"
				_tmp14_ = dimensions_to_string (&(*self).viewport);
#line 455 "../src/Dimensions.vala"
				_tmp15_ = _tmp14_;
#line 455 "../src/Dimensions.vala"
				_tmp16_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp15_, _tmp13_);
#line 455 "../src/Dimensions.vala"
				_tmp17_ = _tmp16_;
#line 455 "../src/Dimensions.vala"
				_g_free0 (_tmp15_);
#line 455 "../src/Dimensions.vala"
				result = _tmp17_;
#line 455 "../src/Dimensions.vala"
				return result;
#line 2286 "Dimensions.c"
			}
		}
	}
}

gboolean
scaling_equals (Scaling *self,
                Scaling* scaling)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ScaleConstraint _tmp2_;
	Scaling _tmp3_;
	ScaleConstraint _tmp4_;
#line 459 "../src/Dimensions.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 460 "../src/Dimensions.vala"
	_tmp2_ = (*self).constraint;
#line 460 "../src/Dimensions.vala"
	_tmp3_ = *scaling;
#line 460 "../src/Dimensions.vala"
	_tmp4_ = _tmp3_.constraint;
#line 460 "../src/Dimensions.vala"
	if (_tmp2_ == _tmp4_) {
#line 2312 "Dimensions.c"
		Scaling _tmp5_;
#line 460 "../src/Dimensions.vala"
		_tmp5_ = *scaling;
#line 460 "../src/Dimensions.vala"
		_tmp1_ = (*self).scale == _tmp5_.scale;
#line 2318 "Dimensions.c"
	} else {
#line 460 "../src/Dimensions.vala"
		_tmp1_ = FALSE;
#line 2322 "Dimensions.c"
	}
#line 460 "../src/Dimensions.vala"
	if (_tmp1_) {
#line 2326 "Dimensions.c"
		Scaling _tmp6_;
		Dimensions _tmp7_;
#line 461 "../src/Dimensions.vala"
		_tmp6_ = *scaling;
#line 461 "../src/Dimensions.vala"
		_tmp7_ = _tmp6_.viewport;
#line 461 "../src/Dimensions.vala"
		_tmp0_ = dimensions_equals (&(*self).viewport, &_tmp7_);
#line 2335 "Dimensions.c"
	} else {
#line 460 "../src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 2339 "Dimensions.c"
	}
#line 460 "../src/Dimensions.vala"
	result = _tmp0_;
#line 460 "../src/Dimensions.vala"
	return result;
#line 2345 "Dimensions.c"
}

Scaling*
scaling_dup (const Scaling* self)
{
	Scaling* dup;
#line 249 "../src/Dimensions.vala"
	dup = g_new0 (Scaling, 1);
#line 249 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (Scaling));
#line 249 "../src/Dimensions.vala"
	return dup;
#line 2358 "Dimensions.c"
}

void
scaling_free (Scaling* self)
{
#line 249 "../src/Dimensions.vala"
	g_free (self);
#line 2366 "Dimensions.c"
}

GType
scaling_get_type (void)
{
	static volatile gsize scaling_type_id__volatile = 0;
	if (g_once_init_enter (&scaling_type_id__volatile)) {
		GType scaling_type_id;
		scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
		g_once_init_leave (&scaling_type_id__volatile, scaling_type_id);
	}
	return scaling_type_id__volatile;
}

void
zoom_state_init (ZoomState *self,
                 Dimensions* content_dimensions,
                 Dimensions* viewport_dimensions,
                 gdouble slider_val,
                 GdkPoint* viewport_center)
{
	Dimensions _tmp0_;
	Dimensions _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 474 "../src/Dimensions.vala"
	g_return_if_fail (content_dimensions != NULL);
#line 474 "../src/Dimensions.vala"
	g_return_if_fail (viewport_dimensions != NULL);
#line 474 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 476 "../src/Dimensions.vala"
	_tmp0_ = *content_dimensions;
#line 476 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp0_;
#line 477 "../src/Dimensions.vala"
	_tmp1_ = *viewport_dimensions;
#line 477 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp1_;
#line 478 "../src/Dimensions.vala"
	(*self).interpolation_factor = slider_val;
#line 480 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 482 "../src/Dimensions.vala"
	if (viewport_center == NULL) {
#line 482 "../src/Dimensions.vala"
		_tmp3_ = TRUE;
#line 2414 "Dimensions.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 482 "../src/Dimensions.vala"
		if ((*viewport_center).x == 0) {
#line 482 "../src/Dimensions.vala"
			_tmp4_ = (*viewport_center).y == 0;
#line 2421 "Dimensions.c"
		} else {
#line 482 "../src/Dimensions.vala"
			_tmp4_ = FALSE;
#line 2425 "Dimensions.c"
		}
#line 482 "../src/Dimensions.vala"
		_tmp3_ = _tmp4_;
#line 2429 "Dimensions.c"
	}
#line 482 "../src/Dimensions.vala"
	if (_tmp3_) {
#line 482 "../src/Dimensions.vala"
		_tmp2_ = TRUE;
#line 2435 "Dimensions.c"
	} else {
#line 483 "../src/Dimensions.vala"
		_tmp2_ = slider_val == 0.0;
#line 2439 "Dimensions.c"
	}
#line 482 "../src/Dimensions.vala"
	if (_tmp2_) {
#line 484 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2445 "Dimensions.c"
	} else {
#line 486 "../src/Dimensions.vala"
		(*self).viewport_center = *viewport_center;
#line 487 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2451 "Dimensions.c"
	}
}

void
zoom_state_init_rescale (ZoomState *self,
                         ZoomState* existing,
                         gdouble new_slider_val)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
#line 491 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 491 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 492 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 492 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 492 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 493 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 493 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 493 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 494 "../src/Dimensions.vala"
	(*self).interpolation_factor = new_slider_val;
#line 496 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 498 "../src/Dimensions.vala"
	if (new_slider_val == 0.0) {
#line 499 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2488 "Dimensions.c"
	} else {
		ZoomState _tmp4_;
		GdkPoint _tmp5_;
		ZoomState _tmp6_;
		ZoomState _tmp7_;
		GdkPoint _tmp8_;
		ZoomState _tmp9_;
#line 501 "../src/Dimensions.vala"
		_tmp4_ = *existing;
#line 501 "../src/Dimensions.vala"
		_tmp5_ = _tmp4_.viewport_center;
#line 501 "../src/Dimensions.vala"
		_tmp6_ = *existing;
#line 501 "../src/Dimensions.vala"
		(*self).viewport_center.x = (gint) ((*self).zoom_factor * (_tmp5_.x / _tmp6_.zoom_factor));
#line 503 "../src/Dimensions.vala"
		_tmp7_ = *existing;
#line 503 "../src/Dimensions.vala"
		_tmp8_ = _tmp7_.viewport_center;
#line 503 "../src/Dimensions.vala"
		_tmp9_ = *existing;
#line 503 "../src/Dimensions.vala"
		(*self).viewport_center.y = (gint) ((*self).zoom_factor * (_tmp8_.y / _tmp9_.zoom_factor));
#line 505 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2514 "Dimensions.c"
	}
}

void
zoom_state_init_rescale_to_isomorphic (ZoomState *self,
                                       ZoomState* existing)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	ZoomState _tmp5_;
	ZoomState _tmp6_;
#line 509 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 509 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 510 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 510 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 510 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 511 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 511 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 511 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 512 "../src/Dimensions.vala"
	_tmp4_ = *existing;
#line 512 "../src/Dimensions.vala"
	_tmp5_ = *existing;
#line 512 "../src/Dimensions.vala"
	_tmp6_ = *existing;
#line 512 "../src/Dimensions.vala"
	(*self).interpolation_factor = log (1.0 / _tmp4_.min_factor) / log (_tmp5_.max_factor / _tmp6_.min_factor);
#line 515 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 517 "../src/Dimensions.vala"
	if ((*self).interpolation_factor == 0.0) {
#line 518 "../src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2559 "Dimensions.c"
	} else {
		ZoomState _tmp7_;
		GdkPoint _tmp8_;
		ZoomState _tmp9_;
		ZoomState _tmp10_;
		GdkPoint _tmp11_;
		ZoomState _tmp12_;
#line 520 "../src/Dimensions.vala"
		_tmp7_ = *existing;
#line 520 "../src/Dimensions.vala"
		_tmp8_ = _tmp7_.viewport_center;
#line 520 "../src/Dimensions.vala"
		_tmp9_ = *existing;
#line 520 "../src/Dimensions.vala"
		(*self).viewport_center.x = (gint) ((*self).zoom_factor * (_tmp8_.x / _tmp9_.zoom_factor));
#line 522 "../src/Dimensions.vala"
		_tmp10_ = *existing;
#line 522 "../src/Dimensions.vala"
		_tmp11_ = _tmp10_.viewport_center;
#line 522 "../src/Dimensions.vala"
		_tmp12_ = *existing;
#line 522 "../src/Dimensions.vala"
		(*self).viewport_center.y = (gint) ((*self).zoom_factor * (_tmp11_.y / _tmp12_.zoom_factor));
#line 524 "../src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2585 "Dimensions.c"
	}
}

void
zoom_state_init_pan (ZoomState *self,
                     ZoomState* existing,
                     GdkPoint* new_viewport_center)
{
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	GdkPoint _tmp5_;
#line 528 "../src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 528 "../src/Dimensions.vala"
	g_return_if_fail (new_viewport_center != NULL);
#line 528 "../src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 529 "../src/Dimensions.vala"
	_tmp0_ = *existing;
#line 529 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 529 "../src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 530 "../src/Dimensions.vala"
	_tmp2_ = *existing;
#line 530 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 530 "../src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 531 "../src/Dimensions.vala"
	_tmp4_ = *existing;
#line 531 "../src/Dimensions.vala"
	(*self).interpolation_factor = _tmp4_.interpolation_factor;
#line 533 "../src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 535 "../src/Dimensions.vala"
	_tmp5_ = *new_viewport_center;
#line 535 "../src/Dimensions.vala"
	(*self).viewport_center = _tmp5_;
#line 537 "../src/Dimensions.vala"
	zoom_state_clamp_viewport_center (&(*self));
#line 2630 "Dimensions.c"
}

static void
zoom_state_clamp_viewport_center (ZoomState *self)
{
	gint zoomed_width = 0;
	gint zoomed_height = 0;
	GdkPoint _tmp0_;
	Dimensions _tmp1_;
	Dimensions _tmp2_;
	GdkPoint _tmp3_;
	Dimensions _tmp4_;
	Dimensions _tmp5_;
#line 541 "../src/Dimensions.vala"
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
#line 542 "../src/Dimensions.vala"
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
#line 544 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_center;
#line 544 "../src/Dimensions.vala"
	_tmp1_ = (*self).viewport_dimensions;
#line 544 "../src/Dimensions.vala"
	_tmp2_ = (*self).viewport_dimensions;
#line 544 "../src/Dimensions.vala"
	(*self).viewport_center.x = CLAMP (_tmp0_.x, _tmp1_.width / 2, (zoomed_width - (_tmp2_.width / 2)) - 1);
#line 546 "../src/Dimensions.vala"
	_tmp3_ = (*self).viewport_center;
#line 546 "../src/Dimensions.vala"
	_tmp4_ = (*self).viewport_dimensions;
#line 546 "../src/Dimensions.vala"
	_tmp5_ = (*self).viewport_dimensions;
#line 546 "../src/Dimensions.vala"
	(*self).viewport_center.y = CLAMP (_tmp3_.y, _tmp4_.height / 2, (zoomed_height - (_tmp5_.height / 2)) - 1);
#line 2664 "Dimensions.c"
}

static void
zoom_state_center_viewport (ZoomState *self)
{
#line 551 "../src/Dimensions.vala"
	(*self).viewport_center.x = zoom_state_get_zoomed_width (&(*self)) / 2;
#line 552 "../src/Dimensions.vala"
	(*self).viewport_center.y = zoom_state_get_zoomed_height (&(*self)) / 2;
#line 2674 "Dimensions.c"
}

static void
zoom_state_compute_zoom_factors (ZoomState *self)
{
	gdouble viewport_to_content_x = 0.0;
	gdouble viewport_to_content_y = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 556 "../src/Dimensions.vala"
	(*self).max_factor = 2.0;
#line 560 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_dimensions;
#line 560 "../src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self).content_dimensions, &_tmp0_, &_tmp1_, &_tmp2_);
#line 560 "../src/Dimensions.vala"
	viewport_to_content_x = _tmp1_;
#line 560 "../src/Dimensions.vala"
	viewport_to_content_y = _tmp2_;
#line 562 "../src/Dimensions.vala"
	(*self).min_factor = MIN (viewport_to_content_x, viewport_to_content_y);
#line 563 "../src/Dimensions.vala"
	if ((*self).min_factor > 1.0) {
#line 564 "../src/Dimensions.vala"
		(*self).min_factor = 1.0;
#line 2701 "Dimensions.c"
	}
#line 566 "../src/Dimensions.vala"
	(*self).zoom_factor = (*self).min_factor * pow ((*self).max_factor / (*self).min_factor, (*self).interpolation_factor);
#line 2705 "Dimensions.c"
}

gdouble
zoom_state_get_interpolation_factor (ZoomState *self)
{
	gdouble result = 0.0;
#line 570 "../src/Dimensions.vala"
	result = (*self).interpolation_factor;
#line 570 "../src/Dimensions.vala"
	return result;
#line 2716 "Dimensions.c"
}

void
zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self,
                                              GdkRectangle* result)
{
	gint zoomed_width = 0;
	gint zoomed_height = 0;
	GdkRectangle _result_ = {0};
	Dimensions _tmp0_;
	GdkRectangle _tmp4_;
	Dimensions _tmp5_;
	GdkRectangle _tmp9_;
	gint right = 0;
	GdkRectangle _tmp10_;
	Dimensions _tmp11_;
	GdkRectangle _tmp12_;
	gint bottom = 0;
	GdkRectangle _tmp13_;
	Dimensions _tmp14_;
	GdkRectangle _tmp15_;
	GdkRectangle _tmp16_;
	GdkRectangle _tmp17_;
#line 575 "../src/Dimensions.vala"
	zoomed_width = zoom_state_get_zoomed_width (&(*self));
#line 576 "../src/Dimensions.vala"
	zoomed_height = zoom_state_get_zoomed_height (&(*self));
#line 578 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 580 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_dimensions;
#line 580 "../src/Dimensions.vala"
	if (_tmp0_.width < zoomed_width) {
#line 2750 "Dimensions.c"
		GdkPoint _tmp1_;
		Dimensions _tmp2_;
#line 581 "../src/Dimensions.vala"
		_tmp1_ = (*self).viewport_center;
#line 581 "../src/Dimensions.vala"
		_tmp2_ = (*self).viewport_dimensions;
#line 581 "../src/Dimensions.vala"
		_result_.x = _tmp1_.x - (_tmp2_.width / 2);
#line 2759 "Dimensions.c"
	} else {
		Dimensions _tmp3_;
#line 583 "../src/Dimensions.vala"
		_tmp3_ = (*self).viewport_dimensions;
#line 583 "../src/Dimensions.vala"
		_result_.x = (zoomed_width - _tmp3_.width) / 2;
#line 2766 "Dimensions.c"
	}
#line 585 "../src/Dimensions.vala"
	_tmp4_ = _result_;
#line 585 "../src/Dimensions.vala"
	if (_tmp4_.x < 0) {
#line 586 "../src/Dimensions.vala"
		_result_.x = 0;
#line 2774 "Dimensions.c"
	}
#line 588 "../src/Dimensions.vala"
	_tmp5_ = (*self).viewport_dimensions;
#line 588 "../src/Dimensions.vala"
	if (_tmp5_.height < zoomed_height) {
#line 2780 "Dimensions.c"
		GdkPoint _tmp6_;
		Dimensions _tmp7_;
#line 589 "../src/Dimensions.vala"
		_tmp6_ = (*self).viewport_center;
#line 589 "../src/Dimensions.vala"
		_tmp7_ = (*self).viewport_dimensions;
#line 589 "../src/Dimensions.vala"
		_result_.y = _tmp6_.y - (_tmp7_.height / 2);
#line 2789 "Dimensions.c"
	} else {
		Dimensions _tmp8_;
#line 591 "../src/Dimensions.vala"
		_tmp8_ = (*self).viewport_dimensions;
#line 591 "../src/Dimensions.vala"
		_result_.y = (zoomed_height - _tmp8_.height) / 2;
#line 2796 "Dimensions.c"
	}
#line 593 "../src/Dimensions.vala"
	_tmp9_ = _result_;
#line 593 "../src/Dimensions.vala"
	if (_tmp9_.y < 0) {
#line 594 "../src/Dimensions.vala"
		_result_.y = 0;
#line 2804 "Dimensions.c"
	}
#line 596 "../src/Dimensions.vala"
	_tmp10_ = _result_;
#line 596 "../src/Dimensions.vala"
	_tmp11_ = (*self).viewport_dimensions;
#line 596 "../src/Dimensions.vala"
	right = _tmp10_.x + _tmp11_.width;
#line 597 "../src/Dimensions.vala"
	if (right > zoomed_width) {
#line 598 "../src/Dimensions.vala"
		right = zoomed_width;
#line 2816 "Dimensions.c"
	}
#line 599 "../src/Dimensions.vala"
	_tmp12_ = _result_;
#line 599 "../src/Dimensions.vala"
	_result_.width = right - _tmp12_.x;
#line 601 "../src/Dimensions.vala"
	_tmp13_ = _result_;
#line 601 "../src/Dimensions.vala"
	_tmp14_ = (*self).viewport_dimensions;
#line 601 "../src/Dimensions.vala"
	bottom = _tmp13_.y + _tmp14_.height;
#line 602 "../src/Dimensions.vala"
	if (bottom > zoomed_height) {
#line 603 "../src/Dimensions.vala"
		bottom = zoomed_height;
#line 2832 "Dimensions.c"
	}
#line 604 "../src/Dimensions.vala"
	_tmp15_ = _result_;
#line 604 "../src/Dimensions.vala"
	_result_.height = bottom - _tmp15_.y;
#line 606 "../src/Dimensions.vala"
	_tmp16_ = _result_;
#line 606 "../src/Dimensions.vala"
	_result_.width = CLAMP (_tmp16_.width, 1, G_MAXINT);
#line 607 "../src/Dimensions.vala"
	_tmp17_ = _result_;
#line 607 "../src/Dimensions.vala"
	_result_.height = CLAMP (_tmp17_.height, 1, G_MAXINT);
#line 609 "../src/Dimensions.vala"
	*result = _result_;
#line 609 "../src/Dimensions.vala"
	return;
#line 2850 "Dimensions.c"
}

void
zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self,
                                             GdkRectangle* result)
{
	GdkRectangle wrt_content = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _result_ = {0};
	Dimensions _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	Dimensions _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
#line 615 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp0_);
#line 615 "../src/Dimensions.vala"
	wrt_content = _tmp0_;
#line 617 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 618 "../src/Dimensions.vala"
	_tmp1_ = (*self).viewport_dimensions;
#line 618 "../src/Dimensions.vala"
	_tmp2_ = wrt_content;
#line 618 "../src/Dimensions.vala"
	_result_.x = (_tmp1_.width / 2) - (_tmp2_.width / 2);
#line 619 "../src/Dimensions.vala"
	_tmp3_ = _result_;
#line 619 "../src/Dimensions.vala"
	if (_tmp3_.x < 0) {
#line 620 "../src/Dimensions.vala"
		_result_.x = 0;
#line 2886 "Dimensions.c"
	}
#line 621 "../src/Dimensions.vala"
	_tmp4_ = (*self).viewport_dimensions;
#line 621 "../src/Dimensions.vala"
	_tmp5_ = wrt_content;
#line 621 "../src/Dimensions.vala"
	_result_.y = (_tmp4_.height / 2) - (_tmp5_.height / 2);
#line 622 "../src/Dimensions.vala"
	_tmp6_ = _result_;
#line 622 "../src/Dimensions.vala"
	if (_tmp6_.y < 0) {
#line 623 "../src/Dimensions.vala"
		_result_.y = 0;
#line 2900 "Dimensions.c"
	}
#line 624 "../src/Dimensions.vala"
	_tmp7_ = wrt_content;
#line 624 "../src/Dimensions.vala"
	_result_.width = _tmp7_.width;
#line 625 "../src/Dimensions.vala"
	_tmp8_ = wrt_content;
#line 625 "../src/Dimensions.vala"
	_result_.height = _tmp8_.height;
#line 627 "../src/Dimensions.vala"
	*result = _result_;
#line 627 "../src/Dimensions.vala"
	return;
#line 2914 "Dimensions.c"
}

void
zoom_state_get_viewing_rectangle_projection (ZoomState *self,
                                             GdkPixbuf* for_pixbuf,
                                             GdkRectangle* result)
{
	gdouble zoomed_width = 0.0;
	gdouble zoomed_height = 0.0;
	gdouble horiz_scale = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble vert_scale = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble scale = 0.0;
	GdkRectangle viewing_rectangle = {0};
	GdkRectangle _tmp4_ = {0};
	GdkRectangle _result_ = {0};
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint right = 0;
	GdkRectangle _tmp13_;
	GdkRectangle _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint bottom = 0;
	GdkRectangle _tmp17_;
	GdkRectangle _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GdkRectangle _tmp21_;
	GdkRectangle _tmp22_;
#line 631 "../src/Dimensions.vala"
	g_return_if_fail (GDK_IS_PIXBUF (for_pixbuf));
#line 632 "../src/Dimensions.vala"
	zoomed_width = (gdouble) zoom_state_get_zoomed_width (&(*self));
#line 633 "../src/Dimensions.vala"
	zoomed_height = (gdouble) zoom_state_get_zoomed_height (&(*self));
#line 635 "../src/Dimensions.vala"
	_tmp0_ = gdk_pixbuf_get_width (for_pixbuf);
#line 635 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_;
#line 635 "../src/Dimensions.vala"
	horiz_scale = _tmp1_ / zoomed_width;
#line 636 "../src/Dimensions.vala"
	_tmp2_ = gdk_pixbuf_get_height (for_pixbuf);
#line 636 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_;
#line 636 "../src/Dimensions.vala"
	vert_scale = _tmp3_ / zoomed_height;
#line 637 "../src/Dimensions.vala"
	scale = (horiz_scale + vert_scale) / 2.0;
#line 639 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp4_);
#line 639 "../src/Dimensions.vala"
	viewing_rectangle = _tmp4_;
#line 641 "../src/Dimensions.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 642 "../src/Dimensions.vala"
	_tmp5_ = viewing_rectangle;
#line 642 "../src/Dimensions.vala"
	_result_.x = (gint) (_tmp5_.x * scale);
#line 643 "../src/Dimensions.vala"
	_tmp6_ = _result_;
#line 643 "../src/Dimensions.vala"
	_tmp7_ = gdk_pixbuf_get_width (for_pixbuf);
#line 643 "../src/Dimensions.vala"
	_tmp8_ = _tmp7_;
#line 643 "../src/Dimensions.vala"
	_result_.x = CLAMP (_tmp6_.x, 0, _tmp8_);
#line 644 "../src/Dimensions.vala"
	_tmp9_ = viewing_rectangle;
#line 644 "../src/Dimensions.vala"
	_result_.y = (gint) (_tmp9_.y * scale);
#line 645 "../src/Dimensions.vala"
	_tmp10_ = _result_;
#line 645 "../src/Dimensions.vala"
	_tmp11_ = gdk_pixbuf_get_height (for_pixbuf);
#line 645 "../src/Dimensions.vala"
	_tmp12_ = _tmp11_;
#line 645 "../src/Dimensions.vala"
	_result_.y = CLAMP (_tmp10_.y, 0, _tmp12_);
#line 646 "../src/Dimensions.vala"
	_tmp13_ = viewing_rectangle;
#line 646 "../src/Dimensions.vala"
	_tmp14_ = viewing_rectangle;
#line 646 "../src/Dimensions.vala"
	right = (gint) ((_tmp13_.x + _tmp14_.width) * scale);
#line 647 "../src/Dimensions.vala"
	_tmp15_ = gdk_pixbuf_get_width (for_pixbuf);
#line 647 "../src/Dimensions.vala"
	_tmp16_ = _tmp15_;
#line 647 "../src/Dimensions.vala"
	right = CLAMP (right, 0, _tmp16_);
#line 648 "../src/Dimensions.vala"
	_tmp17_ = viewing_rectangle;
#line 648 "../src/Dimensions.vala"
	_tmp18_ = viewing_rectangle;
#line 648 "../src/Dimensions.vala"
	bottom = (gint) ((_tmp17_.y + _tmp18_.height) * scale);
#line 649 "../src/Dimensions.vala"
	_tmp19_ = gdk_pixbuf_get_height (for_pixbuf);
#line 649 "../src/Dimensions.vala"
	_tmp20_ = _tmp19_;
#line 649 "../src/Dimensions.vala"
	bottom = CLAMP (bottom, 0, _tmp20_);
#line 650 "../src/Dimensions.vala"
	_tmp21_ = _result_;
#line 650 "../src/Dimensions.vala"
	_result_.width = right - _tmp21_.x;
#line 651 "../src/Dimensions.vala"
	_tmp22_ = _result_;
#line 651 "../src/Dimensions.vala"
	_result_.height = bottom - _tmp22_.y;
#line 653 "../src/Dimensions.vala"
	*result = _result_;
#line 653 "../src/Dimensions.vala"
	return;
#line 3040 "Dimensions.c"
}

gdouble
zoom_state_get_zoom_factor (ZoomState *self)
{
	gdouble result = 0.0;
#line 658 "../src/Dimensions.vala"
	result = (*self).zoom_factor;
#line 658 "../src/Dimensions.vala"
	return result;
#line 3051 "Dimensions.c"
}

gint
zoom_state_get_zoomed_width (ZoomState *self)
{
	gint result = 0;
	Dimensions _tmp0_;
#line 662 "../src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 662 "../src/Dimensions.vala"
	result = (gint) (_tmp0_.width * (*self).zoom_factor);
#line 662 "../src/Dimensions.vala"
	return result;
#line 3065 "Dimensions.c"
}

gint
zoom_state_get_zoomed_height (ZoomState *self)
{
	gint result = 0;
	Dimensions _tmp0_;
#line 666 "../src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 666 "../src/Dimensions.vala"
	result = (gint) (_tmp0_.height * (*self).zoom_factor);
#line 666 "../src/Dimensions.vala"
	return result;
#line 3079 "Dimensions.c"
}

void
zoom_state_get_viewport_center (ZoomState *self,
                                GdkPoint* result)
{
	GdkPoint _tmp0_;
#line 670 "../src/Dimensions.vala"
	_tmp0_ = (*self).viewport_center;
#line 670 "../src/Dimensions.vala"
	*result = _tmp0_;
#line 670 "../src/Dimensions.vala"
	return;
#line 3093 "Dimensions.c"
}

gchar*
zoom_state_to_string (ZoomState *self)
{
	gchar* result = NULL;
	gchar* named_modes = NULL;
	gchar* _tmp0_;
	const gchar* _tmp17_;
	GdkRectangle viewing_rect = {0};
	GdkRectangle _tmp19_ = {0};
	Dimensions _tmp20_;
	Dimensions _tmp21_;
	Dimensions _tmp22_;
	Dimensions _tmp23_;
	const gchar* _tmp24_;
	GdkRectangle _tmp25_;
	GdkRectangle _tmp26_;
	GdkRectangle _tmp27_;
	GdkRectangle _tmp28_;
	GdkPoint _tmp29_;
	GdkPoint _tmp30_;
	gchar* _tmp31_;
#line 674 "../src/Dimensions.vala"
	_tmp0_ = g_strdup ("");
#line 674 "../src/Dimensions.vala"
	named_modes = _tmp0_;
#line 675 "../src/Dimensions.vala"
	if (zoom_state_is_min (&(*self))) {
#line 3123 "Dimensions.c"
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 676 "../src/Dimensions.vala"
		_tmp2_ = named_modes;
#line 676 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp2_, "") == 0) {
#line 676 "../src/Dimensions.vala"
			_tmp1_ = "MIN";
#line 3134 "Dimensions.c"
		} else {
#line 676 "../src/Dimensions.vala"
			_tmp1_ = ", MIN";
#line 3138 "Dimensions.c"
		}
#line 676 "../src/Dimensions.vala"
		_tmp3_ = named_modes;
#line 676 "../src/Dimensions.vala"
		_tmp4_ = g_strconcat (_tmp3_, _tmp1_, NULL);
#line 676 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 676 "../src/Dimensions.vala"
		named_modes = _tmp4_;
#line 3148 "Dimensions.c"
	}
#line 677 "../src/Dimensions.vala"
	if (zoom_state_is_default (&(*self))) {
#line 3152 "Dimensions.c"
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 678 "../src/Dimensions.vala"
		_tmp6_ = named_modes;
#line 678 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp6_, "") == 0) {
#line 678 "../src/Dimensions.vala"
			_tmp5_ = "DEFAULT";
#line 3163 "Dimensions.c"
		} else {
#line 678 "../src/Dimensions.vala"
			_tmp5_ = ", DEFAULT";
#line 3167 "Dimensions.c"
		}
#line 678 "../src/Dimensions.vala"
		_tmp7_ = named_modes;
#line 678 "../src/Dimensions.vala"
		_tmp8_ = g_strconcat (_tmp7_, _tmp5_, NULL);
#line 678 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 678 "../src/Dimensions.vala"
		named_modes = _tmp8_;
#line 3177 "Dimensions.c"
	}
#line 679 "../src/Dimensions.vala"
	if (zoom_state_is_isomorphic (&(*self))) {
#line 3181 "Dimensions.c"
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 680 "../src/Dimensions.vala"
		_tmp10_ = named_modes;
#line 680 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp10_, "") == 0) {
#line 680 "../src/Dimensions.vala"
			_tmp9_ = "ISOMORPHIC";
#line 3192 "Dimensions.c"
		} else {
#line 680 "../src/Dimensions.vala"
			_tmp9_ = ", ISOMORPHIC";
#line 3196 "Dimensions.c"
		}
#line 680 "../src/Dimensions.vala"
		_tmp11_ = named_modes;
#line 680 "../src/Dimensions.vala"
		_tmp12_ = g_strconcat (_tmp11_, _tmp9_, NULL);
#line 680 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 680 "../src/Dimensions.vala"
		named_modes = _tmp12_;
#line 3206 "Dimensions.c"
	}
#line 681 "../src/Dimensions.vala"
	if (zoom_state_is_max (&(*self))) {
#line 3210 "Dimensions.c"
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 682 "../src/Dimensions.vala"
		_tmp14_ = named_modes;
#line 682 "../src/Dimensions.vala"
		if (g_strcmp0 (_tmp14_, "") == 0) {
#line 682 "../src/Dimensions.vala"
			_tmp13_ = "MAX";
#line 3221 "Dimensions.c"
		} else {
#line 682 "../src/Dimensions.vala"
			_tmp13_ = ", MAX";
#line 3225 "Dimensions.c"
		}
#line 682 "../src/Dimensions.vala"
		_tmp15_ = named_modes;
#line 682 "../src/Dimensions.vala"
		_tmp16_ = g_strconcat (_tmp15_, _tmp13_, NULL);
#line 682 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 682 "../src/Dimensions.vala"
		named_modes = _tmp16_;
#line 3235 "Dimensions.c"
	}
#line 683 "../src/Dimensions.vala"
	_tmp17_ = named_modes;
#line 683 "../src/Dimensions.vala"
	if (g_strcmp0 (_tmp17_, "") == 0) {
#line 3241 "Dimensions.c"
		gchar* _tmp18_;
#line 684 "../src/Dimensions.vala"
		_tmp18_ = g_strdup ("(none)");
#line 684 "../src/Dimensions.vala"
		_g_free0 (named_modes);
#line 684 "../src/Dimensions.vala"
		named_modes = _tmp18_;
#line 3249 "Dimensions.c"
	}
#line 686 "../src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp19_);
#line 686 "../src/Dimensions.vala"
	viewing_rect = _tmp19_;
#line 688 "../src/Dimensions.vala"
	_tmp20_ = (*self).content_dimensions;
#line 688 "../src/Dimensions.vala"
	_tmp21_ = (*self).content_dimensions;
#line 688 "../src/Dimensions.vala"
	_tmp22_ = (*self).viewport_dimensions;
#line 688 "../src/Dimensions.vala"
	_tmp23_ = (*self).viewport_dimensions;
#line 688 "../src/Dimensions.vala"
	_tmp24_ = named_modes;
#line 688 "../src/Dimensions.vala"
	_tmp25_ = viewing_rect;
#line 688 "../src/Dimensions.vala"
	_tmp26_ = viewing_rect;
#line 688 "../src/Dimensions.vala"
	_tmp27_ = viewing_rect;
#line 688 "../src/Dimensions.vala"
	_tmp28_ = viewing_rect;
#line 688 "../src/Dimensions.vala"
	_tmp29_ = (*self).viewport_center;
#line 688 "../src/Dimensions.vala"
	_tmp30_ = (*self).viewport_center;
#line 688 "../src/Dimensions.vala"
	_tmp31_ = g_strdup_printf ("ZoomState {\n" \
"    content dimensions = %d x %d;\n" \
"    viewport dimensions = " "%d x %d;\n" \
"    min factor = %f;\n" \
"    max factor = %f;\n" \
"    current factor = %f;" "\n" \
"    zoomed width = %d;\n" \
"    zoomed height = %d;\n" \
"    named modes = %s;" "\n    viewing rectangle = { x: %d, y: %d, width: %d, height: %d };" "\n    viewport center = (%d, %d);\n}\n", _tmp20_.width, _tmp21_.height, _tmp22_.width, _tmp23_.height, (*self).min_factor, (*self).max_factor, (*self).zoom_factor, zoom_state_get_zoomed_width (&(*self)), zoom_state_get_zoomed_height (&(*self)), _tmp24_, _tmp25_.x, _tmp26_.y, _tmp27_.width, _tmp28_.height, _tmp29_.x, _tmp30_.y);
#line 688 "../src/Dimensions.vala"
	result = _tmp31_;
#line 688 "../src/Dimensions.vala"
	_g_free0 (named_modes);
#line 688 "../src/Dimensions.vala"
	return result;
#line 3285 "Dimensions.c"
}

gboolean
zoom_state_is_min (ZoomState *self)
{
	gboolean result = FALSE;
#line 700 "../src/Dimensions.vala"
	result = (*self).zoom_factor == (*self).min_factor;
#line 700 "../src/Dimensions.vala"
	return result;
#line 3296 "Dimensions.c"
}

gboolean
zoom_state_is_default (ZoomState *self)
{
	gboolean result = FALSE;
#line 704 "../src/Dimensions.vala"
	result = zoom_state_is_min (&(*self));
#line 704 "../src/Dimensions.vala"
	return result;
#line 3307 "Dimensions.c"
}

gboolean
zoom_state_is_max (ZoomState *self)
{
	gboolean result = FALSE;
#line 708 "../src/Dimensions.vala"
	result = (*self).zoom_factor == (*self).max_factor;
#line 708 "../src/Dimensions.vala"
	return result;
#line 3318 "Dimensions.c"
}

gboolean
zoom_state_is_isomorphic (ZoomState *self)
{
	gboolean result = FALSE;
#line 712 "../src/Dimensions.vala"
	result = (*self).zoom_factor == 1.0;
#line 712 "../src/Dimensions.vala"
	return result;
#line 3329 "Dimensions.c"
}

gboolean
zoom_state_equals (ZoomState *self,
                   ZoomState* other)
{
	gboolean result = FALSE;
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	ZoomState _tmp5_;
	ZoomState _tmp6_;
	GdkPoint _tmp7_;
	ZoomState _tmp8_;
	GdkPoint _tmp9_;
	GdkPoint _tmp10_;
	ZoomState _tmp11_;
	GdkPoint _tmp12_;
#line 715 "../src/Dimensions.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 716 "../src/Dimensions.vala"
	_tmp0_ = *other;
#line 716 "../src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 716 "../src/Dimensions.vala"
	if (!dimensions_equals (&(*self).content_dimensions, &_tmp1_)) {
#line 717 "../src/Dimensions.vala"
		result = FALSE;
#line 717 "../src/Dimensions.vala"
		return result;
#line 3362 "Dimensions.c"
	}
#line 718 "../src/Dimensions.vala"
	_tmp2_ = *other;
#line 718 "../src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 718 "../src/Dimensions.vala"
	if (!dimensions_equals (&(*self).viewport_dimensions, &_tmp3_)) {
#line 719 "../src/Dimensions.vala"
		result = FALSE;
#line 719 "../src/Dimensions.vala"
		return result;
#line 3374 "Dimensions.c"
	}
#line 720 "../src/Dimensions.vala"
	_tmp4_ = *other;
#line 720 "../src/Dimensions.vala"
	if ((*self).zoom_factor != _tmp4_.zoom_factor) {
#line 721 "../src/Dimensions.vala"
		result = FALSE;
#line 721 "../src/Dimensions.vala"
		return result;
#line 3384 "Dimensions.c"
	}
#line 722 "../src/Dimensions.vala"
	_tmp5_ = *other;
#line 722 "../src/Dimensions.vala"
	if ((*self).min_factor != _tmp5_.min_factor) {
#line 723 "../src/Dimensions.vala"
		result = FALSE;
#line 723 "../src/Dimensions.vala"
		return result;
#line 3394 "Dimensions.c"
	}
#line 724 "../src/Dimensions.vala"
	_tmp6_ = *other;
#line 724 "../src/Dimensions.vala"
	if ((*self).max_factor != _tmp6_.max_factor) {
#line 725 "../src/Dimensions.vala"
		result = FALSE;
#line 725 "../src/Dimensions.vala"
		return result;
#line 3404 "Dimensions.c"
	}
#line 726 "../src/Dimensions.vala"
	_tmp7_ = (*self).viewport_center;
#line 726 "../src/Dimensions.vala"
	_tmp8_ = *other;
#line 726 "../src/Dimensions.vala"
	_tmp9_ = _tmp8_.viewport_center;
#line 726 "../src/Dimensions.vala"
	if (_tmp7_.x != _tmp9_.x) {
#line 727 "../src/Dimensions.vala"
		result = FALSE;
#line 727 "../src/Dimensions.vala"
		return result;
#line 3418 "Dimensions.c"
	}
#line 728 "../src/Dimensions.vala"
	_tmp10_ = (*self).viewport_center;
#line 728 "../src/Dimensions.vala"
	_tmp11_ = *other;
#line 728 "../src/Dimensions.vala"
	_tmp12_ = _tmp11_.viewport_center;
#line 728 "../src/Dimensions.vala"
	if (_tmp10_.y != _tmp12_.y) {
#line 729 "../src/Dimensions.vala"
		result = FALSE;
#line 729 "../src/Dimensions.vala"
		return result;
#line 3432 "Dimensions.c"
	}
#line 731 "../src/Dimensions.vala"
	result = TRUE;
#line 731 "../src/Dimensions.vala"
	return result;
#line 3438 "Dimensions.c"
}

ZoomState*
zoom_state_dup (const ZoomState* self)
{
	ZoomState* dup;
#line 465 "../src/Dimensions.vala"
	dup = g_new0 (ZoomState, 1);
#line 465 "../src/Dimensions.vala"
	memcpy (dup, self, sizeof (ZoomState));
#line 465 "../src/Dimensions.vala"
	return dup;
#line 3451 "Dimensions.c"
}

void
zoom_state_free (ZoomState* self)
{
#line 465 "../src/Dimensions.vala"
	g_free (self);
#line 3459 "Dimensions.c"
}

GType
zoom_state_get_type (void)
{
	static volatile gsize zoom_state_type_id__volatile = 0;
	if (g_once_init_enter (&zoom_state_type_id__volatile)) {
		GType zoom_state_type_id;
		zoom_state_type_id = g_boxed_type_register_static ("ZoomState", (GBoxedCopyFunc) zoom_state_dup, (GBoxedFreeFunc) zoom_state_free);
		g_once_init_leave (&zoom_state_type_id__volatile, zoom_state_type_id);
	}
	return zoom_state_type_id__volatile;
}

