/* Orientation.c generated by valac 0.44.3, the Vala compiler
 * generated from Orientation.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())
typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

GType orientation_get_type (void) G_GNUC_CONST;
gchar* orientation_to_string (Orientation self);
Orientation orientation_rotate_clockwise (Orientation self);
Orientation orientation_rotate_counterclockwise (Orientation self);
Orientation orientation_flip_top_to_bottom (Orientation self);
Orientation orientation_flip_left_to_right (Orientation self);
GType rotation_get_type (void) G_GNUC_CONST;
Orientation orientation_perform (Orientation self,
                                 Rotation rotation);
Rotation* orientation_to_rotations (Orientation self,
                                    gint* result_length1);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void orientation_rotate_dimensions (Orientation self,
                                    Dimensions* dim,
                                    Dimensions* result);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
void orientation_derotate_dimensions (Orientation self,
                                      Dimensions* dim,
                                      Dimensions* result);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self,
                                      GdkPixbuf* pixbuf);
void orientation_rotate_point (Orientation self,
                               Dimensions* space,
                               GdkPoint* point,
                               GdkPoint* result);
gboolean dimensions_has_area (Dimensions *self);
void orientation_derotate_point (Orientation self,
                                 Dimensions* space,
                                 GdkPoint* point,
                                 GdkPoint* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
void orientation_rotate_box (Orientation self,
                             Dimensions* space,
                             Box* box,
                             Box* result);
void box_get_points (Box *self,
                     GdkPoint* top_left,
                     GdkPoint* bottom_right);
void box_from_points (GdkPoint* corner1,
                      GdkPoint* corner2,
                      Box* result);
void orientation_derotate_box (Orientation self,
                               Dimensions* space,
                               Box* box,
                               Box* result);
GdkPixbuf* rotation_perform (Rotation self,
                             GdkPixbuf* pixbuf);
Rotation rotation_opposite (Rotation self);

gchar*
orientation_to_string (Orientation self)
{
	gchar* result = NULL;
#line 20 "../src/Orientation.vala"
	switch (self) {
#line 20 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 127 "Orientation.c"
		{
			gchar* _tmp0_;
#line 22 "../src/Orientation.vala"
			_tmp0_ = g_strdup ("top-left");
#line 22 "../src/Orientation.vala"
			result = _tmp0_;
#line 22 "../src/Orientation.vala"
			return result;
#line 136 "Orientation.c"
		}
#line 20 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 140 "Orientation.c"
		{
			gchar* _tmp1_;
#line 25 "../src/Orientation.vala"
			_tmp1_ = g_strdup ("top-right");
#line 25 "../src/Orientation.vala"
			result = _tmp1_;
#line 25 "../src/Orientation.vala"
			return result;
#line 149 "Orientation.c"
		}
#line 20 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 153 "Orientation.c"
		{
			gchar* _tmp2_;
#line 28 "../src/Orientation.vala"
			_tmp2_ = g_strdup ("bottom-right");
#line 28 "../src/Orientation.vala"
			result = _tmp2_;
#line 28 "../src/Orientation.vala"
			return result;
#line 162 "Orientation.c"
		}
#line 20 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 166 "Orientation.c"
		{
			gchar* _tmp3_;
#line 31 "../src/Orientation.vala"
			_tmp3_ = g_strdup ("bottom-left");
#line 31 "../src/Orientation.vala"
			result = _tmp3_;
#line 31 "../src/Orientation.vala"
			return result;
#line 175 "Orientation.c"
		}
#line 20 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 179 "Orientation.c"
		{
			gchar* _tmp4_;
#line 34 "../src/Orientation.vala"
			_tmp4_ = g_strdup ("left-top");
#line 34 "../src/Orientation.vala"
			result = _tmp4_;
#line 34 "../src/Orientation.vala"
			return result;
#line 188 "Orientation.c"
		}
#line 20 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 192 "Orientation.c"
		{
			gchar* _tmp5_;
#line 37 "../src/Orientation.vala"
			_tmp5_ = g_strdup ("right-top");
#line 37 "../src/Orientation.vala"
			result = _tmp5_;
#line 37 "../src/Orientation.vala"
			return result;
#line 201 "Orientation.c"
		}
#line 20 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 205 "Orientation.c"
		{
			gchar* _tmp6_;
#line 40 "../src/Orientation.vala"
			_tmp6_ = g_strdup ("right-bottom");
#line 40 "../src/Orientation.vala"
			result = _tmp6_;
#line 40 "../src/Orientation.vala"
			return result;
#line 214 "Orientation.c"
		}
#line 20 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 218 "Orientation.c"
		{
			gchar* _tmp7_;
#line 43 "../src/Orientation.vala"
			_tmp7_ = g_strdup ("left-bottom");
#line 43 "../src/Orientation.vala"
			result = _tmp7_;
#line 43 "../src/Orientation.vala"
			return result;
#line 227 "Orientation.c"
		}
		default:
		{
			gchar* _tmp8_;
#line 46 "../src/Orientation.vala"
			_tmp8_ = g_strdup_printf ("unknown orientation %d", (gint) self);
#line 46 "../src/Orientation.vala"
			result = _tmp8_;
#line 46 "../src/Orientation.vala"
			return result;
#line 238 "Orientation.c"
		}
	}
}

Orientation
orientation_rotate_clockwise (Orientation self)
{
	Orientation result = 0;
#line 51 "../src/Orientation.vala"
	switch (self) {
#line 51 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 251 "Orientation.c"
		{
#line 53 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 53 "../src/Orientation.vala"
			return result;
#line 257 "Orientation.c"
		}
#line 51 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 261 "Orientation.c"
		{
#line 56 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 56 "../src/Orientation.vala"
			return result;
#line 267 "Orientation.c"
		}
#line 51 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 271 "Orientation.c"
		{
#line 59 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 59 "../src/Orientation.vala"
			return result;
#line 277 "Orientation.c"
		}
#line 51 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 281 "Orientation.c"
		{
#line 62 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 62 "../src/Orientation.vala"
			return result;
#line 287 "Orientation.c"
		}
#line 51 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 291 "Orientation.c"
		{
#line 65 "../src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 65 "../src/Orientation.vala"
			return result;
#line 297 "Orientation.c"
		}
#line 51 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 301 "Orientation.c"
		{
#line 68 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 68 "../src/Orientation.vala"
			return result;
#line 307 "Orientation.c"
		}
#line 51 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 311 "Orientation.c"
		{
#line 71 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 71 "../src/Orientation.vala"
			return result;
#line 317 "Orientation.c"
		}
#line 51 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 321 "Orientation.c"
		{
#line 74 "../src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 74 "../src/Orientation.vala"
			return result;
#line 327 "Orientation.c"
		}
		default:
		{
#line 77 "../src/Orientation.vala"
			g_error ("Orientation.vala:77: rotate_clockwise: %d", (gint) self);
#line 333 "Orientation.c"
		}
	}
}

Orientation
orientation_rotate_counterclockwise (Orientation self)
{
	Orientation result = 0;
#line 82 "../src/Orientation.vala"
	switch (self) {
#line 82 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 346 "Orientation.c"
		{
#line 84 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 84 "../src/Orientation.vala"
			return result;
#line 352 "Orientation.c"
		}
#line 82 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 356 "Orientation.c"
		{
#line 87 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 87 "../src/Orientation.vala"
			return result;
#line 362 "Orientation.c"
		}
#line 82 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 366 "Orientation.c"
		{
#line 90 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 90 "../src/Orientation.vala"
			return result;
#line 372 "Orientation.c"
		}
#line 82 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 376 "Orientation.c"
		{
#line 93 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 93 "../src/Orientation.vala"
			return result;
#line 382 "Orientation.c"
		}
#line 82 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 386 "Orientation.c"
		{
#line 96 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 96 "../src/Orientation.vala"
			return result;
#line 392 "Orientation.c"
		}
#line 82 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 396 "Orientation.c"
		{
#line 99 "../src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 99 "../src/Orientation.vala"
			return result;
#line 402 "Orientation.c"
		}
#line 82 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 406 "Orientation.c"
		{
#line 102 "../src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 102 "../src/Orientation.vala"
			return result;
#line 412 "Orientation.c"
		}
#line 82 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 416 "Orientation.c"
		{
#line 105 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 105 "../src/Orientation.vala"
			return result;
#line 422 "Orientation.c"
		}
		default:
		{
#line 108 "../src/Orientation.vala"
			g_error ("Orientation.vala:108: rotate_counterclockwise: %d", (gint) self);
#line 428 "Orientation.c"
		}
	}
}

Orientation
orientation_flip_top_to_bottom (Orientation self)
{
	Orientation result = 0;
#line 113 "../src/Orientation.vala"
	switch (self) {
#line 113 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 441 "Orientation.c"
		{
#line 115 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 115 "../src/Orientation.vala"
			return result;
#line 447 "Orientation.c"
		}
#line 113 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 451 "Orientation.c"
		{
#line 118 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 118 "../src/Orientation.vala"
			return result;
#line 457 "Orientation.c"
		}
#line 113 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 461 "Orientation.c"
		{
#line 121 "../src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 121 "../src/Orientation.vala"
			return result;
#line 467 "Orientation.c"
		}
#line 113 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 471 "Orientation.c"
		{
#line 124 "../src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 124 "../src/Orientation.vala"
			return result;
#line 477 "Orientation.c"
		}
#line 113 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 481 "Orientation.c"
		{
#line 127 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 127 "../src/Orientation.vala"
			return result;
#line 487 "Orientation.c"
		}
#line 113 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 491 "Orientation.c"
		{
#line 130 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 130 "../src/Orientation.vala"
			return result;
#line 497 "Orientation.c"
		}
#line 113 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 501 "Orientation.c"
		{
#line 133 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 133 "../src/Orientation.vala"
			return result;
#line 507 "Orientation.c"
		}
#line 113 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 511 "Orientation.c"
		{
#line 136 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 136 "../src/Orientation.vala"
			return result;
#line 517 "Orientation.c"
		}
		default:
		{
#line 139 "../src/Orientation.vala"
			g_error ("Orientation.vala:139: flip_top_to_bottom: %d", (gint) self);
#line 523 "Orientation.c"
		}
	}
}

Orientation
orientation_flip_left_to_right (Orientation self)
{
	Orientation result = 0;
#line 144 "../src/Orientation.vala"
	switch (self) {
#line 144 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 536 "Orientation.c"
		{
#line 146 "../src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 146 "../src/Orientation.vala"
			return result;
#line 542 "Orientation.c"
		}
#line 144 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 546 "Orientation.c"
		{
#line 149 "../src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 149 "../src/Orientation.vala"
			return result;
#line 552 "Orientation.c"
		}
#line 144 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 556 "Orientation.c"
		{
#line 152 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 152 "../src/Orientation.vala"
			return result;
#line 562 "Orientation.c"
		}
#line 144 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 566 "Orientation.c"
		{
#line 155 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 155 "../src/Orientation.vala"
			return result;
#line 572 "Orientation.c"
		}
#line 144 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 576 "Orientation.c"
		{
#line 158 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 158 "../src/Orientation.vala"
			return result;
#line 582 "Orientation.c"
		}
#line 144 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 586 "Orientation.c"
		{
#line 161 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 161 "../src/Orientation.vala"
			return result;
#line 592 "Orientation.c"
		}
#line 144 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 596 "Orientation.c"
		{
#line 164 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 164 "../src/Orientation.vala"
			return result;
#line 602 "Orientation.c"
		}
#line 144 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 606 "Orientation.c"
		{
#line 167 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 167 "../src/Orientation.vala"
			return result;
#line 612 "Orientation.c"
		}
		default:
		{
#line 170 "../src/Orientation.vala"
			g_error ("Orientation.vala:170: flip_left_to_right: %d", (gint) self);
#line 618 "Orientation.c"
		}
	}
}

Orientation
orientation_perform (Orientation self,
                     Rotation rotation)
{
	Orientation result = 0;
#line 175 "../src/Orientation.vala"
	switch (rotation) {
#line 175 "../src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 632 "Orientation.c"
		{
#line 177 "../src/Orientation.vala"
			result = orientation_rotate_clockwise (self);
#line 177 "../src/Orientation.vala"
			return result;
#line 638 "Orientation.c"
		}
#line 175 "../src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 642 "Orientation.c"
		{
#line 180 "../src/Orientation.vala"
			result = orientation_rotate_counterclockwise (self);
#line 180 "../src/Orientation.vala"
			return result;
#line 648 "Orientation.c"
		}
#line 175 "../src/Orientation.vala"
		case ROTATION_MIRROR:
#line 652 "Orientation.c"
		{
#line 183 "../src/Orientation.vala"
			result = orientation_flip_left_to_right (self);
#line 183 "../src/Orientation.vala"
			return result;
#line 658 "Orientation.c"
		}
#line 175 "../src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 662 "Orientation.c"
		{
#line 186 "../src/Orientation.vala"
			result = orientation_flip_top_to_bottom (self);
#line 186 "../src/Orientation.vala"
			return result;
#line 668 "Orientation.c"
		}
		default:
		{
#line 189 "../src/Orientation.vala"
			g_error ("Orientation.vala:189: perform: %d", (gint) rotation);
#line 674 "Orientation.c"
		}
	}
}

Rotation*
orientation_to_rotations (Orientation self,
                          gint* result_length1)
{
	Rotation* result = NULL;
#line 194 "../src/Orientation.vala"
	switch (self) {
#line 194 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 688 "Orientation.c"
		{
			Rotation* _tmp0_;
			Rotation* _tmp1_;
			gint _tmp1__length1;
#line 197 "../src/Orientation.vala"
			_tmp0_ = g_new0 (Rotation, 0);
#line 197 "../src/Orientation.vala"
			_tmp1_ = _tmp0_;
#line 197 "../src/Orientation.vala"
			_tmp1__length1 = 0;
#line 197 "../src/Orientation.vala"
			if (result_length1) {
#line 197 "../src/Orientation.vala"
				*result_length1 = _tmp1__length1;
#line 703 "Orientation.c"
			}
#line 197 "../src/Orientation.vala"
			result = _tmp1_;
#line 197 "../src/Orientation.vala"
			return result;
#line 709 "Orientation.c"
		}
#line 194 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 713 "Orientation.c"
		{
			Rotation* _tmp2_;
			Rotation* _tmp3_;
			gint _tmp3__length1;
#line 200 "../src/Orientation.vala"
			_tmp2_ = g_new0 (Rotation, 1);
#line 200 "../src/Orientation.vala"
			_tmp2_[0] = ROTATION_MIRROR;
#line 200 "../src/Orientation.vala"
			_tmp3_ = _tmp2_;
#line 200 "../src/Orientation.vala"
			_tmp3__length1 = 1;
#line 200 "../src/Orientation.vala"
			if (result_length1) {
#line 200 "../src/Orientation.vala"
				*result_length1 = _tmp3__length1;
#line 730 "Orientation.c"
			}
#line 200 "../src/Orientation.vala"
			result = _tmp3_;
#line 200 "../src/Orientation.vala"
			return result;
#line 736 "Orientation.c"
		}
#line 194 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 740 "Orientation.c"
		{
			Rotation* _tmp4_;
			Rotation* _tmp5_;
			gint _tmp5__length1;
#line 203 "../src/Orientation.vala"
			_tmp4_ = g_new0 (Rotation, 1);
#line 203 "../src/Orientation.vala"
			_tmp4_[0] = ROTATION_UPSIDE_DOWN;
#line 203 "../src/Orientation.vala"
			_tmp5_ = _tmp4_;
#line 203 "../src/Orientation.vala"
			_tmp5__length1 = 1;
#line 203 "../src/Orientation.vala"
			if (result_length1) {
#line 203 "../src/Orientation.vala"
				*result_length1 = _tmp5__length1;
#line 757 "Orientation.c"
			}
#line 203 "../src/Orientation.vala"
			result = _tmp5_;
#line 203 "../src/Orientation.vala"
			return result;
#line 763 "Orientation.c"
		}
#line 194 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 767 "Orientation.c"
		{
			Rotation* _tmp6_;
			Rotation* _tmp7_;
			gint _tmp7__length1;
#line 207 "../src/Orientation.vala"
			_tmp6_ = g_new0 (Rotation, 2);
#line 207 "../src/Orientation.vala"
			_tmp6_[0] = ROTATION_MIRROR;
#line 207 "../src/Orientation.vala"
			_tmp6_[1] = ROTATION_UPSIDE_DOWN;
#line 207 "../src/Orientation.vala"
			_tmp7_ = _tmp6_;
#line 207 "../src/Orientation.vala"
			_tmp7__length1 = 2;
#line 207 "../src/Orientation.vala"
			if (result_length1) {
#line 207 "../src/Orientation.vala"
				*result_length1 = _tmp7__length1;
#line 786 "Orientation.c"
			}
#line 207 "../src/Orientation.vala"
			result = _tmp7_;
#line 207 "../src/Orientation.vala"
			return result;
#line 792 "Orientation.c"
		}
#line 194 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 796 "Orientation.c"
		{
			Rotation* _tmp8_;
			Rotation* _tmp9_;
			gint _tmp9__length1;
#line 210 "../src/Orientation.vala"
			_tmp8_ = g_new0 (Rotation, 2);
#line 210 "../src/Orientation.vala"
			_tmp8_[0] = ROTATION_COUNTERCLOCKWISE;
#line 210 "../src/Orientation.vala"
			_tmp8_[1] = ROTATION_UPSIDE_DOWN;
#line 210 "../src/Orientation.vala"
			_tmp9_ = _tmp8_;
#line 210 "../src/Orientation.vala"
			_tmp9__length1 = 2;
#line 210 "../src/Orientation.vala"
			if (result_length1) {
#line 210 "../src/Orientation.vala"
				*result_length1 = _tmp9__length1;
#line 815 "Orientation.c"
			}
#line 210 "../src/Orientation.vala"
			result = _tmp9_;
#line 210 "../src/Orientation.vala"
			return result;
#line 821 "Orientation.c"
		}
#line 194 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 825 "Orientation.c"
		{
			Rotation* _tmp10_;
			Rotation* _tmp11_;
			gint _tmp11__length1;
#line 213 "../src/Orientation.vala"
			_tmp10_ = g_new0 (Rotation, 1);
#line 213 "../src/Orientation.vala"
			_tmp10_[0] = ROTATION_CLOCKWISE;
#line 213 "../src/Orientation.vala"
			_tmp11_ = _tmp10_;
#line 213 "../src/Orientation.vala"
			_tmp11__length1 = 1;
#line 213 "../src/Orientation.vala"
			if (result_length1) {
#line 213 "../src/Orientation.vala"
				*result_length1 = _tmp11__length1;
#line 842 "Orientation.c"
			}
#line 213 "../src/Orientation.vala"
			result = _tmp11_;
#line 213 "../src/Orientation.vala"
			return result;
#line 848 "Orientation.c"
		}
#line 194 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 852 "Orientation.c"
		{
			Rotation* _tmp12_;
			Rotation* _tmp13_;
			gint _tmp13__length1;
#line 216 "../src/Orientation.vala"
			_tmp12_ = g_new0 (Rotation, 2);
#line 216 "../src/Orientation.vala"
			_tmp12_[0] = ROTATION_CLOCKWISE;
#line 216 "../src/Orientation.vala"
			_tmp12_[1] = ROTATION_UPSIDE_DOWN;
#line 216 "../src/Orientation.vala"
			_tmp13_ = _tmp12_;
#line 216 "../src/Orientation.vala"
			_tmp13__length1 = 2;
#line 216 "../src/Orientation.vala"
			if (result_length1) {
#line 216 "../src/Orientation.vala"
				*result_length1 = _tmp13__length1;
#line 871 "Orientation.c"
			}
#line 216 "../src/Orientation.vala"
			result = _tmp13_;
#line 216 "../src/Orientation.vala"
			return result;
#line 877 "Orientation.c"
		}
#line 194 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 881 "Orientation.c"
		{
			Rotation* _tmp14_;
			Rotation* _tmp15_;
			gint _tmp15__length1;
#line 219 "../src/Orientation.vala"
			_tmp14_ = g_new0 (Rotation, 1);
#line 219 "../src/Orientation.vala"
			_tmp14_[0] = ROTATION_COUNTERCLOCKWISE;
#line 219 "../src/Orientation.vala"
			_tmp15_ = _tmp14_;
#line 219 "../src/Orientation.vala"
			_tmp15__length1 = 1;
#line 219 "../src/Orientation.vala"
			if (result_length1) {
#line 219 "../src/Orientation.vala"
				*result_length1 = _tmp15__length1;
#line 898 "Orientation.c"
			}
#line 219 "../src/Orientation.vala"
			result = _tmp15_;
#line 219 "../src/Orientation.vala"
			return result;
#line 904 "Orientation.c"
		}
		default:
		{
#line 222 "../src/Orientation.vala"
			g_error ("Orientation.vala:222: to_rotations: %d", (gint) self);
#line 910 "Orientation.c"
		}
	}
}

void
orientation_rotate_dimensions (Orientation self,
                               Dimensions* dim,
                               Dimensions* result)
{
#line 226 "../src/Orientation.vala"
	g_return_if_fail (dim != NULL);
#line 227 "../src/Orientation.vala"
	switch (self) {
#line 227 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 227 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 227 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 227 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 932 "Orientation.c"
		{
			Dimensions _tmp0_;
#line 233 "../src/Orientation.vala"
			_tmp0_ = *dim;
#line 233 "../src/Orientation.vala"
			*result = _tmp0_;
#line 233 "../src/Orientation.vala"
			return;
#line 941 "Orientation.c"
		}
#line 227 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 227 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 227 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 227 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 951 "Orientation.c"
		{
			Dimensions _tmp1_;
			Dimensions _tmp2_;
			Dimensions _tmp3_ = {0};
#line 240 "../src/Orientation.vala"
			_tmp1_ = *dim;
#line 240 "../src/Orientation.vala"
			_tmp2_ = *dim;
#line 240 "../src/Orientation.vala"
			dimensions_init (&_tmp3_, _tmp1_.height, _tmp2_.width);
#line 240 "../src/Orientation.vala"
			*result = _tmp3_;
#line 240 "../src/Orientation.vala"
			return;
#line 966 "Orientation.c"
		}
		default:
		{
#line 243 "../src/Orientation.vala"
			g_error ("Orientation.vala:243: rotate_dimensions: %d", (gint) self);
#line 972 "Orientation.c"
		}
	}
}

void
orientation_derotate_dimensions (Orientation self,
                                 Dimensions* dim,
                                 Dimensions* result)
{
	Dimensions _tmp0_;
	Dimensions _tmp1_ = {0};
#line 247 "../src/Orientation.vala"
	g_return_if_fail (dim != NULL);
#line 248 "../src/Orientation.vala"
	_tmp0_ = *dim;
#line 248 "../src/Orientation.vala"
	orientation_rotate_dimensions (self, &_tmp0_, &_tmp1_);
#line 248 "../src/Orientation.vala"
	*result = _tmp1_;
#line 248 "../src/Orientation.vala"
	return;
#line 994 "Orientation.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 256 "../src/Orientation.vala"
	return self ? g_object_ref (self) : NULL;
#line 1002 "Orientation.c"
}

GdkPixbuf*
orientation_rotate_pixbuf (Orientation self,
                           GdkPixbuf* pixbuf)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* rotated = NULL;
#line 251 "../src/Orientation.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 253 "../src/Orientation.vala"
	switch (self) {
#line 253 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1017 "Orientation.c"
		{
			GdkPixbuf* _tmp0_;
#line 256 "../src/Orientation.vala"
			_tmp0_ = _g_object_ref0 (pixbuf);
#line 256 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 256 "../src/Orientation.vala"
			rotated = _tmp0_;
#line 257 "../src/Orientation.vala"
			break;
#line 1028 "Orientation.c"
		}
#line 253 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1032 "Orientation.c"
		{
			GdkPixbuf* _tmp1_;
#line 261 "../src/Orientation.vala"
			_tmp1_ = gdk_pixbuf_flip (pixbuf, TRUE);
#line 261 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 261 "../src/Orientation.vala"
			rotated = _tmp1_;
#line 262 "../src/Orientation.vala"
			break;
#line 1043 "Orientation.c"
		}
#line 253 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1047 "Orientation.c"
		{
			GdkPixbuf* _tmp2_;
#line 265 "../src/Orientation.vala"
			_tmp2_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_UPSIDEDOWN);
#line 265 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 265 "../src/Orientation.vala"
			rotated = _tmp2_;
#line 266 "../src/Orientation.vala"
			break;
#line 1058 "Orientation.c"
		}
#line 253 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1062 "Orientation.c"
		{
			GdkPixbuf* _tmp3_;
#line 270 "../src/Orientation.vala"
			_tmp3_ = gdk_pixbuf_flip (pixbuf, FALSE);
#line 270 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 270 "../src/Orientation.vala"
			rotated = _tmp3_;
#line 271 "../src/Orientation.vala"
			break;
#line 1073 "Orientation.c"
		}
#line 253 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1077 "Orientation.c"
		{
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 274 "../src/Orientation.vala"
			_tmp4_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 274 "../src/Orientation.vala"
			_tmp5_ = _tmp4_;
#line 274 "../src/Orientation.vala"
			_tmp6_ = gdk_pixbuf_flip (_tmp5_, FALSE);
#line 274 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 274 "../src/Orientation.vala"
			rotated = _tmp6_;
#line 274 "../src/Orientation.vala"
			_g_object_unref0 (_tmp5_);
#line 275 "../src/Orientation.vala"
			break;
#line 1096 "Orientation.c"
		}
#line 253 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1100 "Orientation.c"
		{
			GdkPixbuf* _tmp7_;
#line 278 "../src/Orientation.vala"
			_tmp7_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 278 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 278 "../src/Orientation.vala"
			rotated = _tmp7_;
#line 279 "../src/Orientation.vala"
			break;
#line 1111 "Orientation.c"
		}
#line 253 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1115 "Orientation.c"
		{
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
#line 282 "../src/Orientation.vala"
			_tmp8_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 282 "../src/Orientation.vala"
			_tmp9_ = _tmp8_;
#line 282 "../src/Orientation.vala"
			_tmp10_ = gdk_pixbuf_flip (_tmp9_, FALSE);
#line 282 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 282 "../src/Orientation.vala"
			rotated = _tmp10_;
#line 282 "../src/Orientation.vala"
			_g_object_unref0 (_tmp9_);
#line 283 "../src/Orientation.vala"
			break;
#line 1134 "Orientation.c"
		}
#line 253 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1138 "Orientation.c"
		{
			GdkPixbuf* _tmp11_;
#line 286 "../src/Orientation.vala"
			_tmp11_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 286 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 286 "../src/Orientation.vala"
			rotated = _tmp11_;
#line 287 "../src/Orientation.vala"
			break;
#line 1149 "Orientation.c"
		}
		default:
		{
#line 290 "../src/Orientation.vala"
			g_error ("Orientation.vala:290: rotate_pixbuf: %d", (gint) self);
#line 1155 "Orientation.c"
		}
	}
#line 293 "../src/Orientation.vala"
	result = rotated;
#line 293 "../src/Orientation.vala"
	return result;
#line 1162 "Orientation.c"
}

void
orientation_rotate_point (Orientation self,
                          Dimensions* space,
                          GdkPoint* point,
                          GdkPoint* result)
{
	GdkPoint _tmp0_;
	GdkPoint _tmp1_;
	Dimensions _tmp2_;
	GdkPoint _tmp3_;
	GdkPoint _tmp4_;
	Dimensions _tmp5_;
	GdkPoint rotated = {0};
#line 297 "../src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 297 "../src/Orientation.vala"
	g_return_if_fail (point != NULL);
#line 298 "../src/Orientation.vala"
	_vala_assert (dimensions_has_area (space), "space.has_area()");
#line 299 "../src/Orientation.vala"
	_tmp0_ = *point;
#line 299 "../src/Orientation.vala"
	_vala_assert (_tmp0_.x >= 0, "point.x >= 0");
#line 300 "../src/Orientation.vala"
	_tmp1_ = *point;
#line 300 "../src/Orientation.vala"
	_tmp2_ = *space;
#line 300 "../src/Orientation.vala"
	_vala_assert (_tmp1_.x < _tmp2_.width, "point.x < space.width");
#line 301 "../src/Orientation.vala"
	_tmp3_ = *point;
#line 301 "../src/Orientation.vala"
	_vala_assert (_tmp3_.y >= 0, "point.y >= 0");
#line 302 "../src/Orientation.vala"
	_tmp4_ = *point;
#line 302 "../src/Orientation.vala"
	_tmp5_ = *space;
#line 302 "../src/Orientation.vala"
	_vala_assert (_tmp4_.y < _tmp5_.height, "point.y < space.height");
#line 304 "../src/Orientation.vala"
	memset (&rotated, 0, sizeof (GdkPoint));
#line 306 "../src/Orientation.vala"
	switch (self) {
#line 306 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1210 "Orientation.c"
		{
			GdkPoint _tmp6_;
#line 309 "../src/Orientation.vala"
			_tmp6_ = *point;
#line 309 "../src/Orientation.vala"
			rotated = _tmp6_;
#line 310 "../src/Orientation.vala"
			break;
#line 1219 "Orientation.c"
		}
#line 306 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1223 "Orientation.c"
		{
			Dimensions _tmp7_;
			GdkPoint _tmp8_;
			GdkPoint _tmp9_;
#line 314 "../src/Orientation.vala"
			_tmp7_ = *space;
#line 314 "../src/Orientation.vala"
			_tmp8_ = *point;
#line 314 "../src/Orientation.vala"
			rotated.x = (_tmp7_.width - _tmp8_.x) - 1;
#line 315 "../src/Orientation.vala"
			_tmp9_ = *point;
#line 315 "../src/Orientation.vala"
			rotated.y = _tmp9_.y;
#line 316 "../src/Orientation.vala"
			break;
#line 1240 "Orientation.c"
		}
#line 306 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1244 "Orientation.c"
		{
			Dimensions _tmp10_;
			GdkPoint _tmp11_;
			Dimensions _tmp12_;
			GdkPoint _tmp13_;
#line 320 "../src/Orientation.vala"
			_tmp10_ = *space;
#line 320 "../src/Orientation.vala"
			_tmp11_ = *point;
#line 320 "../src/Orientation.vala"
			rotated.x = (_tmp10_.width - _tmp11_.x) - 1;
#line 321 "../src/Orientation.vala"
			_tmp12_ = *space;
#line 321 "../src/Orientation.vala"
			_tmp13_ = *point;
#line 321 "../src/Orientation.vala"
			rotated.y = (_tmp12_.height - _tmp13_.y) - 1;
#line 322 "../src/Orientation.vala"
			break;
#line 1264 "Orientation.c"
		}
#line 306 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1268 "Orientation.c"
		{
			GdkPoint _tmp14_;
			Dimensions _tmp15_;
			GdkPoint _tmp16_;
#line 326 "../src/Orientation.vala"
			_tmp14_ = *point;
#line 326 "../src/Orientation.vala"
			rotated.x = _tmp14_.x;
#line 327 "../src/Orientation.vala"
			_tmp15_ = *space;
#line 327 "../src/Orientation.vala"
			_tmp16_ = *point;
#line 327 "../src/Orientation.vala"
			rotated.y = (_tmp15_.height - _tmp16_.y) - 1;
#line 328 "../src/Orientation.vala"
			break;
#line 1285 "Orientation.c"
		}
#line 306 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1289 "Orientation.c"
		{
			GdkPoint _tmp17_;
			GdkPoint _tmp18_;
#line 332 "../src/Orientation.vala"
			_tmp17_ = *point;
#line 332 "../src/Orientation.vala"
			rotated.x = _tmp17_.y;
#line 333 "../src/Orientation.vala"
			_tmp18_ = *point;
#line 333 "../src/Orientation.vala"
			rotated.y = _tmp18_.x;
#line 334 "../src/Orientation.vala"
			break;
#line 1303 "Orientation.c"
		}
#line 306 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1307 "Orientation.c"
		{
			Dimensions _tmp19_;
			GdkPoint _tmp20_;
			GdkPoint _tmp21_;
#line 338 "../src/Orientation.vala"
			_tmp19_ = *space;
#line 338 "../src/Orientation.vala"
			_tmp20_ = *point;
#line 338 "../src/Orientation.vala"
			rotated.x = (_tmp19_.height - _tmp20_.y) - 1;
#line 339 "../src/Orientation.vala"
			_tmp21_ = *point;
#line 339 "../src/Orientation.vala"
			rotated.y = _tmp21_.x;
#line 340 "../src/Orientation.vala"
			break;
#line 1324 "Orientation.c"
		}
#line 306 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1328 "Orientation.c"
		{
			Dimensions _tmp22_;
			GdkPoint _tmp23_;
			Dimensions _tmp24_;
			GdkPoint _tmp25_;
#line 344 "../src/Orientation.vala"
			_tmp22_ = *space;
#line 344 "../src/Orientation.vala"
			_tmp23_ = *point;
#line 344 "../src/Orientation.vala"
			rotated.x = (_tmp22_.height - _tmp23_.y) - 1;
#line 345 "../src/Orientation.vala"
			_tmp24_ = *space;
#line 345 "../src/Orientation.vala"
			_tmp25_ = *point;
#line 345 "../src/Orientation.vala"
			rotated.y = (_tmp24_.width - _tmp25_.x) - 1;
#line 346 "../src/Orientation.vala"
			break;
#line 1348 "Orientation.c"
		}
#line 306 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1352 "Orientation.c"
		{
			GdkPoint _tmp26_;
			Dimensions _tmp27_;
			GdkPoint _tmp28_;
#line 350 "../src/Orientation.vala"
			_tmp26_ = *point;
#line 350 "../src/Orientation.vala"
			rotated.x = _tmp26_.y;
#line 351 "../src/Orientation.vala"
			_tmp27_ = *space;
#line 351 "../src/Orientation.vala"
			_tmp28_ = *point;
#line 351 "../src/Orientation.vala"
			rotated.y = (_tmp27_.width - _tmp28_.x) - 1;
#line 352 "../src/Orientation.vala"
			break;
#line 1369 "Orientation.c"
		}
		default:
		{
#line 355 "../src/Orientation.vala"
			g_error ("Orientation.vala:355: rotate_point: %d", (gint) self);
#line 1375 "Orientation.c"
		}
	}
#line 358 "../src/Orientation.vala"
	*result = rotated;
#line 358 "../src/Orientation.vala"
	return;
#line 1382 "Orientation.c"
}

void
orientation_derotate_point (Orientation self,
                            Dimensions* space,
                            GdkPoint* point,
                            GdkPoint* result)
{
	GdkPoint derotated = {0};
#line 362 "../src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 362 "../src/Orientation.vala"
	g_return_if_fail (point != NULL);
#line 363 "../src/Orientation.vala"
	_vala_assert (dimensions_has_area (space), "space.has_area()");
#line 365 "../src/Orientation.vala"
	memset (&derotated, 0, sizeof (GdkPoint));
#line 367 "../src/Orientation.vala"
	switch (self) {
#line 367 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1404 "Orientation.c"
		{
			GdkPoint _tmp0_;
#line 370 "../src/Orientation.vala"
			_tmp0_ = *point;
#line 370 "../src/Orientation.vala"
			derotated = _tmp0_;
#line 371 "../src/Orientation.vala"
			break;
#line 1413 "Orientation.c"
		}
#line 367 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1417 "Orientation.c"
		{
			Dimensions _tmp1_;
			GdkPoint _tmp2_;
			GdkPoint _tmp3_;
#line 375 "../src/Orientation.vala"
			_tmp1_ = *space;
#line 375 "../src/Orientation.vala"
			_tmp2_ = *point;
#line 375 "../src/Orientation.vala"
			derotated.x = (_tmp1_.width - _tmp2_.x) - 1;
#line 376 "../src/Orientation.vala"
			_tmp3_ = *point;
#line 376 "../src/Orientation.vala"
			derotated.y = _tmp3_.y;
#line 377 "../src/Orientation.vala"
			break;
#line 1434 "Orientation.c"
		}
#line 367 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1438 "Orientation.c"
		{
			Dimensions _tmp4_;
			GdkPoint _tmp5_;
			Dimensions _tmp6_;
			GdkPoint _tmp7_;
#line 381 "../src/Orientation.vala"
			_tmp4_ = *space;
#line 381 "../src/Orientation.vala"
			_tmp5_ = *point;
#line 381 "../src/Orientation.vala"
			derotated.x = (_tmp4_.width - _tmp5_.x) - 1;
#line 382 "../src/Orientation.vala"
			_tmp6_ = *space;
#line 382 "../src/Orientation.vala"
			_tmp7_ = *point;
#line 382 "../src/Orientation.vala"
			derotated.y = (_tmp6_.height - _tmp7_.y) - 1;
#line 383 "../src/Orientation.vala"
			break;
#line 1458 "Orientation.c"
		}
#line 367 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1462 "Orientation.c"
		{
			GdkPoint _tmp8_;
			Dimensions _tmp9_;
			GdkPoint _tmp10_;
#line 387 "../src/Orientation.vala"
			_tmp8_ = *point;
#line 387 "../src/Orientation.vala"
			derotated.x = _tmp8_.x;
#line 388 "../src/Orientation.vala"
			_tmp9_ = *space;
#line 388 "../src/Orientation.vala"
			_tmp10_ = *point;
#line 388 "../src/Orientation.vala"
			derotated.y = (_tmp9_.height - _tmp10_.y) - 1;
#line 389 "../src/Orientation.vala"
			break;
#line 1479 "Orientation.c"
		}
#line 367 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1483 "Orientation.c"
		{
			GdkPoint _tmp11_;
			GdkPoint _tmp12_;
#line 393 "../src/Orientation.vala"
			_tmp11_ = *point;
#line 393 "../src/Orientation.vala"
			derotated.x = _tmp11_.y;
#line 394 "../src/Orientation.vala"
			_tmp12_ = *point;
#line 394 "../src/Orientation.vala"
			derotated.y = _tmp12_.x;
#line 395 "../src/Orientation.vala"
			break;
#line 1497 "Orientation.c"
		}
#line 367 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1501 "Orientation.c"
		{
			GdkPoint _tmp13_;
			Dimensions _tmp14_;
			GdkPoint _tmp15_;
#line 399 "../src/Orientation.vala"
			_tmp13_ = *point;
#line 399 "../src/Orientation.vala"
			derotated.x = _tmp13_.y;
#line 400 "../src/Orientation.vala"
			_tmp14_ = *space;
#line 400 "../src/Orientation.vala"
			_tmp15_ = *point;
#line 400 "../src/Orientation.vala"
			derotated.y = (_tmp14_.height - _tmp15_.x) - 1;
#line 401 "../src/Orientation.vala"
			break;
#line 1518 "Orientation.c"
		}
#line 367 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1522 "Orientation.c"
		{
			Dimensions _tmp16_;
			GdkPoint _tmp17_;
			Dimensions _tmp18_;
			GdkPoint _tmp19_;
#line 405 "../src/Orientation.vala"
			_tmp16_ = *space;
#line 405 "../src/Orientation.vala"
			_tmp17_ = *point;
#line 405 "../src/Orientation.vala"
			derotated.x = (_tmp16_.width - _tmp17_.y) - 1;
#line 406 "../src/Orientation.vala"
			_tmp18_ = *space;
#line 406 "../src/Orientation.vala"
			_tmp19_ = *point;
#line 406 "../src/Orientation.vala"
			derotated.y = (_tmp18_.height - _tmp19_.x) - 1;
#line 407 "../src/Orientation.vala"
			break;
#line 1542 "Orientation.c"
		}
#line 367 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1546 "Orientation.c"
		{
			Dimensions _tmp20_;
			GdkPoint _tmp21_;
			GdkPoint _tmp22_;
#line 411 "../src/Orientation.vala"
			_tmp20_ = *space;
#line 411 "../src/Orientation.vala"
			_tmp21_ = *point;
#line 411 "../src/Orientation.vala"
			derotated.x = (_tmp20_.width - _tmp21_.y) - 1;
#line 412 "../src/Orientation.vala"
			_tmp22_ = *point;
#line 412 "../src/Orientation.vala"
			derotated.y = _tmp22_.x;
#line 413 "../src/Orientation.vala"
			break;
#line 1563 "Orientation.c"
		}
		default:
		{
#line 416 "../src/Orientation.vala"
			g_error ("Orientation.vala:416: rotate_point: %d", (gint) self);
#line 1569 "Orientation.c"
		}
	}
#line 419 "../src/Orientation.vala"
	*result = derotated;
#line 419 "../src/Orientation.vala"
	return;
#line 1576 "Orientation.c"
}

void
orientation_rotate_box (Orientation self,
                        Dimensions* space,
                        Box* box,
                        Box* result)
{
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	GdkPoint _tmp2_;
	Dimensions _tmp3_;
	GdkPoint _tmp4_;
	Dimensions _tmp5_;
	GdkPoint _tmp6_;
	Dimensions _tmp7_;
	GdkPoint _tmp8_;
	Dimensions _tmp9_;
	Dimensions _tmp10_;
	GdkPoint _tmp11_;
	GdkPoint _tmp12_ = {0};
	Dimensions _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_ = {0};
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
	Box _tmp18_ = {0};
#line 423 "../src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 423 "../src/Orientation.vala"
	g_return_if_fail (box != NULL);
#line 425 "../src/Orientation.vala"
	box_get_points (box, &_tmp0_, &_tmp1_);
#line 425 "../src/Orientation.vala"
	top_left = _tmp0_;
#line 425 "../src/Orientation.vala"
	bottom_right = _tmp1_;
#line 427 "../src/Orientation.vala"
	_tmp2_ = top_left;
#line 427 "../src/Orientation.vala"
	_tmp3_ = *space;
#line 427 "../src/Orientation.vala"
	top_left.x = CLAMP (_tmp2_.x, 0, _tmp3_.width - 1);
#line 428 "../src/Orientation.vala"
	_tmp4_ = top_left;
#line 428 "../src/Orientation.vala"
	_tmp5_ = *space;
#line 428 "../src/Orientation.vala"
	top_left.y = CLAMP (_tmp4_.y, 0, _tmp5_.height - 1);
#line 430 "../src/Orientation.vala"
	_tmp6_ = bottom_right;
#line 430 "../src/Orientation.vala"
	_tmp7_ = *space;
#line 430 "../src/Orientation.vala"
	bottom_right.x = CLAMP (_tmp6_.x, 0, _tmp7_.width - 1);
#line 431 "../src/Orientation.vala"
	_tmp8_ = bottom_right;
#line 431 "../src/Orientation.vala"
	_tmp9_ = *space;
#line 431 "../src/Orientation.vala"
	bottom_right.y = CLAMP (_tmp8_.y, 0, _tmp9_.height - 1);
#line 433 "../src/Orientation.vala"
	_tmp10_ = *space;
#line 433 "../src/Orientation.vala"
	_tmp11_ = top_left;
#line 433 "../src/Orientation.vala"
	orientation_rotate_point (self, &_tmp10_, &_tmp11_, &_tmp12_);
#line 433 "../src/Orientation.vala"
	top_left = _tmp12_;
#line 434 "../src/Orientation.vala"
	_tmp13_ = *space;
#line 434 "../src/Orientation.vala"
	_tmp14_ = bottom_right;
#line 434 "../src/Orientation.vala"
	orientation_rotate_point (self, &_tmp13_, &_tmp14_, &_tmp15_);
#line 434 "../src/Orientation.vala"
	bottom_right = _tmp15_;
#line 436 "../src/Orientation.vala"
	_tmp16_ = top_left;
#line 436 "../src/Orientation.vala"
	_tmp17_ = bottom_right;
#line 436 "../src/Orientation.vala"
	box_from_points (&_tmp16_, &_tmp17_, &_tmp18_);
#line 436 "../src/Orientation.vala"
	*result = _tmp18_;
#line 436 "../src/Orientation.vala"
	return;
#line 1666 "Orientation.c"
}

void
orientation_derotate_box (Orientation self,
                          Dimensions* space,
                          Box* box,
                          Box* result)
{
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Dimensions _tmp2_;
	GdkPoint _tmp3_;
	GdkPoint _tmp4_ = {0};
	Dimensions _tmp5_;
	GdkPoint _tmp6_;
	GdkPoint _tmp7_ = {0};
	GdkPoint _tmp8_;
	GdkPoint _tmp9_;
	Box _tmp10_ = {0};
#line 440 "../src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 440 "../src/Orientation.vala"
	g_return_if_fail (box != NULL);
#line 442 "../src/Orientation.vala"
	box_get_points (box, &_tmp0_, &_tmp1_);
#line 442 "../src/Orientation.vala"
	top_left = _tmp0_;
#line 442 "../src/Orientation.vala"
	bottom_right = _tmp1_;
#line 444 "../src/Orientation.vala"
	_tmp2_ = *space;
#line 444 "../src/Orientation.vala"
	_tmp3_ = top_left;
#line 444 "../src/Orientation.vala"
	orientation_derotate_point (self, &_tmp2_, &_tmp3_, &_tmp4_);
#line 444 "../src/Orientation.vala"
	top_left = _tmp4_;
#line 445 "../src/Orientation.vala"
	_tmp5_ = *space;
#line 445 "../src/Orientation.vala"
	_tmp6_ = bottom_right;
#line 445 "../src/Orientation.vala"
	orientation_derotate_point (self, &_tmp5_, &_tmp6_, &_tmp7_);
#line 445 "../src/Orientation.vala"
	bottom_right = _tmp7_;
#line 447 "../src/Orientation.vala"
	_tmp8_ = top_left;
#line 447 "../src/Orientation.vala"
	_tmp9_ = bottom_right;
#line 447 "../src/Orientation.vala"
	box_from_points (&_tmp8_, &_tmp9_, &_tmp10_);
#line 447 "../src/Orientation.vala"
	*result = _tmp10_;
#line 447 "../src/Orientation.vala"
	return;
#line 1724 "Orientation.c"
}

GType
orientation_get_type (void)
{
	static volatile gsize orientation_type_id__volatile = 0;
	if (g_once_init_enter (&orientation_type_id__volatile)) {
		static const GEnumValue values[] = {{ORIENTATION_MIN, "ORIENTATION_MIN", "min"}, {ORIENTATION_TOP_LEFT, "ORIENTATION_TOP_LEFT", "top-left"}, {ORIENTATION_TOP_RIGHT, "ORIENTATION_TOP_RIGHT", "top-right"}, {ORIENTATION_BOTTOM_RIGHT, "ORIENTATION_BOTTOM_RIGHT", "bottom-right"}, {ORIENTATION_BOTTOM_LEFT, "ORIENTATION_BOTTOM_LEFT", "bottom-left"}, {ORIENTATION_LEFT_TOP, "ORIENTATION_LEFT_TOP", "left-top"}, {ORIENTATION_RIGHT_TOP, "ORIENTATION_RIGHT_TOP", "right-top"}, {ORIENTATION_RIGHT_BOTTOM, "ORIENTATION_RIGHT_BOTTOM", "right-bottom"}, {ORIENTATION_LEFT_BOTTOM, "ORIENTATION_LEFT_BOTTOM", "left-bottom"}, {ORIENTATION_MAX, "ORIENTATION_MAX", "max"}, {0, NULL, NULL}};
		GType orientation_type_id;
		orientation_type_id = g_enum_register_static ("Orientation", values);
		g_once_init_leave (&orientation_type_id__volatile, orientation_type_id);
	}
	return orientation_type_id__volatile;
}

GdkPixbuf*
rotation_perform (Rotation self,
                  GdkPixbuf* pixbuf)
{
	GdkPixbuf* result = NULL;
#line 457 "../src/Orientation.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 458 "../src/Orientation.vala"
	switch (self) {
#line 458 "../src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 1751 "Orientation.c"
		{
			GdkPixbuf* _tmp0_;
#line 460 "../src/Orientation.vala"
			_tmp0_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 460 "../src/Orientation.vala"
			result = _tmp0_;
#line 460 "../src/Orientation.vala"
			return result;
#line 1760 "Orientation.c"
		}
#line 458 "../src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 1764 "Orientation.c"
		{
			GdkPixbuf* _tmp1_;
#line 463 "../src/Orientation.vala"
			_tmp1_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 463 "../src/Orientation.vala"
			result = _tmp1_;
#line 463 "../src/Orientation.vala"
			return result;
#line 1773 "Orientation.c"
		}
#line 458 "../src/Orientation.vala"
		case ROTATION_MIRROR:
#line 1777 "Orientation.c"
		{
			GdkPixbuf* _tmp2_;
#line 466 "../src/Orientation.vala"
			_tmp2_ = gdk_pixbuf_flip (pixbuf, TRUE);
#line 466 "../src/Orientation.vala"
			result = _tmp2_;
#line 466 "../src/Orientation.vala"
			return result;
#line 1786 "Orientation.c"
		}
#line 458 "../src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 1790 "Orientation.c"
		{
			GdkPixbuf* _tmp3_;
#line 469 "../src/Orientation.vala"
			_tmp3_ = gdk_pixbuf_flip (pixbuf, FALSE);
#line 469 "../src/Orientation.vala"
			result = _tmp3_;
#line 469 "../src/Orientation.vala"
			return result;
#line 1799 "Orientation.c"
		}
		default:
		{
#line 472 "../src/Orientation.vala"
			g_error ("Orientation.vala:472: Unknown rotation: %d", (gint) self);
#line 1805 "Orientation.c"
		}
	}
}

Rotation
rotation_opposite (Rotation self)
{
	Rotation result = 0;
#line 477 "../src/Orientation.vala"
	switch (self) {
#line 477 "../src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 1818 "Orientation.c"
		{
#line 479 "../src/Orientation.vala"
			result = ROTATION_COUNTERCLOCKWISE;
#line 479 "../src/Orientation.vala"
			return result;
#line 1824 "Orientation.c"
		}
#line 477 "../src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 1828 "Orientation.c"
		{
#line 482 "../src/Orientation.vala"
			result = ROTATION_CLOCKWISE;
#line 482 "../src/Orientation.vala"
			return result;
#line 1834 "Orientation.c"
		}
#line 477 "../src/Orientation.vala"
		case ROTATION_MIRROR:
#line 477 "../src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 1840 "Orientation.c"
		{
#line 486 "../src/Orientation.vala"
			result = self;
#line 486 "../src/Orientation.vala"
			return result;
#line 1846 "Orientation.c"
		}
		default:
		{
#line 489 "../src/Orientation.vala"
			g_error ("Orientation.vala:489: Unknown rotation: %d", (gint) self);
#line 1852 "Orientation.c"
		}
	}
}

GType
rotation_get_type (void)
{
	static volatile gsize rotation_type_id__volatile = 0;
	if (g_once_init_enter (&rotation_type_id__volatile)) {
		static const GEnumValue values[] = {{ROTATION_CLOCKWISE, "ROTATION_CLOCKWISE", "clockwise"}, {ROTATION_COUNTERCLOCKWISE, "ROTATION_COUNTERCLOCKWISE", "counterclockwise"}, {ROTATION_MIRROR, "ROTATION_MIRROR", "mirror"}, {ROTATION_UPSIDE_DOWN, "ROTATION_UPSIDE_DOWN", "upside-down"}, {0, NULL, NULL}};
		GType rotation_type_id;
		rotation_type_id = g_enum_register_static ("Rotation", values);
		g_once_init_leave (&rotation_type_id__volatile, rotation_type_id);
	}
	return rotation_type_id__volatile;
}

