/* DatabaseTable.c generated by valac 0.44.3, the Vala compiler
 * generated from DatabaseTable.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
typedef struct _ParamSpecDatabaseTable ParamSpecDatabaseTable;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _ParamSpecDatabaseTable {
	GParamSpec parent_instance;
};

static gpointer database_table_parent_class = NULL;
extern sqlite3* database_table_db;
sqlite3* database_table_db = NULL;
static gint database_table_in_transaction;
static gint database_table_in_transaction = 0;

GQuark database_error_quark (void);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
#define DATABASE_TABLE_SCHEMA_VERSION 22
static void database_table_prepare_db (const gchar* filename);
void app_window_panic (const gchar* msg);
#define DB_IN_MEMORY_NAME ":memory:"
void database_table_on_trace (const gchar* message);
static void _database_table_on_trace_sqlite_trace_callback (gpointer self,
                                                     const gchar* message);
void database_table_init (const gchar* filename);
void database_table_warning (const gchar* op,
                             gint res);
void database_table_terminate (void);
void database_table_fatal (const gchar* op,
                           gint res);
void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
gboolean database_table_exists_by_id (DatabaseTable* self,
                                      gint64 id);
gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt* * stmt);
static void database_table_prepare_update_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          sqlite3_stmt* * stmt);
static gboolean database_table_execute_update_by_id (DatabaseTable* self,
                                              sqlite3_stmt* stmt);
gboolean database_table_update_text_by_id (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           const gchar* text);
void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
gboolean database_table_update_int_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint value);
void database_table_update_int_by_id_2 (DatabaseTable* self,
                                        gint64 id,
                                        const gchar* column,
                                        gint value,
                                        GError** error);
gboolean database_table_update_int64_by_id (DatabaseTable* self,
                                            gint64 id,
                                            const gchar* column,
                                            gint64 value);
void database_table_update_int64_by_id_2 (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint64 value,
                                          GError** error);
void database_table_update_double_by_id_2 (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           gdouble value,
                                           GError** error);
void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
gboolean database_table_has_column (const gchar* table_name,
                                    const gchar* column_name);
gboolean database_table_has_table (const gchar* table_name);
gboolean database_table_add_column (const gchar* table_name,
                                    const gchar* column_name,
                                    const gchar* column_constraints);
gboolean database_table_ensure_column (const gchar* table_name,
                                       const gchar* column_name,
                                       const gchar* column_constraints,
                                       const gchar* upgrade_msg);
gint database_table_get_row_count (DatabaseTable* self);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
DatabaseTable* database_table_construct (GType object_type);
static void database_table_finalize (DatabaseTable * obj);

GQuark
database_error_quark (void)
{
	return g_quark_from_static_string ("database-error-quark");
}

static void
_database_table_on_trace_sqlite_trace_callback (gpointer self,
                                                const gchar* message)
{
#line 57 "../src/db/DatabaseTable.vala"
	database_table_on_trace (message);
#line 181 "DatabaseTable.c"
}

static void
database_table_prepare_db (const gchar* filename)
{
	gint res = 0;
	sqlite3* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* sql_debug = NULL;
	const gchar* _tmp14_;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 32 "../src/db/DatabaseTable.vala"
	g_return_if_fail (filename != NULL);
#line 34 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_open_v2 (filename, &_tmp0_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 34 "../src/db/DatabaseTable.vala"
	_sqlite3_close0 (database_table_db);
#line 34 "../src/db/DatabaseTable.vala"
	database_table_db = _tmp0_;
#line 34 "../src/db/DatabaseTable.vala"
	res = _tmp1_;
#line 36 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_OK) {
#line 207 "DatabaseTable.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 37 "../src/db/DatabaseTable.vala"
		_tmp2_ = g_strdup_printf (_ ("Unable to open/create photo database %s: error code %d"), filename, res);
#line 37 "../src/db/DatabaseTable.vala"
		_tmp3_ = _tmp2_;
#line 37 "../src/db/DatabaseTable.vala"
		app_window_panic (_tmp3_);
#line 37 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp3_);
#line 218 "DatabaseTable.c"
	}
#line 41 "../src/db/DatabaseTable.vala"
	if (g_strcmp0 (filename, DB_IN_MEMORY_NAME) != 0) {
#line 222 "DatabaseTable.c"
		{
			GFile* file_db = NULL;
			GFile* _tmp4_;
			GFileInfo* info = NULL;
			GFile* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
#line 43 "../src/db/DatabaseTable.vala"
			_tmp4_ = g_file_new_for_path (filename);
#line 43 "../src/db/DatabaseTable.vala"
			file_db = _tmp4_;
#line 44 "../src/db/DatabaseTable.vala"
			_tmp5_ = file_db;
#line 44 "../src/db/DatabaseTable.vala"
			_tmp6_ = g_file_query_info (_tmp5_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 44 "../src/db/DatabaseTable.vala"
			info = _tmp6_;
#line 44 "../src/db/DatabaseTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 44 "../src/db/DatabaseTable.vala"
				_g_object_unref0 (file_db);
#line 244 "DatabaseTable.c"
				goto __catch17_g_error;
			}
#line 45 "../src/db/DatabaseTable.vala"
			_tmp7_ = info;
#line 45 "../src/db/DatabaseTable.vala"
			if (!g_file_info_get_attribute_boolean (_tmp7_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE)) {
#line 251 "DatabaseTable.c"
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 46 "../src/db/DatabaseTable.vala"
				_tmp8_ = g_strdup_printf (_ ("Unable to write to photo database file:\n %s"), filename);
#line 46 "../src/db/DatabaseTable.vala"
				_tmp9_ = _tmp8_;
#line 46 "../src/db/DatabaseTable.vala"
				app_window_panic (_tmp9_);
#line 46 "../src/db/DatabaseTable.vala"
				_g_free0 (_tmp9_);
#line 262 "DatabaseTable.c"
			}
#line 42 "../src/db/DatabaseTable.vala"
			_g_object_unref0 (info);
#line 42 "../src/db/DatabaseTable.vala"
			_g_object_unref0 (file_db);
#line 268 "DatabaseTable.c"
		}
		goto __finally17;
		__catch17_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 42 "../src/db/DatabaseTable.vala"
			e = _inner_error0_;
#line 42 "../src/db/DatabaseTable.vala"
			_inner_error0_ = NULL;
#line 48 "../src/db/DatabaseTable.vala"
			_tmp10_ = e;
#line 48 "../src/db/DatabaseTable.vala"
			_tmp11_ = _tmp10_->message;
#line 48 "../src/db/DatabaseTable.vala"
			_tmp12_ = g_strdup_printf (_ ("Error accessing database file:\n %s\n\nError was: \n%s"), filename, _tmp11_);
#line 48 "../src/db/DatabaseTable.vala"
			_tmp13_ = _tmp12_;
#line 48 "../src/db/DatabaseTable.vala"
			app_window_panic (_tmp13_);
#line 48 "../src/db/DatabaseTable.vala"
			_g_free0 (_tmp13_);
#line 42 "../src/db/DatabaseTable.vala"
			_g_error_free0 (e);
#line 296 "DatabaseTable.c"
		}
		__finally17:
#line 42 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 42 "../src/db/DatabaseTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 42 "../src/db/DatabaseTable.vala"
			g_clear_error (&_inner_error0_);
#line 42 "../src/db/DatabaseTable.vala"
			return;
#line 307 "DatabaseTable.c"
		}
	}
#line 53 "../src/db/DatabaseTable.vala"
	_tmp14_ = g_getenv ("SHOTWELL_SQL_DEBUG");
#line 53 "../src/db/DatabaseTable.vala"
	sql_debug = _tmp14_;
#line 56 "../src/db/DatabaseTable.vala"
	_tmp16_ = sql_debug;
#line 56 "../src/db/DatabaseTable.vala"
	if (_tmp16_ != NULL) {
#line 318 "DatabaseTable.c"
		const gchar* _tmp17_;
#line 56 "../src/db/DatabaseTable.vala"
		_tmp17_ = sql_debug;
#line 56 "../src/db/DatabaseTable.vala"
		_tmp15_ = g_strcmp0 (_tmp17_, "") != 0;
#line 324 "DatabaseTable.c"
	} else {
#line 56 "../src/db/DatabaseTable.vala"
		_tmp15_ = FALSE;
#line 328 "DatabaseTable.c"
	}
#line 56 "../src/db/DatabaseTable.vala"
	if (_tmp15_) {
#line 332 "DatabaseTable.c"
		sqlite3* _tmp18_;
#line 57 "../src/db/DatabaseTable.vala"
		_tmp18_ = database_table_db;
#line 57 "../src/db/DatabaseTable.vala"
		sqlite3_trace (_tmp18_, _database_table_on_trace_sqlite_trace_callback, NULL);
#line 338 "DatabaseTable.c"
	}
}

void
database_table_on_trace (const gchar* message)
{
#line 61 "../src/db/DatabaseTable.vala"
	g_return_if_fail (message != NULL);
#line 62 "../src/db/DatabaseTable.vala"
	g_debug ("DatabaseTable.vala:62: SQLITE: %s", message);
#line 349 "DatabaseTable.c"
}

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar* * errmsg)
{
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "sqlite3.vapi"
	ec = _tmp1_;
#line 37 "sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 378 "DatabaseTable.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 389 "DatabaseTable.c"
	}
#line 40 "sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 40 "sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 41 "sqlite3.vapi"
	result = ec;
#line 41 "sqlite3.vapi"
	if (errmsg) {
#line 41 "sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 401 "DatabaseTable.c"
	} else {
#line 41 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 405 "DatabaseTable.c"
	}
#line 41 "sqlite3.vapi"
	return result;
#line 409 "DatabaseTable.c"
}

void
database_table_init (const gchar* filename)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 65 "../src/db/DatabaseTable.vala"
	g_return_if_fail (filename != NULL);
#line 67 "../src/db/DatabaseTable.vala"
	database_table_prepare_db (filename);
#line 71 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 71 "../src/db/DatabaseTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS VersionTable (" "id INTEGER PRIMARY KEY, " "schema_version INTEGER, " "app_version TEXT, " "user_data TEXT NULL" ")", -1, &_tmp1_, NULL);
#line 71 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 71 "../src/db/DatabaseTable.vala"
	stmt = _tmp1_;
#line 71 "../src/db/DatabaseTable.vala"
	res = _tmp2_;
#line 79 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_OK) {
#line 438 "DatabaseTable.c"
		gchar* backup_path = NULL;
		gchar* _tmp3_;
#line 80 "../src/db/DatabaseTable.vala"
		_sqlite3_close0 (database_table_db);
#line 80 "../src/db/DatabaseTable.vala"
		database_table_db = NULL;
#line 82 "../src/db/DatabaseTable.vala"
		_tmp3_ = g_strconcat (filename, ".bak", NULL);
#line 82 "../src/db/DatabaseTable.vala"
		backup_path = _tmp3_;
#line 449 "DatabaseTable.c"
		{
			GFile* src = NULL;
			const gchar* _tmp4_;
			GFile* _tmp5_;
			GFile* dest = NULL;
			GFile* _tmp6_;
			GFile* _tmp7_;
			GFile* _tmp8_;
#line 85 "../src/db/DatabaseTable.vala"
			_tmp4_ = backup_path;
#line 85 "../src/db/DatabaseTable.vala"
			_tmp5_ = g_file_new_for_commandline_arg (_tmp4_);
#line 85 "../src/db/DatabaseTable.vala"
			src = _tmp5_;
#line 86 "../src/db/DatabaseTable.vala"
			_tmp6_ = g_file_new_for_commandline_arg (filename);
#line 86 "../src/db/DatabaseTable.vala"
			dest = _tmp6_;
#line 87 "../src/db/DatabaseTable.vala"
			_tmp7_ = src;
#line 87 "../src/db/DatabaseTable.vala"
			_tmp8_ = dest;
#line 87 "../src/db/DatabaseTable.vala"
			g_file_copy (_tmp7_, _tmp8_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error0_);
#line 87 "../src/db/DatabaseTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../src/db/DatabaseTable.vala"
				_g_object_unref0 (dest);
#line 87 "../src/db/DatabaseTable.vala"
				_g_object_unref0 (src);
#line 480 "DatabaseTable.c"
				goto __catch18_g_error;
			}
#line 90 "../src/db/DatabaseTable.vala"
			database_table_prepare_db (filename);
#line 84 "../src/db/DatabaseTable.vala"
			_g_object_unref0 (dest);
#line 84 "../src/db/DatabaseTable.vala"
			_g_object_unref0 (src);
#line 489 "DatabaseTable.c"
		}
		goto __finally18;
		__catch18_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 84 "../src/db/DatabaseTable.vala"
			_error_ = _inner_error0_;
#line 84 "../src/db/DatabaseTable.vala"
			_inner_error0_ = NULL;
#line 92 "../src/db/DatabaseTable.vala"
			_tmp9_ = _error_;
#line 92 "../src/db/DatabaseTable.vala"
			_tmp10_ = _tmp9_->message;
#line 92 "../src/db/DatabaseTable.vala"
			_tmp11_ = g_strdup_printf (_ ("Unable to restore photo database %s"), _tmp10_);
#line 92 "../src/db/DatabaseTable.vala"
			_tmp12_ = _tmp11_;
#line 92 "../src/db/DatabaseTable.vala"
			app_window_panic (_tmp12_);
#line 92 "../src/db/DatabaseTable.vala"
			_g_free0 (_tmp12_);
#line 84 "../src/db/DatabaseTable.vala"
			_g_error_free0 (_error_);
#line 517 "DatabaseTable.c"
		}
		__finally18:
#line 84 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../src/db/DatabaseTable.vala"
			_g_free0 (backup_path);
#line 84 "../src/db/DatabaseTable.vala"
			_sqlite3_finalize0 (stmt);
#line 84 "../src/db/DatabaseTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../src/db/DatabaseTable.vala"
			g_clear_error (&_inner_error0_);
#line 84 "../src/db/DatabaseTable.vala"
			return;
#line 532 "DatabaseTable.c"
		}
#line 79 "../src/db/DatabaseTable.vala"
		_g_free0 (backup_path);
#line 536 "DatabaseTable.c"
	}
#line 98 "../src/db/DatabaseTable.vala"
	_tmp13_ = database_table_db;
#line 98 "../src/db/DatabaseTable.vala"
	res = _sqlite3_exec (_tmp13_, "PRAGMA synchronous=OFF", NULL, NULL, NULL);
#line 99 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_OK) {
#line 100 "../src/db/DatabaseTable.vala"
		database_table_warning ("Unable to disable synchronous mode", res);
#line 546 "DatabaseTable.c"
	}
#line 65 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 550 "DatabaseTable.c"
}

void
database_table_terminate (void)
{
#line 105 "../src/db/DatabaseTable.vala"
	_sqlite3_close0 (database_table_db);
#line 105 "../src/db/DatabaseTable.vala"
	database_table_db = NULL;
#line 560 "DatabaseTable.c"
}

void
database_table_fatal (const gchar* op,
                      gint res)
{
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
#line 109 "../src/db/DatabaseTable.vala"
	g_return_if_fail (op != NULL);
#line 110 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 110 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 110 "../src/db/DatabaseTable.vala"
	g_error ("DatabaseTable.vala:110: %s: [%d] %s", op, res, _tmp1_);
#line 577 "DatabaseTable.c"
}

void
database_table_warning (const gchar* op,
                        gint res)
{
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
#line 114 "../src/db/DatabaseTable.vala"
	g_return_if_fail (op != NULL);
#line 115 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 115 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 115 "../src/db/DatabaseTable.vala"
	g_warning ("DatabaseTable.vala:115: %s: [%d] %s", op, res, _tmp1_);
#line 594 "DatabaseTable.c"
}

void
database_table_set_table_name (DatabaseTable* self,
                               const gchar* table_name)
{
	gchar* _tmp0_;
#line 118 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 118 "../src/db/DatabaseTable.vala"
	g_return_if_fail (table_name != NULL);
#line 119 "../src/db/DatabaseTable.vala"
	_tmp0_ = g_strdup (table_name);
#line 119 "../src/db/DatabaseTable.vala"
	_g_free0 (self->table_name);
#line 119 "../src/db/DatabaseTable.vala"
	self->table_name = _tmp0_;
#line 612 "DatabaseTable.c"
}

void
database_table_throw_error (const gchar* method,
                            gint res,
                            GError** error)
{
	gchar* msg = NULL;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 124 "../src/db/DatabaseTable.vala"
	g_return_if_fail (method != NULL);
#line 125 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 125 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 125 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("(%s) [%d] - %s", method, res, _tmp1_);
#line 125 "../src/db/DatabaseTable.vala"
	msg = _tmp2_;
#line 127 "../src/db/DatabaseTable.vala"
	switch (res) {
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_OK:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_DONE:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_ROW:
#line 643 "DatabaseTable.c"
		{
#line 131 "../src/db/DatabaseTable.vala"
			_g_free0 (msg);
#line 131 "../src/db/DatabaseTable.vala"
			return;
#line 649 "DatabaseTable.c"
		}
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_PERM:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_BUSY:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_READONLY:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_IOERR:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_CORRUPT:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_CANTOPEN:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_NOLFS:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_AUTH:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_FORMAT:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_NOTADB:
#line 671 "DatabaseTable.c"
		{
			const gchar* _tmp3_;
			GError* _tmp4_;
#line 143 "../src/db/DatabaseTable.vala"
			_tmp3_ = msg;
#line 143 "../src/db/DatabaseTable.vala"
			_tmp4_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_BACKING, _tmp3_);
#line 143 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp4_;
#line 143 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 143 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 143 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 143 "../src/db/DatabaseTable.vala"
				return;
#line 689 "DatabaseTable.c"
			} else {
#line 143 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 143 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 143 "../src/db/DatabaseTable.vala"
				return;
#line 699 "DatabaseTable.c"
			}
		}
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_NOMEM:
#line 704 "DatabaseTable.c"
		{
			const gchar* _tmp5_;
			GError* _tmp6_;
#line 146 "../src/db/DatabaseTable.vala"
			_tmp5_ = msg;
#line 146 "../src/db/DatabaseTable.vala"
			_tmp6_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_MEMORY, _tmp5_);
#line 146 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp6_;
#line 146 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 146 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 146 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 146 "../src/db/DatabaseTable.vala"
				return;
#line 722 "DatabaseTable.c"
			} else {
#line 146 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 146 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 146 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 146 "../src/db/DatabaseTable.vala"
				return;
#line 732 "DatabaseTable.c"
			}
		}
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_ABORT:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_LOCKED:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_INTERRUPT:
#line 741 "DatabaseTable.c"
		{
			const gchar* _tmp7_;
			GError* _tmp8_;
#line 151 "../src/db/DatabaseTable.vala"
			_tmp7_ = msg;
#line 151 "../src/db/DatabaseTable.vala"
			_tmp8_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ABORT, _tmp7_);
#line 151 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp8_;
#line 151 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 151 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 151 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 151 "../src/db/DatabaseTable.vala"
				return;
#line 759 "DatabaseTable.c"
			} else {
#line 151 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 151 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 151 "../src/db/DatabaseTable.vala"
				return;
#line 769 "DatabaseTable.c"
			}
		}
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_FULL:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_EMPTY:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_TOOBIG:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_CONSTRAINT:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_RANGE:
#line 782 "DatabaseTable.c"
		{
			const gchar* _tmp9_;
			GError* _tmp10_;
#line 158 "../src/db/DatabaseTable.vala"
			_tmp9_ = msg;
#line 158 "../src/db/DatabaseTable.vala"
			_tmp10_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_LIMITS, _tmp9_);
#line 158 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp10_;
#line 158 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 158 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 158 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 158 "../src/db/DatabaseTable.vala"
				return;
#line 800 "DatabaseTable.c"
			} else {
#line 158 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 158 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 158 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 158 "../src/db/DatabaseTable.vala"
				return;
#line 810 "DatabaseTable.c"
			}
		}
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_SCHEMA:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_MISMATCH:
#line 817 "DatabaseTable.c"
		{
			const gchar* _tmp11_;
			GError* _tmp12_;
#line 162 "../src/db/DatabaseTable.vala"
			_tmp11_ = msg;
#line 162 "../src/db/DatabaseTable.vala"
			_tmp12_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_TYPESPEC, _tmp11_);
#line 162 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp12_;
#line 162 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 162 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 162 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 162 "../src/db/DatabaseTable.vala"
				return;
#line 835 "DatabaseTable.c"
			} else {
#line 162 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 162 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 162 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 162 "../src/db/DatabaseTable.vala"
				return;
#line 845 "DatabaseTable.c"
			}
		}
		default:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_ERROR:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_INTERNAL:
#line 127 "../src/db/DatabaseTable.vala"
		case SQLITE_MISUSE:
#line 855 "DatabaseTable.c"
		{
			const gchar* _tmp13_;
			GError* _tmp14_;
#line 168 "../src/db/DatabaseTable.vala"
			_tmp13_ = msg;
#line 168 "../src/db/DatabaseTable.vala"
			_tmp14_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ERROR, _tmp13_);
#line 168 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp14_;
#line 168 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 168 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 168 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 168 "../src/db/DatabaseTable.vala"
				return;
#line 873 "DatabaseTable.c"
			} else {
#line 168 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 168 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 168 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 168 "../src/db/DatabaseTable.vala"
				return;
#line 883 "DatabaseTable.c"
			}
		}
	}
#line 124 "../src/db/DatabaseTable.vala"
	_g_free0 (msg);
#line 889 "DatabaseTable.c"
}

gboolean
database_table_exists_by_id (DatabaseTable* self,
                             gint64 id)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	gboolean _tmp9_ = FALSE;
#line 172 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 174 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 174 "../src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 174 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT id FROM %s WHERE id=?", _tmp1_);
#line 174 "../src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 174 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 174 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 174 "../src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 174 "../src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 174 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 174 "../src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 175 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 177 "../src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 177 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 1, id);
#line 178 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 180 "../src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 180 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp8_);
#line 181 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_ROW) {
#line 181 "../src/db/DatabaseTable.vala"
		_tmp9_ = res != SQLITE_DONE;
#line 947 "DatabaseTable.c"
	} else {
#line 181 "../src/db/DatabaseTable.vala"
		_tmp9_ = FALSE;
#line 951 "DatabaseTable.c"
	}
#line 181 "../src/db/DatabaseTable.vala"
	if (_tmp9_) {
#line 955 "DatabaseTable.c"
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 182 "../src/db/DatabaseTable.vala"
		_tmp10_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
#line 182 "../src/db/DatabaseTable.vala"
		_tmp11_ = _tmp10_;
#line 182 "../src/db/DatabaseTable.vala"
		_tmp12_ = self->table_name;
#line 182 "../src/db/DatabaseTable.vala"
		_tmp13_ = g_strdup_printf ("exists_by_id [%s] %s", _tmp11_, _tmp12_);
#line 182 "../src/db/DatabaseTable.vala"
		_tmp14_ = _tmp13_;
#line 182 "../src/db/DatabaseTable.vala"
		database_table_fatal (_tmp14_, res);
#line 182 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp14_);
#line 182 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp11_);
#line 977 "DatabaseTable.c"
	}
#line 184 "../src/db/DatabaseTable.vala"
	result = res == SQLITE_ROW;
#line 184 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 184 "../src/db/DatabaseTable.vala"
	return result;
#line 985 "DatabaseTable.c"
}

gboolean
database_table_select_by_id (DatabaseTable* self,
                             gint64 id,
                             const gchar* columns,
                             sqlite3_stmt* * stmt)
{
	sqlite3_stmt* _vala_stmt = NULL;
	gboolean result = FALSE;
	gchar* sql = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint res = 0;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp7_;
	gboolean _tmp8_ = FALSE;
#line 187 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 187 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (columns != NULL, FALSE);
#line 188 "../src/db/DatabaseTable.vala"
	_tmp0_ = self->table_name;
#line 188 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("SELECT %s FROM %s WHERE id=?", columns, _tmp0_);
#line 188 "../src/db/DatabaseTable.vala"
	sql = _tmp1_;
#line 190 "../src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 190 "../src/db/DatabaseTable.vala"
	_tmp3_ = sql;
#line 190 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp2_, _tmp3_, -1, &_tmp4_, NULL);
#line 190 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (_vala_stmt);
#line 190 "../src/db/DatabaseTable.vala"
	_vala_stmt = _tmp4_;
#line 190 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 191 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 193 "../src/db/DatabaseTable.vala"
	_tmp6_ = _vala_stmt;
#line 193 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 1, id);
#line 194 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 196 "../src/db/DatabaseTable.vala"
	_tmp7_ = _vala_stmt;
#line 196 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp7_);
#line 197 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_ROW) {
#line 197 "../src/db/DatabaseTable.vala"
		_tmp8_ = res != SQLITE_DONE;
#line 1045 "DatabaseTable.c"
	} else {
#line 197 "../src/db/DatabaseTable.vala"
		_tmp8_ = FALSE;
#line 1049 "DatabaseTable.c"
	}
#line 197 "../src/db/DatabaseTable.vala"
	if (_tmp8_) {
#line 1053 "DatabaseTable.c"
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 198 "../src/db/DatabaseTable.vala"
		_tmp9_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
#line 198 "../src/db/DatabaseTable.vala"
		_tmp10_ = _tmp9_;
#line 198 "../src/db/DatabaseTable.vala"
		_tmp11_ = self->table_name;
#line 198 "../src/db/DatabaseTable.vala"
		_tmp12_ = g_strdup_printf ("select_by_id [%s] %s %s", _tmp10_, _tmp11_, columns);
#line 198 "../src/db/DatabaseTable.vala"
		_tmp13_ = _tmp12_;
#line 198 "../src/db/DatabaseTable.vala"
		database_table_fatal (_tmp13_, res);
#line 198 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp13_);
#line 198 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp10_);
#line 1075 "DatabaseTable.c"
	}
#line 200 "../src/db/DatabaseTable.vala"
	result = res == SQLITE_ROW;
#line 200 "../src/db/DatabaseTable.vala"
	_g_free0 (sql);
#line 200 "../src/db/DatabaseTable.vala"
	if (stmt) {
#line 200 "../src/db/DatabaseTable.vala"
		*stmt = _vala_stmt;
#line 1085 "DatabaseTable.c"
	} else {
#line 200 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (_vala_stmt);
#line 1089 "DatabaseTable.c"
	}
#line 200 "../src/db/DatabaseTable.vala"
	return result;
#line 1093 "DatabaseTable.c"
}

static void
database_table_prepare_update_by_id (DatabaseTable* self,
                                     gint64 id,
                                     const gchar* column,
                                     sqlite3_stmt* * stmt)
{
	sqlite3_stmt* _vala_stmt = NULL;
	gchar* sql = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint res = 0;
	sqlite3* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
#line 204 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 204 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 205 "../src/db/DatabaseTable.vala"
	_tmp0_ = self->table_name;
#line 205 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("UPDATE %s SET %s=? WHERE id=?", _tmp0_, column);
#line 205 "../src/db/DatabaseTable.vala"
	sql = _tmp1_;
#line 207 "../src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 207 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp2_, sql, -1, &_tmp3_, NULL);
#line 207 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (_vala_stmt);
#line 207 "../src/db/DatabaseTable.vala"
	_vala_stmt = _tmp3_;
#line 207 "../src/db/DatabaseTable.vala"
	res = _tmp4_;
#line 208 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 210 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_vala_stmt, 2, id);
#line 211 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 204 "../src/db/DatabaseTable.vala"
	_g_free0 (sql);
#line 204 "../src/db/DatabaseTable.vala"
	if (stmt) {
#line 204 "../src/db/DatabaseTable.vala"
		*stmt = _vala_stmt;
#line 1142 "DatabaseTable.c"
	} else {
#line 204 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (_vala_stmt);
#line 1146 "DatabaseTable.c"
	}
}

static gboolean
database_table_execute_update_by_id (DatabaseTable* self,
                                     sqlite3_stmt* stmt)
{
	gboolean result = FALSE;
	gint res = 0;
#line 214 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 214 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (stmt != NULL, FALSE);
#line 215 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (stmt);
#line 216 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 217 "../src/db/DatabaseTable.vala"
		database_table_fatal ("execute_update_by_id", res);
#line 219 "../src/db/DatabaseTable.vala"
		result = FALSE;
#line 219 "../src/db/DatabaseTable.vala"
		return result;
#line 1170 "DatabaseTable.c"
	}
#line 222 "../src/db/DatabaseTable.vala"
	result = TRUE;
#line 222 "../src/db/DatabaseTable.vala"
	return result;
#line 1176 "DatabaseTable.c"
}

gboolean
database_table_update_text_by_id (DatabaseTable* self,
                                  gint64 id,
                                  const gchar* column,
                                  const gchar* text)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	gchar* _tmp1_;
	GDestroyNotify _tmp2_;
#line 225 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 225 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 225 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 227 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 227 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 227 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 229 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup (text);
#line 229 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_free;
#line 229 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_text (stmt, 1, _tmp1_, -1, _tmp2_);
#line 230 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 232 "../src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 232 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 232 "../src/db/DatabaseTable.vala"
	return result;
#line 1217 "DatabaseTable.c"
}

void
database_table_update_text_by_id_2 (DatabaseTable* self,
                                    gint64 id,
                                    const gchar* column,
                                    const gchar* text,
                                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gchar* _tmp2_;
	GDestroyNotify _tmp3_;
	sqlite3_stmt* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 235 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 235 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 235 "../src/db/DatabaseTable.vala"
	g_return_if_fail (text != NULL);
#line 237 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 237 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 237 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 239 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 239 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup (text);
#line 239 "../src/db/DatabaseTable.vala"
	_tmp3_ = g_free;
#line 239 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_text (_tmp1_, 1, _tmp2_, -1, _tmp3_);
#line 240 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 242 "../src/db/DatabaseTable.vala"
	_tmp4_ = stmt;
#line 242 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp4_);
#line 243 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1263 "DatabaseTable.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 244 "../src/db/DatabaseTable.vala"
		_tmp5_ = self->table_name;
#line 244 "../src/db/DatabaseTable.vala"
		_tmp6_ = g_strdup_printf ("DatabaseTable.update_text_by_id_2 %s.%s", _tmp5_, column);
#line 244 "../src/db/DatabaseTable.vala"
		_tmp7_ = _tmp6_;
#line 244 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp7_, res, &_inner_error0_);
#line 244 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp7_);
#line 244 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 244 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 244 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 244 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 244 "../src/db/DatabaseTable.vala"
				return;
#line 1287 "DatabaseTable.c"
			} else {
#line 244 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 244 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 244 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 244 "../src/db/DatabaseTable.vala"
				return;
#line 1297 "DatabaseTable.c"
			}
		}
	}
#line 235 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1303 "DatabaseTable.c"
}

gboolean
database_table_update_int_by_id (DatabaseTable* self,
                                 gint64 id,
                                 const gchar* column,
                                 gint value)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
#line 247 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 247 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 249 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 249 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 249 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 251 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int (stmt, 1, value);
#line 252 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 254 "../src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 254 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 254 "../src/db/DatabaseTable.vala"
	return result;
#line 1336 "DatabaseTable.c"
}

void
database_table_update_int_by_id_2 (DatabaseTable* self,
                                   gint64 id,
                                   const gchar* column,
                                   gint value,
                                   GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 257 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 257 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 259 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 259 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 259 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 261 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 261 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int (_tmp1_, 1, value);
#line 262 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 264 "../src/db/DatabaseTable.vala"
	_tmp2_ = stmt;
#line 264 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp2_);
#line 265 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1374 "DatabaseTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 266 "../src/db/DatabaseTable.vala"
		_tmp3_ = self->table_name;
#line 266 "../src/db/DatabaseTable.vala"
		_tmp4_ = g_strdup_printf ("DatabaseTable.update_int_by_id_2 %s.%s", _tmp3_, column);
#line 266 "../src/db/DatabaseTable.vala"
		_tmp5_ = _tmp4_;
#line 266 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp5_, res, &_inner_error0_);
#line 266 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp5_);
#line 266 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 266 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 266 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 266 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 266 "../src/db/DatabaseTable.vala"
				return;
#line 1398 "DatabaseTable.c"
			} else {
#line 266 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 266 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 266 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 266 "../src/db/DatabaseTable.vala"
				return;
#line 1408 "DatabaseTable.c"
			}
		}
	}
#line 257 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1414 "DatabaseTable.c"
}

gboolean
database_table_update_int64_by_id (DatabaseTable* self,
                                   gint64 id,
                                   const gchar* column,
                                   gint64 value)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
#line 269 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
#line 269 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 271 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 271 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 271 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 273 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (stmt, 1, value);
#line 274 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 276 "../src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 276 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 276 "../src/db/DatabaseTable.vala"
	return result;
#line 1447 "DatabaseTable.c"
}

void
database_table_update_int64_by_id_2 (DatabaseTable* self,
                                     gint64 id,
                                     const gchar* column,
                                     gint64 value,
                                     GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 279 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 279 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 281 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 281 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 281 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 283 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 283 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp1_, 1, value);
#line 284 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 286 "../src/db/DatabaseTable.vala"
	_tmp2_ = stmt;
#line 286 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp2_);
#line 287 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1485 "DatabaseTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 288 "../src/db/DatabaseTable.vala"
		_tmp3_ = self->table_name;
#line 288 "../src/db/DatabaseTable.vala"
		_tmp4_ = g_strdup_printf ("DatabaseTable.update_int64_by_id_2 %s.%s", _tmp3_, column);
#line 288 "../src/db/DatabaseTable.vala"
		_tmp5_ = _tmp4_;
#line 288 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp5_, res, &_inner_error0_);
#line 288 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp5_);
#line 288 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 288 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 288 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 288 "../src/db/DatabaseTable.vala"
				return;
#line 1509 "DatabaseTable.c"
			} else {
#line 288 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 288 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 288 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 288 "../src/db/DatabaseTable.vala"
				return;
#line 1519 "DatabaseTable.c"
			}
		}
	}
#line 279 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1525 "DatabaseTable.c"
}

void
database_table_update_double_by_id_2 (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* column,
                                      gdouble value,
                                      GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 291 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 291 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 293 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 293 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 293 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 295 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 295 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_double (_tmp1_, 1, value);
#line 296 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 298 "../src/db/DatabaseTable.vala"
	_tmp2_ = stmt;
#line 298 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp2_);
#line 299 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1563 "DatabaseTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 300 "../src/db/DatabaseTable.vala"
		_tmp3_ = self->table_name;
#line 300 "../src/db/DatabaseTable.vala"
		_tmp4_ = g_strdup_printf ("DatabaseTable.update_double_by_id_2 %s.%s", _tmp3_, column);
#line 300 "../src/db/DatabaseTable.vala"
		_tmp5_ = _tmp4_;
#line 300 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp5_, res, &_inner_error0_);
#line 300 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp5_);
#line 300 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 300 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 300 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 300 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 300 "../src/db/DatabaseTable.vala"
				return;
#line 1587 "DatabaseTable.c"
			} else {
#line 300 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 300 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 300 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 300 "../src/db/DatabaseTable.vala"
				return;
#line 1597 "DatabaseTable.c"
			}
		}
	}
#line 291 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1603 "DatabaseTable.c"
}

void
database_table_delete_by_id (DatabaseTable* self,
                             gint64 id,
                             GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 303 "../src/db/DatabaseTable.vala"
	g_return_if_fail (IS_DATABASE_TABLE (self));
#line 305 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 305 "../src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 305 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("DELETE FROM %s WHERE id=?", _tmp1_);
#line 305 "../src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 305 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 305 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 305 "../src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 305 "../src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 305 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 305 "../src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 306 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 308 "../src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 308 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 1, id);
#line 309 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 311 "../src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 311 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp8_);
#line 312 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1659 "DatabaseTable.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 313 "../src/db/DatabaseTable.vala"
		_tmp9_ = self->table_name;
#line 313 "../src/db/DatabaseTable.vala"
		_tmp10_ = g_strdup_printf ("%s.remove", _tmp9_);
#line 313 "../src/db/DatabaseTable.vala"
		_tmp11_ = _tmp10_;
#line 313 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp11_, res, &_inner_error0_);
#line 313 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp11_);
#line 313 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 313 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 313 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 313 "../src/db/DatabaseTable.vala"
				return;
#line 1683 "DatabaseTable.c"
			} else {
#line 313 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 313 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 313 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 313 "../src/db/DatabaseTable.vala"
				return;
#line 1693 "DatabaseTable.c"
			}
		}
	}
#line 303 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1699 "DatabaseTable.c"
}

gboolean
database_table_has_column (const gchar* table_name,
                           const gchar* column_name)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
#line 316 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 316 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 318 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 318 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("PRAGMA table_info(%s)", table_name);
#line 318 "../src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 318 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 318 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 318 "../src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 318 "../src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 318 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 318 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 319 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1739 "DatabaseTable.c"
	{
		gboolean _tmp6_ = FALSE;
#line 321 "../src/db/DatabaseTable.vala"
		_tmp6_ = TRUE;
#line 321 "../src/db/DatabaseTable.vala"
		while (TRUE) {
#line 1746 "DatabaseTable.c"
			sqlite3_stmt* _tmp7_;
#line 321 "../src/db/DatabaseTable.vala"
			if (!_tmp6_) {
#line 1750 "DatabaseTable.c"
			}
#line 321 "../src/db/DatabaseTable.vala"
			_tmp6_ = FALSE;
#line 322 "../src/db/DatabaseTable.vala"
			_tmp7_ = stmt;
#line 322 "../src/db/DatabaseTable.vala"
			res = sqlite3_step (_tmp7_);
#line 323 "../src/db/DatabaseTable.vala"
			if (res == SQLITE_DONE) {
#line 324 "../src/db/DatabaseTable.vala"
				break;
#line 1762 "DatabaseTable.c"
			} else {
#line 325 "../src/db/DatabaseTable.vala"
				if (res != SQLITE_ROW) {
#line 1766 "DatabaseTable.c"
					gchar* _tmp8_;
					gchar* _tmp9_;
#line 326 "../src/db/DatabaseTable.vala"
					_tmp8_ = g_strdup_printf ("has_column %s", table_name);
#line 326 "../src/db/DatabaseTable.vala"
					_tmp9_ = _tmp8_;
#line 326 "../src/db/DatabaseTable.vala"
					database_table_fatal (_tmp9_, res);
#line 326 "../src/db/DatabaseTable.vala"
					_g_free0 (_tmp9_);
#line 328 "../src/db/DatabaseTable.vala"
					break;
#line 1779 "DatabaseTable.c"
				} else {
					gchar* column = NULL;
					sqlite3_stmt* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gboolean _tmp13_ = FALSE;
					const gchar* _tmp14_;
#line 330 "../src/db/DatabaseTable.vala"
					_tmp10_ = stmt;
#line 330 "../src/db/DatabaseTable.vala"
					_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 1);
#line 330 "../src/db/DatabaseTable.vala"
					_tmp12_ = g_strdup (_tmp11_);
#line 330 "../src/db/DatabaseTable.vala"
					column = _tmp12_;
#line 331 "../src/db/DatabaseTable.vala"
					_tmp14_ = column;
#line 331 "../src/db/DatabaseTable.vala"
					if (_tmp14_ != NULL) {
#line 1799 "DatabaseTable.c"
						const gchar* _tmp15_;
#line 331 "../src/db/DatabaseTable.vala"
						_tmp15_ = column;
#line 331 "../src/db/DatabaseTable.vala"
						_tmp13_ = g_strcmp0 (_tmp15_, column_name) == 0;
#line 1805 "DatabaseTable.c"
					} else {
#line 331 "../src/db/DatabaseTable.vala"
						_tmp13_ = FALSE;
#line 1809 "DatabaseTable.c"
					}
#line 331 "../src/db/DatabaseTable.vala"
					if (_tmp13_) {
#line 332 "../src/db/DatabaseTable.vala"
						result = TRUE;
#line 332 "../src/db/DatabaseTable.vala"
						_g_free0 (column);
#line 332 "../src/db/DatabaseTable.vala"
						_sqlite3_finalize0 (stmt);
#line 332 "../src/db/DatabaseTable.vala"
						return result;
#line 1821 "DatabaseTable.c"
					}
#line 325 "../src/db/DatabaseTable.vala"
					_g_free0 (column);
#line 1825 "DatabaseTable.c"
				}
			}
		}
	}
#line 336 "../src/db/DatabaseTable.vala"
	result = FALSE;
#line 336 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 336 "../src/db/DatabaseTable.vala"
	return result;
#line 1836 "DatabaseTable.c"
}

gboolean
database_table_has_table (const gchar* table_name)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
#line 339 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 341 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 341 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("PRAGMA table_info(%s)", table_name);
#line 341 "../src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 341 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 341 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 341 "../src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 341 "../src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 341 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 341 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 342 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 344 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (stmt);
#line 346 "../src/db/DatabaseTable.vala"
	result = res != SQLITE_DONE;
#line 346 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 346 "../src/db/DatabaseTable.vala"
	return result;
#line 1881 "DatabaseTable.c"
}

gboolean
database_table_add_column (const gchar* table_name,
                           const gchar* column_name,
                           const gchar* column_constraints)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
#line 349 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 349 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 349 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_constraints != NULL, FALSE);
#line 351 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 351 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("ALTER TABLE %s ADD COLUMN %s %s", table_name, column_name, column_constraints);
#line 351 "../src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 351 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 351 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 351 "../src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 351 "../src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 351 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 351 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 353 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 355 "../src/db/DatabaseTable.vala"
	_tmp6_ = stmt;
#line 355 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp6_);
#line 356 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1931 "DatabaseTable.c"
		sqlite3* _tmp7_;
		const gchar* _tmp8_;
#line 357 "../src/db/DatabaseTable.vala"
		_tmp7_ = database_table_db;
#line 357 "../src/db/DatabaseTable.vala"
		_tmp8_ = sqlite3_errmsg (_tmp7_);
#line 357 "../src/db/DatabaseTable.vala"
		g_critical ("DatabaseTable.vala:357: Unable to add column %s %s %s: (%d) %s", table_name, column_name, column_constraints, res, _tmp8_);
#line 360 "../src/db/DatabaseTable.vala"
		result = FALSE;
#line 360 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (stmt);
#line 360 "../src/db/DatabaseTable.vala"
		return result;
#line 1946 "DatabaseTable.c"
	}
#line 363 "../src/db/DatabaseTable.vala"
	result = TRUE;
#line 363 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 363 "../src/db/DatabaseTable.vala"
	return result;
#line 1954 "DatabaseTable.c"
}

gboolean
database_table_ensure_column (const gchar* table_name,
                              const gchar* column_name,
                              const gchar* column_constraints,
                              const gchar* upgrade_msg)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 369 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 369 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 369 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_constraints != NULL, FALSE);
#line 369 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (upgrade_msg != NULL, FALSE);
#line 371 "../src/db/DatabaseTable.vala"
	if (!database_table_has_table (table_name)) {
#line 371 "../src/db/DatabaseTable.vala"
		_tmp0_ = TRUE;
#line 1977 "DatabaseTable.c"
	} else {
#line 371 "../src/db/DatabaseTable.vala"
		_tmp0_ = database_table_has_column (table_name, column_name);
#line 1981 "DatabaseTable.c"
	}
#line 371 "../src/db/DatabaseTable.vala"
	if (_tmp0_) {
#line 372 "../src/db/DatabaseTable.vala"
		result = TRUE;
#line 372 "../src/db/DatabaseTable.vala"
		return result;
#line 1989 "DatabaseTable.c"
	}
#line 374 "../src/db/DatabaseTable.vala"
	g_message ("DatabaseTable.vala:374: %s", upgrade_msg);
#line 376 "../src/db/DatabaseTable.vala"
	result = database_table_add_column (table_name, column_name, column_constraints);
#line 376 "../src/db/DatabaseTable.vala"
	return result;
#line 1997 "DatabaseTable.c"
}

gint
database_table_get_row_count (DatabaseTable* self)
{
	gint result = 0;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp11_;
#line 379 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (IS_DATABASE_TABLE (self), 0);
#line 381 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 381 "../src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 381 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT COUNT(id) AS RowCount FROM %s", _tmp1_);
#line 381 "../src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 381 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 381 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 381 "../src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 381 "../src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 381 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 381 "../src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 382 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 384 "../src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 384 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp7_);
#line 385 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_ROW) {
#line 2045 "DatabaseTable.c"
		const gchar* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 386 "../src/db/DatabaseTable.vala"
		_tmp8_ = self->table_name;
#line 386 "../src/db/DatabaseTable.vala"
		_tmp9_ = database_table_db;
#line 386 "../src/db/DatabaseTable.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 386 "../src/db/DatabaseTable.vala"
		g_critical ("DatabaseTable.vala:386: Unable to retrieve row count on %s: (%d) %s", _tmp8_, res, _tmp10_);
#line 388 "../src/db/DatabaseTable.vala"
		result = 0;
#line 388 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (stmt);
#line 388 "../src/db/DatabaseTable.vala"
		return result;
#line 2063 "DatabaseTable.c"
	}
#line 391 "../src/db/DatabaseTable.vala"
	_tmp11_ = stmt;
#line 391 "../src/db/DatabaseTable.vala"
	result = sqlite3_column_int (_tmp11_, 0);
#line 391 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 391 "../src/db/DatabaseTable.vala"
	return result;
#line 2073 "DatabaseTable.c"
}

void
database_table_begin_transaction (void)
{
	gint _tmp0_;
	gint res = 0;
	sqlite3* _tmp1_;
#line 396 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_in_transaction;
#line 396 "../src/db/DatabaseTable.vala"
	database_table_in_transaction = _tmp0_ + 1;
#line 396 "../src/db/DatabaseTable.vala"
	if (_tmp0_ != 0) {
#line 397 "../src/db/DatabaseTable.vala"
		return;
#line 2090 "DatabaseTable.c"
	}
#line 399 "../src/db/DatabaseTable.vala"
	_tmp1_ = database_table_db;
#line 399 "../src/db/DatabaseTable.vala"
	res = _sqlite3_exec (_tmp1_, "BEGIN TRANSACTION", NULL, NULL, NULL);
#line 400 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2098 "DatabaseTable.c"
}

void
database_table_commit_transaction (GError** error)
{
	gint res = 0;
	sqlite3* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 405 "../src/db/DatabaseTable.vala"
	_vala_assert (database_table_in_transaction > 0, "in_transaction > 0");
#line 406 "../src/db/DatabaseTable.vala"
	database_table_in_transaction = database_table_in_transaction - 1;
#line 406 "../src/db/DatabaseTable.vala"
	if (database_table_in_transaction != 0) {
#line 407 "../src/db/DatabaseTable.vala"
		return;
#line 2115 "DatabaseTable.c"
	}
#line 409 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 409 "../src/db/DatabaseTable.vala"
	res = _sqlite3_exec (_tmp0_, "COMMIT TRANSACTION", NULL, NULL, NULL);
#line 410 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 411 "../src/db/DatabaseTable.vala"
		database_table_throw_error ("commit_transaction", res, &_inner_error0_);
#line 411 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 411 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 411 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 411 "../src/db/DatabaseTable.vala"
				return;
#line 2133 "DatabaseTable.c"
			} else {
#line 411 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 411 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 411 "../src/db/DatabaseTable.vala"
				return;
#line 2141 "DatabaseTable.c"
			}
		}
	}
}

DatabaseTable*
database_table_construct (GType object_type)
{
	DatabaseTable* self = NULL;
#line 16 "../src/db/DatabaseTable.vala"
	self = (DatabaseTable*) g_type_create_instance (object_type);
#line 16 "../src/db/DatabaseTable.vala"
	return self;
#line 2155 "DatabaseTable.c"
}

static void
value_database_table_init (GValue* value)
{
#line 16 "../src/db/DatabaseTable.vala"
	value->data[0].v_pointer = NULL;
#line 2163 "DatabaseTable.c"
}

static void
value_database_table_free_value (GValue* value)
{
#line 16 "../src/db/DatabaseTable.vala"
	if (value->data[0].v_pointer) {
#line 16 "../src/db/DatabaseTable.vala"
		database_table_unref (value->data[0].v_pointer);
#line 2173 "DatabaseTable.c"
	}
}

static void
value_database_table_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 16 "../src/db/DatabaseTable.vala"
	if (src_value->data[0].v_pointer) {
#line 16 "../src/db/DatabaseTable.vala"
		dest_value->data[0].v_pointer = database_table_ref (src_value->data[0].v_pointer);
#line 2185 "DatabaseTable.c"
	} else {
#line 16 "../src/db/DatabaseTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2189 "DatabaseTable.c"
	}
}

static gpointer
value_database_table_peek_pointer (const GValue* value)
{
#line 16 "../src/db/DatabaseTable.vala"
	return value->data[0].v_pointer;
#line 2198 "DatabaseTable.c"
}

static gchar*
value_database_table_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 16 "../src/db/DatabaseTable.vala"
	if (collect_values[0].v_pointer) {
#line 2209 "DatabaseTable.c"
		DatabaseTable * object;
		object = collect_values[0].v_pointer;
#line 16 "../src/db/DatabaseTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 16 "../src/db/DatabaseTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2216 "DatabaseTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 16 "../src/db/DatabaseTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2220 "DatabaseTable.c"
		}
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = database_table_ref (object);
#line 2224 "DatabaseTable.c"
	} else {
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2228 "DatabaseTable.c"
	}
#line 16 "../src/db/DatabaseTable.vala"
	return NULL;
#line 2232 "DatabaseTable.c"
}

static gchar*
value_database_table_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	DatabaseTable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 16 "../src/db/DatabaseTable.vala"
	if (!object_p) {
#line 16 "../src/db/DatabaseTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2247 "DatabaseTable.c"
	}
#line 16 "../src/db/DatabaseTable.vala"
	if (!value->data[0].v_pointer) {
#line 16 "../src/db/DatabaseTable.vala"
		*object_p = NULL;
#line 2253 "DatabaseTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 16 "../src/db/DatabaseTable.vala"
		*object_p = value->data[0].v_pointer;
#line 2257 "DatabaseTable.c"
	} else {
#line 16 "../src/db/DatabaseTable.vala"
		*object_p = database_table_ref (value->data[0].v_pointer);
#line 2261 "DatabaseTable.c"
	}
#line 16 "../src/db/DatabaseTable.vala"
	return NULL;
#line 2265 "DatabaseTable.c"
}

GParamSpec*
param_spec_database_table (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecDatabaseTable* spec;
#line 16 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATABASE_TABLE), NULL);
#line 16 "../src/db/DatabaseTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 16 "../src/db/DatabaseTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 16 "../src/db/DatabaseTable.vala"
	return G_PARAM_SPEC (spec);
#line 2284 "DatabaseTable.c"
}

gpointer
value_get_database_table (const GValue* value)
{
#line 16 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE), NULL);
#line 16 "../src/db/DatabaseTable.vala"
	return value->data[0].v_pointer;
#line 2294 "DatabaseTable.c"
}

void
value_set_database_table (GValue* value,
                          gpointer v_object)
{
	DatabaseTable * old;
#line 16 "../src/db/DatabaseTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
#line 16 "../src/db/DatabaseTable.vala"
	old = value->data[0].v_pointer;
#line 16 "../src/db/DatabaseTable.vala"
	if (v_object) {
#line 16 "../src/db/DatabaseTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
#line 16 "../src/db/DatabaseTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = v_object;
#line 16 "../src/db/DatabaseTable.vala"
		database_table_ref (value->data[0].v_pointer);
#line 2316 "DatabaseTable.c"
	} else {
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2320 "DatabaseTable.c"
	}
#line 16 "../src/db/DatabaseTable.vala"
	if (old) {
#line 16 "../src/db/DatabaseTable.vala"
		database_table_unref (old);
#line 2326 "DatabaseTable.c"
	}
}

void
value_take_database_table (GValue* value,
                           gpointer v_object)
{
	DatabaseTable * old;
#line 16 "../src/db/DatabaseTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
#line 16 "../src/db/DatabaseTable.vala"
	old = value->data[0].v_pointer;
#line 16 "../src/db/DatabaseTable.vala"
	if (v_object) {
#line 16 "../src/db/DatabaseTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
#line 16 "../src/db/DatabaseTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = v_object;
#line 2347 "DatabaseTable.c"
	} else {
#line 16 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2351 "DatabaseTable.c"
	}
#line 16 "../src/db/DatabaseTable.vala"
	if (old) {
#line 16 "../src/db/DatabaseTable.vala"
		database_table_unref (old);
#line 2357 "DatabaseTable.c"
	}
}

static void
database_table_class_init (DatabaseTableClass * klass,
                           gpointer klass_data)
{
#line 16 "../src/db/DatabaseTable.vala"
	database_table_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/db/DatabaseTable.vala"
	((DatabaseTableClass *) klass)->finalize = database_table_finalize;
#line 2369 "DatabaseTable.c"
}

static void
database_table_instance_init (DatabaseTable * self,
                              gpointer klass)
{
#line 30 "../src/db/DatabaseTable.vala"
	self->table_name = NULL;
#line 16 "../src/db/DatabaseTable.vala"
	self->ref_count = 1;
#line 2380 "DatabaseTable.c"
}

static void
database_table_finalize (DatabaseTable * obj)
{
	DatabaseTable * self;
#line 16 "../src/db/DatabaseTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATABASE_TABLE, DatabaseTable);
#line 16 "../src/db/DatabaseTable.vala"
	g_signal_handlers_destroy (self);
#line 30 "../src/db/DatabaseTable.vala"
	_g_free0 (self->table_name);
#line 2393 "DatabaseTable.c"
}

GType
database_table_get_type (void)
{
	static volatile gsize database_table_type_id__volatile = 0;
	if (g_once_init_enter (&database_table_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_database_table_init, value_database_table_free_value, value_database_table_copy_value, value_database_table_peek_pointer, "p", value_database_table_collect_value, "p", value_database_table_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseTable), 0, (GInstanceInitFunc) database_table_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType database_table_type_id;
		database_table_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DatabaseTable", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&database_table_type_id__volatile, database_table_type_id);
	}
	return database_table_type_id__volatile;
}

gpointer
database_table_ref (gpointer instance)
{
	DatabaseTable * self;
	self = instance;
#line 16 "../src/db/DatabaseTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 16 "../src/db/DatabaseTable.vala"
	return instance;
#line 2420 "DatabaseTable.c"
}

void
database_table_unref (gpointer instance)
{
	DatabaseTable * self;
	self = instance;
#line 16 "../src/db/DatabaseTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 16 "../src/db/DatabaseTable.vala"
		DATABASE_TABLE_GET_CLASS (self)->finalize (self);
#line 16 "../src/db/DatabaseTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2434 "DatabaseTable.c"
	}
}

