/* VideoTable.c generated by valac 0.44.3, the Vala compiler
 * generated from VideoTable.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>
#include <gee.h>
#include <gio/gio.h>

#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_VIDEO_ROW (video_row_get_type ())
#define VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_ROW, VideoRow))
#define VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_ROW, VideoRowClass))
#define IS_VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_ROW))
#define IS_VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_ROW))
#define VIDEO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_ROW, VideoRowClass))

typedef struct _VideoRow VideoRow;
typedef struct _VideoRowClass VideoRowClass;
typedef struct _VideoRowPrivate VideoRowPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecVideoRow ParamSpecVideoRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_VIDEO_TABLE (video_table_get_type ())
#define VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_TABLE, VideoTable))
#define VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_TABLE, VideoTableClass))
#define IS_VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_TABLE))
#define IS_VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_TABLE))
#define VIDEO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_TABLE, VideoTableClass))

typedef struct _VideoTable VideoTable;
typedef struct _VideoTableClass VideoTableClass;
typedef struct _VideoTablePrivate VideoTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _video_row_unref0(var) ((var == NULL) ? NULL : (var = (video_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _VideoID {
	gint64 id;
};

struct _ImportID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _VideoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoRowPrivate * priv;
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	time_t time_created;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	guint64 flags;
	gchar* comment;
};

struct _VideoRowClass {
	GTypeClass parent_class;
	void (*finalize) (VideoRow *self);
};

struct _ParamSpecVideoRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _VideoTable {
	DatabaseTable parent_instance;
	VideoTablePrivate * priv;
};

struct _VideoTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer video_row_parent_class = NULL;
static gpointer video_table_parent_class = NULL;
static VideoTable* video_table_instance;
static VideoTable* video_table_instance = NULL;
extern sqlite3* database_table_db;

GType video_id_get_type (void) G_GNUC_CONST;
VideoID* video_id_dup (const VideoID* self);
void video_id_free (VideoID* self);
#define VIDEO_ID_INVALID ((gint64) -1)
void video_id_init (VideoID *self,
                    gint64 id);
gboolean video_id_is_invalid (VideoID *self);
gboolean video_id_is_valid (VideoID *self);
guint video_id_hash (VideoID* a);
guint int64_hash (gint64* n);
gboolean video_id_equal (void* a,
                         void* b);
gchar* video_id_upgrade_video_id_to_source_id (VideoID* video_id);
#define VIDEO_TYPENAME "video"
gpointer video_row_ref (gpointer instance);
void video_row_unref (gpointer instance);
GParamSpec* param_spec_video_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_video_row (GValue* value,
                          gpointer v_object);
void value_take_video_row (GValue* value,
                           gpointer v_object);
gpointer value_get_video_row (const GValue* value);
GType video_row_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
GType rating_get_type (void) G_GNUC_CONST;
VideoRow* video_row_new (void);
VideoRow* video_row_construct (GType object_type);
static void video_row_finalize (VideoRow * obj);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType video_table_get_type (void) G_GNUC_CONST;
static VideoTable* video_table_new (void);
static VideoTable* video_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_fatal (const gchar* op,
                           gint res);
void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
VideoTable* video_table_get_instance (void);
GQuark database_error_quark (void);
void video_table_add (VideoTable* self,
                      VideoRow* video_row,
                      VideoID* result,
                      GError** error);
gulong now_sec (void);
#define EVENT_ID_INVALID ((gint64) -1)
void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
void event_id_init (EventID *self,
                    gint64 id);
gboolean video_table_drop_event (VideoTable* self,
                                 EventID* event_id);
VideoRow* video_table_get_row (VideoTable* self,
                               VideoID* video_id);
Rating rating_unserialize (gint value);
GeeArrayList* video_table_get_all (VideoTable* self);
void video_table_set_filepath (VideoTable* self,
                               VideoID* video_id,
                               const gchar* filepath,
                               GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
void video_table_set_title (VideoTable* self,
                            VideoID* video_id,
                            const gchar* new_title,
                            GError** error);
void video_table_set_comment (VideoTable* self,
                              VideoID* video_id,
                              const gchar* new_comment,
                              GError** error);
void video_table_set_exposure_time (VideoTable* self,
                                    VideoID* video_id,
                                    time_t time,
                                    GError** error);
void database_table_update_int64_by_id_2 (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint64 value,
                                          GError** error);
void video_table_set_rating (VideoTable* self,
                             VideoID* video_id,
                             Rating rating,
                             GError** error);
gint rating_serialize (Rating self);
void video_table_set_flags (VideoTable* self,
                            VideoID* video_id,
                            guint64 flags,
                            GError** error);
void video_table_update_backlinks (VideoTable* self,
                                   VideoID* video_id,
                                   const gchar* backlinks,
                                   GError** error);
void video_table_update_is_interpretable (VideoTable* self,
                                          VideoID* video_id,
                                          gboolean is_interpretable,
                                          GError** error);
void database_table_update_int_by_id_2 (DatabaseTable* self,
                                        gint64 id,
                                        const gchar* column,
                                        gint value,
                                        GError** error);
gboolean video_table_set_event (VideoTable* self,
                                VideoID* video_id,
                                EventID* event_id);
gboolean database_table_update_int64_by_id (DatabaseTable* self,
                                            gint64 id,
                                            const gchar* column,
                                            gint64 value);
void video_table_remove_by_file (VideoTable* self,
                                 GFile* file,
                                 GError** error);
void video_table_remove (VideoTable* self,
                         VideoID* videoID,
                         GError** error);
gboolean video_table_is_video_stored (VideoTable* self,
                                      GFile* file);
void video_table_get_id (VideoTable* self,
                         GFile* file,
                         VideoID* result);
GeeArrayList* video_table_get_videos (VideoTable* self,
                                      GError** error);
static sqlite3_stmt* video_table_get_duplicate_stmt (VideoTable* self,
                                              GFile* file,
                                              const gchar* md5);
gboolean video_table_has_duplicate (VideoTable* self,
                                    GFile* file,
                                    const gchar* md5);
VideoID* video_table_get_duplicate_ids (VideoTable* self,
                                        GFile* file,
                                        const gchar* md5,
                                        gint* result_length1);
static void _vala_array_add4 (VideoID* * array,
                       int* length,
                       int* size,
                       const VideoID* value);
GeeArrayList* video_table_get_event_source_ids (VideoTable* self,
                                                EventID* event_id);
void video_table_set_timestamp (VideoTable* self,
                                VideoID* video_id,
                                time_t timestamp,
                                GError** error);
static void video_table_finalize (DatabaseTable * obj);

void
video_id_init (VideoID *self,
               gint64 id)
{
#line 12 "../src/db/VideoTable.vala"
	memset (self, 0, sizeof (VideoID));
#line 13 "../src/db/VideoTable.vala"
	(*self).id = id;
#line 344 "VideoTable.c"
}

gboolean
video_id_is_invalid (VideoID *self)
{
	gboolean result = FALSE;
#line 17 "../src/db/VideoTable.vala"
	result = (*self).id == VIDEO_ID_INVALID;
#line 17 "../src/db/VideoTable.vala"
	return result;
#line 355 "VideoTable.c"
}

gboolean
video_id_is_valid (VideoID *self)
{
	gboolean result = FALSE;
#line 21 "../src/db/VideoTable.vala"
	result = (*self).id != VIDEO_ID_INVALID;
#line 21 "../src/db/VideoTable.vala"
	return result;
#line 366 "VideoTable.c"
}

guint
video_id_hash (VideoID* a)
{
	guint result = 0U;
#line 25 "../src/db/VideoTable.vala"
	result = int64_hash (&(*a).id);
#line 25 "../src/db/VideoTable.vala"
	return result;
#line 377 "VideoTable.c"
}

gboolean
video_id_equal (void* a,
                void* b)
{
	gboolean result = FALSE;
#line 29 "../src/db/VideoTable.vala"
	result = (*((VideoID*) a)).id == (*((VideoID*) b)).id;
#line 29 "../src/db/VideoTable.vala"
	return result;
#line 389 "VideoTable.c"
}

gchar*
video_id_upgrade_video_id_to_source_id (VideoID* video_id)
{
	gchar* result = NULL;
	VideoID _tmp0_;
	gchar* _tmp1_;
#line 32 "../src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 33 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 33 "../src/db/VideoTable.vala"
	_tmp1_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", VIDEO_TYPENAME, _tmp0_.id);
#line 33 "../src/db/VideoTable.vala"
	result = _tmp1_;
#line 33 "../src/db/VideoTable.vala"
	return result;
#line 408 "VideoTable.c"
}

VideoID*
video_id_dup (const VideoID* self)
{
	VideoID* dup;
#line 7 "../src/db/VideoTable.vala"
	dup = g_new0 (VideoID, 1);
#line 7 "../src/db/VideoTable.vala"
	memcpy (dup, self, sizeof (VideoID));
#line 7 "../src/db/VideoTable.vala"
	return dup;
#line 421 "VideoTable.c"
}

void
video_id_free (VideoID* self)
{
#line 7 "../src/db/VideoTable.vala"
	g_free (self);
#line 429 "VideoTable.c"
}

GType
video_id_get_type (void)
{
	static volatile gsize video_id_type_id__volatile = 0;
	if (g_once_init_enter (&video_id_type_id__volatile)) {
		GType video_id_type_id;
		video_id_type_id = g_boxed_type_register_static ("VideoID", (GBoxedCopyFunc) video_id_dup, (GBoxedFreeFunc) video_id_free);
		g_once_init_leave (&video_id_type_id__volatile, video_id_type_id);
	}
	return video_id_type_id__volatile;
}

VideoRow*
video_row_construct (GType object_type)
{
	VideoRow* self = NULL;
#line 37 "../src/db/VideoTable.vala"
	self = (VideoRow*) g_type_create_instance (object_type);
#line 37 "../src/db/VideoTable.vala"
	return self;
#line 452 "VideoTable.c"
}

VideoRow*
video_row_new (void)
{
#line 37 "../src/db/VideoTable.vala"
	return video_row_construct (TYPE_VIDEO_ROW);
#line 460 "VideoTable.c"
}

static void
value_video_row_init (GValue* value)
{
#line 37 "../src/db/VideoTable.vala"
	value->data[0].v_pointer = NULL;
#line 468 "VideoTable.c"
}

static void
value_video_row_free_value (GValue* value)
{
#line 37 "../src/db/VideoTable.vala"
	if (value->data[0].v_pointer) {
#line 37 "../src/db/VideoTable.vala"
		video_row_unref (value->data[0].v_pointer);
#line 478 "VideoTable.c"
	}
}

static void
value_video_row_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 37 "../src/db/VideoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 37 "../src/db/VideoTable.vala"
		dest_value->data[0].v_pointer = video_row_ref (src_value->data[0].v_pointer);
#line 490 "VideoTable.c"
	} else {
#line 37 "../src/db/VideoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 494 "VideoTable.c"
	}
}

static gpointer
value_video_row_peek_pointer (const GValue* value)
{
#line 37 "../src/db/VideoTable.vala"
	return value->data[0].v_pointer;
#line 503 "VideoTable.c"
}

static gchar*
value_video_row_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 37 "../src/db/VideoTable.vala"
	if (collect_values[0].v_pointer) {
#line 514 "VideoTable.c"
		VideoRow * object;
		object = collect_values[0].v_pointer;
#line 37 "../src/db/VideoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 37 "../src/db/VideoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 521 "VideoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 37 "../src/db/VideoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 525 "VideoTable.c"
		}
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = video_row_ref (object);
#line 529 "VideoTable.c"
	} else {
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 533 "VideoTable.c"
	}
#line 37 "../src/db/VideoTable.vala"
	return NULL;
#line 537 "VideoTable.c"
}

static gchar*
value_video_row_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	VideoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 37 "../src/db/VideoTable.vala"
	if (!object_p) {
#line 37 "../src/db/VideoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 552 "VideoTable.c"
	}
#line 37 "../src/db/VideoTable.vala"
	if (!value->data[0].v_pointer) {
#line 37 "../src/db/VideoTable.vala"
		*object_p = NULL;
#line 558 "VideoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 37 "../src/db/VideoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 562 "VideoTable.c"
	} else {
#line 37 "../src/db/VideoTable.vala"
		*object_p = video_row_ref (value->data[0].v_pointer);
#line 566 "VideoTable.c"
	}
#line 37 "../src/db/VideoTable.vala"
	return NULL;
#line 570 "VideoTable.c"
}

GParamSpec*
param_spec_video_row (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecVideoRow* spec;
#line 37 "../src/db/VideoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_ROW), NULL);
#line 37 "../src/db/VideoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 37 "../src/db/VideoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 37 "../src/db/VideoTable.vala"
	return G_PARAM_SPEC (spec);
#line 589 "VideoTable.c"
}

gpointer
value_get_video_row (const GValue* value)
{
#line 37 "../src/db/VideoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW), NULL);
#line 37 "../src/db/VideoTable.vala"
	return value->data[0].v_pointer;
#line 599 "VideoTable.c"
}

void
value_set_video_row (GValue* value,
                     gpointer v_object)
{
	VideoRow * old;
#line 37 "../src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW));
#line 37 "../src/db/VideoTable.vala"
	old = value->data[0].v_pointer;
#line 37 "../src/db/VideoTable.vala"
	if (v_object) {
#line 37 "../src/db/VideoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_ROW));
#line 37 "../src/db/VideoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = v_object;
#line 37 "../src/db/VideoTable.vala"
		video_row_ref (value->data[0].v_pointer);
#line 621 "VideoTable.c"
	} else {
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 625 "VideoTable.c"
	}
#line 37 "../src/db/VideoTable.vala"
	if (old) {
#line 37 "../src/db/VideoTable.vala"
		video_row_unref (old);
#line 631 "VideoTable.c"
	}
}

void
value_take_video_row (GValue* value,
                      gpointer v_object)
{
	VideoRow * old;
#line 37 "../src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW));
#line 37 "../src/db/VideoTable.vala"
	old = value->data[0].v_pointer;
#line 37 "../src/db/VideoTable.vala"
	if (v_object) {
#line 37 "../src/db/VideoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_ROW));
#line 37 "../src/db/VideoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = v_object;
#line 652 "VideoTable.c"
	} else {
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 656 "VideoTable.c"
	}
#line 37 "../src/db/VideoTable.vala"
	if (old) {
#line 37 "../src/db/VideoTable.vala"
		video_row_unref (old);
#line 662 "VideoTable.c"
	}
}

static void
video_row_class_init (VideoRowClass * klass,
                      gpointer klass_data)
{
#line 37 "../src/db/VideoTable.vala"
	video_row_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/db/VideoTable.vala"
	((VideoRowClass *) klass)->finalize = video_row_finalize;
#line 674 "VideoTable.c"
}

static void
video_row_instance_init (VideoRow * self,
                         gpointer klass)
{
#line 37 "../src/db/VideoTable.vala"
	self->ref_count = 1;
#line 683 "VideoTable.c"
}

static void
video_row_finalize (VideoRow * obj)
{
	VideoRow * self;
#line 37 "../src/db/VideoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_ROW, VideoRow);
#line 37 "../src/db/VideoTable.vala"
	g_signal_handlers_destroy (self);
#line 39 "../src/db/VideoTable.vala"
	_g_free0 (self->filepath);
#line 49 "../src/db/VideoTable.vala"
	_g_free0 (self->md5);
#line 52 "../src/db/VideoTable.vala"
	_g_free0 (self->title);
#line 53 "../src/db/VideoTable.vala"
	_g_free0 (self->backlinks);
#line 56 "../src/db/VideoTable.vala"
	_g_free0 (self->comment);
#line 704 "VideoTable.c"
}

GType
video_row_get_type (void)
{
	static volatile gsize video_row_type_id__volatile = 0;
	if (g_once_init_enter (&video_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_video_row_init, value_video_row_free_value, value_video_row_copy_value, value_video_row_peek_pointer, "p", value_video_row_collect_value, "p", value_video_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (VideoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoRow), 0, (GInstanceInitFunc) video_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType video_row_type_id;
		video_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&video_row_type_id__volatile, video_row_type_id);
	}
	return video_row_type_id__volatile;
}

gpointer
video_row_ref (gpointer instance)
{
	VideoRow * self;
	self = instance;
#line 37 "../src/db/VideoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 37 "../src/db/VideoTable.vala"
	return instance;
#line 731 "VideoTable.c"
}

void
video_row_unref (gpointer instance)
{
	VideoRow * self;
	self = instance;
#line 37 "../src/db/VideoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 37 "../src/db/VideoTable.vala"
		VIDEO_ROW_GET_CLASS (self)->finalize (self);
#line 37 "../src/db/VideoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 745 "VideoTable.c"
	}
}

static VideoTable*
video_table_construct (GType object_type)
{
	VideoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* stmt2 = NULL;
	gint res2 = 0;
	sqlite3* _tmp4_;
	sqlite3_stmt* _tmp5_ = NULL;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
#line 62 "../src/db/VideoTable.vala"
	self = (VideoTable*) database_table_construct (object_type);
#line 64 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 64 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS VideoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "clip_duration REAL, " "is_interpretable INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "md5 TEXT, " "time_created INTEGER, " "rating INTEGER DEFAULT 0, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "flags INTEGER DEFAULT 0, " "comment TEXT " ")", -1, &_tmp1_, NULL);
#line 64 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 64 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 64 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 85 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 87 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 87 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 88 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 89 "../src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", res);
#line 787 "VideoTable.c"
	}
#line 93 "../src/db/VideoTable.vala"
	_tmp4_ = database_table_db;
#line 93 "../src/db/VideoTable.vala"
	_tmp6_ = sqlite3_prepare_v2 (_tmp4_, "CREATE INDEX IF NOT EXISTS VideoEventIDIndex ON VideoTable (event_id)", -1, &_tmp5_, NULL);
#line 93 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 93 "../src/db/VideoTable.vala"
	stmt2 = _tmp5_;
#line 93 "../src/db/VideoTable.vala"
	res2 = _tmp6_;
#line 95 "../src/db/VideoTable.vala"
	_vala_assert (res2 == SQLITE_OK, "res2 == Sqlite.OK");
#line 97 "../src/db/VideoTable.vala"
	_tmp7_ = stmt2;
#line 97 "../src/db/VideoTable.vala"
	res2 = sqlite3_step (_tmp7_);
#line 98 "../src/db/VideoTable.vala"
	if (res2 != SQLITE_DONE) {
#line 99 "../src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", res2);
#line 809 "VideoTable.c"
	}
#line 101 "../src/db/VideoTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "VideoTable");
#line 62 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 62 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 62 "../src/db/VideoTable.vala"
	return self;
#line 819 "VideoTable.c"
}

static VideoTable*
video_table_new (void)
{
#line 62 "../src/db/VideoTable.vala"
	return video_table_construct (TYPE_VIDEO_TABLE);
#line 827 "VideoTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 108 "../src/db/VideoTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 835 "VideoTable.c"
}

VideoTable*
video_table_get_instance (void)
{
	VideoTable* result = NULL;
	VideoTable* _tmp0_;
	VideoTable* _tmp2_;
	VideoTable* _tmp3_;
#line 105 "../src/db/VideoTable.vala"
	_tmp0_ = video_table_instance;
#line 105 "../src/db/VideoTable.vala"
	if (_tmp0_ == NULL) {
#line 849 "VideoTable.c"
		VideoTable* _tmp1_;
#line 106 "../src/db/VideoTable.vala"
		_tmp1_ = video_table_new ();
#line 106 "../src/db/VideoTable.vala"
		_database_table_unref0 (video_table_instance);
#line 106 "../src/db/VideoTable.vala"
		video_table_instance = _tmp1_;
#line 857 "VideoTable.c"
	}
#line 108 "../src/db/VideoTable.vala"
	_tmp2_ = video_table_instance;
#line 108 "../src/db/VideoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 108 "../src/db/VideoTable.vala"
	result = _tmp3_;
#line 108 "../src/db/VideoTable.vala"
	return result;
#line 867 "VideoTable.c"
}

void
video_table_add (VideoTable* self,
                 VideoRow* video_row,
                 VideoID* result,
                 GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gulong time_created = 0UL;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	gint _tmp10_ = 0;
	sqlite3_stmt* _tmp11_;
	sqlite3_stmt* _tmp12_;
	sqlite3_stmt* _tmp13_;
	sqlite3_stmt* _tmp14_;
	sqlite3_stmt* _tmp15_;
	ImportID _tmp16_;
	sqlite3_stmt* _tmp17_;
	sqlite3_stmt* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GDestroyNotify _tmp21_;
	sqlite3_stmt* _tmp22_;
	sqlite3_stmt* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	GDestroyNotify _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	GDestroyNotify _tmp30_;
	sqlite3_stmt* _tmp31_;
	sqlite3* _tmp32_;
	VideoID _tmp33_;
	GError* _inner_error0_ = NULL;
#line 113 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 113 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_ROW (video_row));
#line 115 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 115 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO VideoTable (filename, width, height, clip_duration, is_int" \
"erpretable, " "filesize, timestamp, exposure_time, import_id, event_id, md5, time_cre" \
"ated, title, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", -1, &_tmp1_, NULL);
#line 115 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 115 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 115 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 120 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 122 "../src/db/VideoTable.vala"
	time_created = now_sec ();
#line 124 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 124 "../src/db/VideoTable.vala"
	_tmp4_ = video_row->filepath;
#line 124 "../src/db/VideoTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 124 "../src/db/VideoTable.vala"
	_tmp6_ = g_free;
#line 124 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp5_, -1, _tmp6_);
#line 125 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 126 "../src/db/VideoTable.vala"
	_tmp7_ = stmt;
#line 126 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int (_tmp7_, 2, video_row->width);
#line 127 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 128 "../src/db/VideoTable.vala"
	_tmp8_ = stmt;
#line 128 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int (_tmp8_, 3, video_row->height);
#line 129 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 130 "../src/db/VideoTable.vala"
	_tmp9_ = stmt;
#line 130 "../src/db/VideoTable.vala"
	res = sqlite3_bind_double (_tmp9_, 4, video_row->clip_duration);
#line 131 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 132 "../src/db/VideoTable.vala"
	if (video_row->is_interpretable) {
#line 132 "../src/db/VideoTable.vala"
		_tmp10_ = 1;
#line 966 "VideoTable.c"
	} else {
#line 132 "../src/db/VideoTable.vala"
		_tmp10_ = 0;
#line 970 "VideoTable.c"
	}
#line 132 "../src/db/VideoTable.vala"
	_tmp11_ = stmt;
#line 132 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int (_tmp11_, 5, _tmp10_);
#line 133 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 134 "../src/db/VideoTable.vala"
	_tmp12_ = stmt;
#line 134 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp12_, 6, video_row->filesize);
#line 135 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 136 "../src/db/VideoTable.vala"
	_tmp13_ = stmt;
#line 136 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp13_, 7, (gint64) video_row->timestamp);
#line 137 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 138 "../src/db/VideoTable.vala"
	_tmp14_ = stmt;
#line 138 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp14_, 8, (gint64) video_row->exposure_time);
#line 139 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 140 "../src/db/VideoTable.vala"
	_tmp15_ = stmt;
#line 140 "../src/db/VideoTable.vala"
	_tmp16_ = video_row->import_id;
#line 140 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp15_, 9, _tmp16_.id);
#line 141 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 142 "../src/db/VideoTable.vala"
	_tmp17_ = stmt;
#line 142 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp17_, 10, EVENT_ID_INVALID);
#line 143 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 144 "../src/db/VideoTable.vala"
	_tmp18_ = stmt;
#line 144 "../src/db/VideoTable.vala"
	_tmp19_ = video_row->md5;
#line 144 "../src/db/VideoTable.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 144 "../src/db/VideoTable.vala"
	_tmp21_ = g_free;
#line 144 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp18_, 11, _tmp20_, -1, _tmp21_);
#line 145 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 146 "../src/db/VideoTable.vala"
	_tmp22_ = stmt;
#line 146 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp22_, 12, (gint64) time_created);
#line 147 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 148 "../src/db/VideoTable.vala"
	_tmp23_ = stmt;
#line 148 "../src/db/VideoTable.vala"
	_tmp24_ = video_row->title;
#line 148 "../src/db/VideoTable.vala"
	_tmp25_ = g_strdup (_tmp24_);
#line 148 "../src/db/VideoTable.vala"
	_tmp26_ = g_free;
#line 148 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp23_, 13, _tmp25_, -1, _tmp26_);
#line 149 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 150 "../src/db/VideoTable.vala"
	_tmp27_ = stmt;
#line 150 "../src/db/VideoTable.vala"
	_tmp28_ = video_row->comment;
#line 150 "../src/db/VideoTable.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 150 "../src/db/VideoTable.vala"
	_tmp30_ = g_free;
#line 150 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp27_, 14, _tmp29_, -1, _tmp30_);
#line 151 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 153 "../src/db/VideoTable.vala"
	_tmp31_ = stmt;
#line 153 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp31_);
#line 154 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 155 "../src/db/VideoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 156 "../src/db/VideoTable.vala"
			database_table_throw_error ("VideoTable.add", res, &_inner_error0_);
#line 156 "../src/db/VideoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "../src/db/VideoTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 156 "../src/db/VideoTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 156 "../src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 156 "../src/db/VideoTable.vala"
					return;
#line 1072 "VideoTable.c"
				} else {
#line 156 "../src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 156 "../src/db/VideoTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 156 "../src/db/VideoTable.vala"
					g_clear_error (&_inner_error0_);
#line 156 "../src/db/VideoTable.vala"
					return;
#line 1082 "VideoTable.c"
				}
			}
		}
	}
#line 160 "../src/db/VideoTable.vala"
	_tmp32_ = database_table_db;
#line 160 "../src/db/VideoTable.vala"
	video_id_init (&video_row->video_id, sqlite3_last_insert_rowid (_tmp32_));
#line 161 "../src/db/VideoTable.vala"
	event_id_init (&video_row->event_id, EVENT_ID_INVALID);
#line 162 "../src/db/VideoTable.vala"
	video_row->time_created = (time_t) time_created;
#line 163 "../src/db/VideoTable.vala"
	video_row->flags = (guint64) 0;
#line 165 "../src/db/VideoTable.vala"
	_tmp33_ = video_row->video_id;
#line 165 "../src/db/VideoTable.vala"
	*result = _tmp33_;
#line 165 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 165 "../src/db/VideoTable.vala"
	return;
#line 1105 "VideoTable.c"
}

gboolean
video_table_drop_event (VideoTable* self,
                        EventID* event_id)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	EventID _tmp5_;
	sqlite3_stmt* _tmp6_;
#line 168 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 168 "../src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 170 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 170 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE VideoTable SET event_id = ? WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 170 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 170 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 170 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 171 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 173 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 173 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, EVENT_ID_INVALID);
#line 174 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 175 "../src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 175 "../src/db/VideoTable.vala"
	_tmp5_ = *event_id;
#line 175 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 2, _tmp5_.id);
#line 176 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 178 "../src/db/VideoTable.vala"
	_tmp6_ = stmt;
#line 178 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp6_);
#line 179 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 180 "../src/db/VideoTable.vala"
		database_table_fatal ("VideoTable.drop_event", res);
#line 182 "../src/db/VideoTable.vala"
		result = FALSE;
#line 182 "../src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 182 "../src/db/VideoTable.vala"
		return result;
#line 1166 "VideoTable.c"
	}
#line 185 "../src/db/VideoTable.vala"
	result = TRUE;
#line 185 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 185 "../src/db/VideoTable.vala"
	return result;
#line 1174 "VideoTable.c"
}

VideoRow*
video_table_get_row (VideoTable* self,
                     VideoID* video_id)
{
	VideoRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	VideoID _tmp4_;
	sqlite3_stmt* _tmp5_;
	VideoRow* row = NULL;
	VideoRow* _tmp6_;
	VideoRow* _tmp7_;
	VideoID _tmp8_;
	VideoRow* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	VideoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	VideoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	VideoRow* _tmp17_;
	sqlite3_stmt* _tmp18_;
	VideoRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	VideoRow* _tmp21_;
	sqlite3_stmt* _tmp22_;
	VideoRow* _tmp23_;
	sqlite3_stmt* _tmp24_;
	VideoRow* _tmp25_;
	sqlite3_stmt* _tmp26_;
	VideoRow* _tmp27_;
	sqlite3_stmt* _tmp28_;
	VideoRow* _tmp29_;
	sqlite3_stmt* _tmp30_;
	VideoRow* _tmp31_;
	sqlite3_stmt* _tmp32_;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	VideoRow* _tmp35_;
	sqlite3_stmt* _tmp36_;
	VideoRow* _tmp37_;
	sqlite3_stmt* _tmp38_;
	VideoRow* _tmp39_;
	sqlite3_stmt* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	VideoRow* _tmp43_;
	sqlite3_stmt* _tmp44_;
	const gchar* _tmp45_;
	gchar* _tmp46_;
	VideoRow* _tmp47_;
	sqlite3_stmt* _tmp48_;
	VideoRow* _tmp49_;
	sqlite3_stmt* _tmp50_;
	VideoRow* _tmp51_;
	sqlite3_stmt* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
#line 188 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 188 "../src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 190 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 190 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT filename, width, height, clip_duration, is_interpretable, files" \
"ize, timestamp, " "exposure_time, import_id, event_id, md5, time_created, rating, title, " \
"backlinks, " "time_reimported, flags, comment FROM VideoTable WHERE id=?", -1, &_tmp1_, NULL);
#line 190 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 190 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 190 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 195 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 197 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 197 "../src/db/VideoTable.vala"
	_tmp4_ = *video_id;
#line 197 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 198 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 200 "../src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 200 "../src/db/VideoTable.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_ROW) {
#line 201 "../src/db/VideoTable.vala"
		result = NULL;
#line 201 "../src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 201 "../src/db/VideoTable.vala"
		return result;
#line 1274 "VideoTable.c"
	}
#line 203 "../src/db/VideoTable.vala"
	_tmp6_ = video_row_new ();
#line 203 "../src/db/VideoTable.vala"
	row = _tmp6_;
#line 204 "../src/db/VideoTable.vala"
	_tmp7_ = row;
#line 204 "../src/db/VideoTable.vala"
	_tmp8_ = *video_id;
#line 204 "../src/db/VideoTable.vala"
	_tmp7_->video_id = _tmp8_;
#line 205 "../src/db/VideoTable.vala"
	_tmp9_ = row;
#line 205 "../src/db/VideoTable.vala"
	_tmp10_ = stmt;
#line 205 "../src/db/VideoTable.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
#line 205 "../src/db/VideoTable.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 205 "../src/db/VideoTable.vala"
	_g_free0 (_tmp9_->filepath);
#line 205 "../src/db/VideoTable.vala"
	_tmp9_->filepath = _tmp12_;
#line 206 "../src/db/VideoTable.vala"
	_tmp13_ = row;
#line 206 "../src/db/VideoTable.vala"
	_tmp14_ = stmt;
#line 206 "../src/db/VideoTable.vala"
	_tmp13_->width = sqlite3_column_int (_tmp14_, 1);
#line 207 "../src/db/VideoTable.vala"
	_tmp15_ = row;
#line 207 "../src/db/VideoTable.vala"
	_tmp16_ = stmt;
#line 207 "../src/db/VideoTable.vala"
	_tmp15_->height = sqlite3_column_int (_tmp16_, 2);
#line 208 "../src/db/VideoTable.vala"
	_tmp17_ = row;
#line 208 "../src/db/VideoTable.vala"
	_tmp18_ = stmt;
#line 208 "../src/db/VideoTable.vala"
	_tmp17_->clip_duration = sqlite3_column_double (_tmp18_, 3);
#line 209 "../src/db/VideoTable.vala"
	_tmp19_ = row;
#line 209 "../src/db/VideoTable.vala"
	_tmp20_ = stmt;
#line 209 "../src/db/VideoTable.vala"
	_tmp19_->is_interpretable = sqlite3_column_int (_tmp20_, 4) == 1;
#line 210 "../src/db/VideoTable.vala"
	_tmp21_ = row;
#line 210 "../src/db/VideoTable.vala"
	_tmp22_ = stmt;
#line 210 "../src/db/VideoTable.vala"
	_tmp21_->filesize = sqlite3_column_int64 (_tmp22_, 5);
#line 211 "../src/db/VideoTable.vala"
	_tmp23_ = row;
#line 211 "../src/db/VideoTable.vala"
	_tmp24_ = stmt;
#line 211 "../src/db/VideoTable.vala"
	_tmp23_->timestamp = (time_t) sqlite3_column_int64 (_tmp24_, 6);
#line 212 "../src/db/VideoTable.vala"
	_tmp25_ = row;
#line 212 "../src/db/VideoTable.vala"
	_tmp26_ = stmt;
#line 212 "../src/db/VideoTable.vala"
	_tmp25_->exposure_time = (time_t) sqlite3_column_int64 (_tmp26_, 7);
#line 213 "../src/db/VideoTable.vala"
	_tmp27_ = row;
#line 213 "../src/db/VideoTable.vala"
	_tmp28_ = stmt;
#line 213 "../src/db/VideoTable.vala"
	_tmp27_->import_id.id = sqlite3_column_int64 (_tmp28_, 8);
#line 214 "../src/db/VideoTable.vala"
	_tmp29_ = row;
#line 214 "../src/db/VideoTable.vala"
	_tmp30_ = stmt;
#line 214 "../src/db/VideoTable.vala"
	_tmp29_->event_id.id = sqlite3_column_int64 (_tmp30_, 9);
#line 215 "../src/db/VideoTable.vala"
	_tmp31_ = row;
#line 215 "../src/db/VideoTable.vala"
	_tmp32_ = stmt;
#line 215 "../src/db/VideoTable.vala"
	_tmp33_ = (const gchar*) sqlite3_column_text (_tmp32_, 10);
#line 215 "../src/db/VideoTable.vala"
	_tmp34_ = g_strdup (_tmp33_);
#line 215 "../src/db/VideoTable.vala"
	_g_free0 (_tmp31_->md5);
#line 215 "../src/db/VideoTable.vala"
	_tmp31_->md5 = _tmp34_;
#line 216 "../src/db/VideoTable.vala"
	_tmp35_ = row;
#line 216 "../src/db/VideoTable.vala"
	_tmp36_ = stmt;
#line 216 "../src/db/VideoTable.vala"
	_tmp35_->time_created = (time_t) sqlite3_column_int64 (_tmp36_, 11);
#line 217 "../src/db/VideoTable.vala"
	_tmp37_ = row;
#line 217 "../src/db/VideoTable.vala"
	_tmp38_ = stmt;
#line 217 "../src/db/VideoTable.vala"
	_tmp37_->rating = rating_unserialize (sqlite3_column_int (_tmp38_, 12));
#line 218 "../src/db/VideoTable.vala"
	_tmp39_ = row;
#line 218 "../src/db/VideoTable.vala"
	_tmp40_ = stmt;
#line 218 "../src/db/VideoTable.vala"
	_tmp41_ = (const gchar*) sqlite3_column_text (_tmp40_, 13);
#line 218 "../src/db/VideoTable.vala"
	_tmp42_ = g_strdup (_tmp41_);
#line 218 "../src/db/VideoTable.vala"
	_g_free0 (_tmp39_->title);
#line 218 "../src/db/VideoTable.vala"
	_tmp39_->title = _tmp42_;
#line 219 "../src/db/VideoTable.vala"
	_tmp43_ = row;
#line 219 "../src/db/VideoTable.vala"
	_tmp44_ = stmt;
#line 219 "../src/db/VideoTable.vala"
	_tmp45_ = (const gchar*) sqlite3_column_text (_tmp44_, 14);
#line 219 "../src/db/VideoTable.vala"
	_tmp46_ = g_strdup (_tmp45_);
#line 219 "../src/db/VideoTable.vala"
	_g_free0 (_tmp43_->backlinks);
#line 219 "../src/db/VideoTable.vala"
	_tmp43_->backlinks = _tmp46_;
#line 220 "../src/db/VideoTable.vala"
	_tmp47_ = row;
#line 220 "../src/db/VideoTable.vala"
	_tmp48_ = stmt;
#line 220 "../src/db/VideoTable.vala"
	_tmp47_->time_reimported = (time_t) sqlite3_column_int64 (_tmp48_, 15);
#line 221 "../src/db/VideoTable.vala"
	_tmp49_ = row;
#line 221 "../src/db/VideoTable.vala"
	_tmp50_ = stmt;
#line 221 "../src/db/VideoTable.vala"
	_tmp49_->flags = (guint64) sqlite3_column_int64 (_tmp50_, 16);
#line 222 "../src/db/VideoTable.vala"
	_tmp51_ = row;
#line 222 "../src/db/VideoTable.vala"
	_tmp52_ = stmt;
#line 222 "../src/db/VideoTable.vala"
	_tmp53_ = (const gchar*) sqlite3_column_text (_tmp52_, 17);
#line 222 "../src/db/VideoTable.vala"
	_tmp54_ = g_strdup (_tmp53_);
#line 222 "../src/db/VideoTable.vala"
	_g_free0 (_tmp51_->comment);
#line 222 "../src/db/VideoTable.vala"
	_tmp51_->comment = _tmp54_;
#line 224 "../src/db/VideoTable.vala"
	result = row;
#line 224 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 224 "../src/db/VideoTable.vala"
	return result;
#line 1430 "VideoTable.c"
}

GeeArrayList*
video_table_get_all (VideoTable* self)
{
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeArrayList* all = NULL;
	GeeArrayList* _tmp3_;
#line 227 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 229 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 229 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, filename, width, height, clip_duration, is_interpretable, f" \
"ilesize, " "timestamp, exposure_time, import_id, event_id, md5, time_created, rati" \
"ng, title, " "backlinks, time_reimported, flags, comment FROM VideoTable", -1, &_tmp1_, NULL);
#line 229 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 229 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 229 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 234 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 236 "../src/db/VideoTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_VIDEO_ROW, (GBoxedCopyFunc) video_row_ref, (GDestroyNotify) video_row_unref, NULL, NULL, NULL);
#line 236 "../src/db/VideoTable.vala"
	all = _tmp3_;
#line 238 "../src/db/VideoTable.vala"
	while (TRUE) {
#line 1464 "VideoTable.c"
		sqlite3_stmt* _tmp4_;
		VideoRow* row = NULL;
		VideoRow* _tmp5_;
		VideoRow* _tmp6_;
		sqlite3_stmt* _tmp7_;
		VideoRow* _tmp8_;
		sqlite3_stmt* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		VideoRow* _tmp12_;
		sqlite3_stmt* _tmp13_;
		VideoRow* _tmp14_;
		sqlite3_stmt* _tmp15_;
		VideoRow* _tmp16_;
		sqlite3_stmt* _tmp17_;
		VideoRow* _tmp18_;
		sqlite3_stmt* _tmp19_;
		VideoRow* _tmp20_;
		sqlite3_stmt* _tmp21_;
		VideoRow* _tmp22_;
		sqlite3_stmt* _tmp23_;
		VideoRow* _tmp24_;
		sqlite3_stmt* _tmp25_;
		VideoRow* _tmp26_;
		sqlite3_stmt* _tmp27_;
		VideoRow* _tmp28_;
		sqlite3_stmt* _tmp29_;
		VideoRow* _tmp30_;
		sqlite3_stmt* _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
		VideoRow* _tmp34_;
		sqlite3_stmt* _tmp35_;
		VideoRow* _tmp36_;
		sqlite3_stmt* _tmp37_;
		VideoRow* _tmp38_;
		sqlite3_stmt* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		VideoRow* _tmp42_;
		sqlite3_stmt* _tmp43_;
		const gchar* _tmp44_;
		gchar* _tmp45_;
		VideoRow* _tmp46_;
		sqlite3_stmt* _tmp47_;
		VideoRow* _tmp48_;
		sqlite3_stmt* _tmp49_;
		VideoRow* _tmp50_;
		sqlite3_stmt* _tmp51_;
		const gchar* _tmp52_;
		gchar* _tmp53_;
		GeeArrayList* _tmp54_;
		VideoRow* _tmp55_;
#line 238 "../src/db/VideoTable.vala"
		_tmp4_ = stmt;
#line 238 "../src/db/VideoTable.vala"
		res = sqlite3_step (_tmp4_);
#line 238 "../src/db/VideoTable.vala"
		if (!(res == SQLITE_ROW)) {
#line 238 "../src/db/VideoTable.vala"
			break;
#line 1526 "VideoTable.c"
		}
#line 239 "../src/db/VideoTable.vala"
		_tmp5_ = video_row_new ();
#line 239 "../src/db/VideoTable.vala"
		row = _tmp5_;
#line 240 "../src/db/VideoTable.vala"
		_tmp6_ = row;
#line 240 "../src/db/VideoTable.vala"
		_tmp7_ = stmt;
#line 240 "../src/db/VideoTable.vala"
		_tmp6_->video_id.id = sqlite3_column_int64 (_tmp7_, 0);
#line 241 "../src/db/VideoTable.vala"
		_tmp8_ = row;
#line 241 "../src/db/VideoTable.vala"
		_tmp9_ = stmt;
#line 241 "../src/db/VideoTable.vala"
		_tmp10_ = (const gchar*) sqlite3_column_text (_tmp9_, 1);
#line 241 "../src/db/VideoTable.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 241 "../src/db/VideoTable.vala"
		_g_free0 (_tmp8_->filepath);
#line 241 "../src/db/VideoTable.vala"
		_tmp8_->filepath = _tmp11_;
#line 242 "../src/db/VideoTable.vala"
		_tmp12_ = row;
#line 242 "../src/db/VideoTable.vala"
		_tmp13_ = stmt;
#line 242 "../src/db/VideoTable.vala"
		_tmp12_->width = sqlite3_column_int (_tmp13_, 2);
#line 243 "../src/db/VideoTable.vala"
		_tmp14_ = row;
#line 243 "../src/db/VideoTable.vala"
		_tmp15_ = stmt;
#line 243 "../src/db/VideoTable.vala"
		_tmp14_->height = sqlite3_column_int (_tmp15_, 3);
#line 244 "../src/db/VideoTable.vala"
		_tmp16_ = row;
#line 244 "../src/db/VideoTable.vala"
		_tmp17_ = stmt;
#line 244 "../src/db/VideoTable.vala"
		_tmp16_->clip_duration = sqlite3_column_double (_tmp17_, 4);
#line 245 "../src/db/VideoTable.vala"
		_tmp18_ = row;
#line 245 "../src/db/VideoTable.vala"
		_tmp19_ = stmt;
#line 245 "../src/db/VideoTable.vala"
		_tmp18_->is_interpretable = sqlite3_column_int (_tmp19_, 5) == 1;
#line 246 "../src/db/VideoTable.vala"
		_tmp20_ = row;
#line 246 "../src/db/VideoTable.vala"
		_tmp21_ = stmt;
#line 246 "../src/db/VideoTable.vala"
		_tmp20_->filesize = sqlite3_column_int64 (_tmp21_, 6);
#line 247 "../src/db/VideoTable.vala"
		_tmp22_ = row;
#line 247 "../src/db/VideoTable.vala"
		_tmp23_ = stmt;
#line 247 "../src/db/VideoTable.vala"
		_tmp22_->timestamp = (time_t) sqlite3_column_int64 (_tmp23_, 7);
#line 248 "../src/db/VideoTable.vala"
		_tmp24_ = row;
#line 248 "../src/db/VideoTable.vala"
		_tmp25_ = stmt;
#line 248 "../src/db/VideoTable.vala"
		_tmp24_->exposure_time = (time_t) sqlite3_column_int64 (_tmp25_, 8);
#line 249 "../src/db/VideoTable.vala"
		_tmp26_ = row;
#line 249 "../src/db/VideoTable.vala"
		_tmp27_ = stmt;
#line 249 "../src/db/VideoTable.vala"
		_tmp26_->import_id.id = sqlite3_column_int64 (_tmp27_, 9);
#line 250 "../src/db/VideoTable.vala"
		_tmp28_ = row;
#line 250 "../src/db/VideoTable.vala"
		_tmp29_ = stmt;
#line 250 "../src/db/VideoTable.vala"
		_tmp28_->event_id.id = sqlite3_column_int64 (_tmp29_, 10);
#line 251 "../src/db/VideoTable.vala"
		_tmp30_ = row;
#line 251 "../src/db/VideoTable.vala"
		_tmp31_ = stmt;
#line 251 "../src/db/VideoTable.vala"
		_tmp32_ = (const gchar*) sqlite3_column_text (_tmp31_, 11);
#line 251 "../src/db/VideoTable.vala"
		_tmp33_ = g_strdup (_tmp32_);
#line 251 "../src/db/VideoTable.vala"
		_g_free0 (_tmp30_->md5);
#line 251 "../src/db/VideoTable.vala"
		_tmp30_->md5 = _tmp33_;
#line 252 "../src/db/VideoTable.vala"
		_tmp34_ = row;
#line 252 "../src/db/VideoTable.vala"
		_tmp35_ = stmt;
#line 252 "../src/db/VideoTable.vala"
		_tmp34_->time_created = (time_t) sqlite3_column_int64 (_tmp35_, 12);
#line 253 "../src/db/VideoTable.vala"
		_tmp36_ = row;
#line 253 "../src/db/VideoTable.vala"
		_tmp37_ = stmt;
#line 253 "../src/db/VideoTable.vala"
		_tmp36_->rating = rating_unserialize (sqlite3_column_int (_tmp37_, 13));
#line 254 "../src/db/VideoTable.vala"
		_tmp38_ = row;
#line 254 "../src/db/VideoTable.vala"
		_tmp39_ = stmt;
#line 254 "../src/db/VideoTable.vala"
		_tmp40_ = (const gchar*) sqlite3_column_text (_tmp39_, 14);
#line 254 "../src/db/VideoTable.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 254 "../src/db/VideoTable.vala"
		_g_free0 (_tmp38_->title);
#line 254 "../src/db/VideoTable.vala"
		_tmp38_->title = _tmp41_;
#line 255 "../src/db/VideoTable.vala"
		_tmp42_ = row;
#line 255 "../src/db/VideoTable.vala"
		_tmp43_ = stmt;
#line 255 "../src/db/VideoTable.vala"
		_tmp44_ = (const gchar*) sqlite3_column_text (_tmp43_, 15);
#line 255 "../src/db/VideoTable.vala"
		_tmp45_ = g_strdup (_tmp44_);
#line 255 "../src/db/VideoTable.vala"
		_g_free0 (_tmp42_->backlinks);
#line 255 "../src/db/VideoTable.vala"
		_tmp42_->backlinks = _tmp45_;
#line 256 "../src/db/VideoTable.vala"
		_tmp46_ = row;
#line 256 "../src/db/VideoTable.vala"
		_tmp47_ = stmt;
#line 256 "../src/db/VideoTable.vala"
		_tmp46_->time_reimported = (time_t) sqlite3_column_int64 (_tmp47_, 16);
#line 257 "../src/db/VideoTable.vala"
		_tmp48_ = row;
#line 257 "../src/db/VideoTable.vala"
		_tmp49_ = stmt;
#line 257 "../src/db/VideoTable.vala"
		_tmp48_->flags = (guint64) sqlite3_column_int64 (_tmp49_, 17);
#line 258 "../src/db/VideoTable.vala"
		_tmp50_ = row;
#line 258 "../src/db/VideoTable.vala"
		_tmp51_ = stmt;
#line 258 "../src/db/VideoTable.vala"
		_tmp52_ = (const gchar*) sqlite3_column_text (_tmp51_, 18);
#line 258 "../src/db/VideoTable.vala"
		_tmp53_ = g_strdup (_tmp52_);
#line 258 "../src/db/VideoTable.vala"
		_g_free0 (_tmp50_->comment);
#line 258 "../src/db/VideoTable.vala"
		_tmp50_->comment = _tmp53_;
#line 260 "../src/db/VideoTable.vala"
		_tmp54_ = all;
#line 260 "../src/db/VideoTable.vala"
		_tmp55_ = row;
#line 260 "../src/db/VideoTable.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp55_);
#line 238 "../src/db/VideoTable.vala"
		_video_row_unref0 (row);
#line 1684 "VideoTable.c"
	}
#line 263 "../src/db/VideoTable.vala"
	result = all;
#line 263 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 263 "../src/db/VideoTable.vala"
	return result;
#line 1692 "VideoTable.c"
}

void
video_table_set_filepath (VideoTable* self,
                          VideoID* video_id,
                          const gchar* filepath,
                          GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 266 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 266 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 266 "../src/db/VideoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 267 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 267 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "filename", filepath, &_inner_error0_);
#line 267 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 267 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 267 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 267 "../src/db/VideoTable.vala"
			return;
#line 1721 "VideoTable.c"
		} else {
#line 267 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 267 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 267 "../src/db/VideoTable.vala"
			return;
#line 1729 "VideoTable.c"
		}
	}
}

void
video_table_set_title (VideoTable* self,
                       VideoID* video_id,
                       const gchar* new_title,
                       GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 270 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 270 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 271 "../src/db/VideoTable.vala"
	if (new_title != NULL) {
#line 271 "../src/db/VideoTable.vala"
		_tmp0_ = new_title;
#line 1751 "VideoTable.c"
	} else {
#line 271 "../src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1755 "VideoTable.c"
	}
#line 271 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 271 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "title", _tmp0_, &_inner_error0_);
#line 271 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 271 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 271 "../src/db/VideoTable.vala"
			return;
#line 1769 "VideoTable.c"
		} else {
#line 271 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 271 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 271 "../src/db/VideoTable.vala"
			return;
#line 1777 "VideoTable.c"
		}
	}
}

void
video_table_set_comment (VideoTable* self,
                         VideoID* video_id,
                         const gchar* new_comment,
                         GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 274 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 274 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 275 "../src/db/VideoTable.vala"
	if (new_comment != NULL) {
#line 275 "../src/db/VideoTable.vala"
		_tmp0_ = new_comment;
#line 1799 "VideoTable.c"
	} else {
#line 275 "../src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1803 "VideoTable.c"
	}
#line 275 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 275 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "comment", _tmp0_, &_inner_error0_);
#line 275 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 275 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 275 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 275 "../src/db/VideoTable.vala"
			return;
#line 1817 "VideoTable.c"
		} else {
#line 275 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 275 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 275 "../src/db/VideoTable.vala"
			return;
#line 1825 "VideoTable.c"
		}
	}
}

void
video_table_set_exposure_time (VideoTable* self,
                               VideoID* video_id,
                               time_t time,
                               GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 278 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 278 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 279 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 279 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "exposure_time", (gint64) time, &_inner_error0_);
#line 279 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 279 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 279 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 279 "../src/db/VideoTable.vala"
			return;
#line 1854 "VideoTable.c"
		} else {
#line 279 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 279 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 279 "../src/db/VideoTable.vala"
			return;
#line 1862 "VideoTable.c"
		}
	}
}

void
video_table_set_rating (VideoTable* self,
                        VideoID* video_id,
                        Rating rating,
                        GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 282 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 282 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 283 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 283 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "rating", (gint64) rating_serialize (rating), &_inner_error0_);
#line 283 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 283 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 283 "../src/db/VideoTable.vala"
			return;
#line 1891 "VideoTable.c"
		} else {
#line 283 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 283 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 283 "../src/db/VideoTable.vala"
			return;
#line 1899 "VideoTable.c"
		}
	}
}

void
video_table_set_flags (VideoTable* self,
                       VideoID* video_id,
                       guint64 flags,
                       GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 286 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 286 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 287 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 287 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "flags", (gint64) flags, &_inner_error0_);
#line 287 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 287 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 287 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 287 "../src/db/VideoTable.vala"
			return;
#line 1928 "VideoTable.c"
		} else {
#line 287 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 287 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 287 "../src/db/VideoTable.vala"
			return;
#line 1936 "VideoTable.c"
		}
	}
}

void
video_table_update_backlinks (VideoTable* self,
                              VideoID* video_id,
                              const gchar* backlinks,
                              GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 290 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 290 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 291 "../src/db/VideoTable.vala"
	if (backlinks != NULL) {
#line 291 "../src/db/VideoTable.vala"
		_tmp0_ = backlinks;
#line 1958 "VideoTable.c"
	} else {
#line 291 "../src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1962 "VideoTable.c"
	}
#line 291 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 291 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "backlinks", _tmp0_, &_inner_error0_);
#line 291 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 291 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 291 "../src/db/VideoTable.vala"
			return;
#line 1976 "VideoTable.c"
		} else {
#line 291 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 291 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 291 "../src/db/VideoTable.vala"
			return;
#line 1984 "VideoTable.c"
		}
	}
}

void
video_table_update_is_interpretable (VideoTable* self,
                                     VideoID* video_id,
                                     gboolean is_interpretable,
                                     GError** error)
{
	gint _tmp0_ = 0;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 294 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 294 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 295 "../src/db/VideoTable.vala"
	if (is_interpretable) {
#line 295 "../src/db/VideoTable.vala"
		_tmp0_ = 1;
#line 2006 "VideoTable.c"
	} else {
#line 295 "../src/db/VideoTable.vala"
		_tmp0_ = 0;
#line 2010 "VideoTable.c"
	}
#line 295 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 295 "../src/db/VideoTable.vala"
	database_table_update_int_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "is_interpretable", _tmp0_, &_inner_error0_);
#line 295 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 295 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 295 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 295 "../src/db/VideoTable.vala"
			return;
#line 2024 "VideoTable.c"
		} else {
#line 295 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 295 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 295 "../src/db/VideoTable.vala"
			return;
#line 2032 "VideoTable.c"
		}
	}
}

gboolean
video_table_set_event (VideoTable* self,
                       VideoID* video_id,
                       EventID* event_id)
{
	gboolean result = FALSE;
	VideoID _tmp0_;
	EventID _tmp1_;
#line 298 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 298 "../src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, FALSE);
#line 298 "../src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 299 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 299 "../src/db/VideoTable.vala"
	_tmp1_ = *event_id;
#line 299 "../src/db/VideoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "event_id", _tmp1_.id);
#line 299 "../src/db/VideoTable.vala"
	return result;
#line 2059 "VideoTable.c"
}

void
video_table_remove_by_file (VideoTable* self,
                            GFile* file,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 302 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 302 "../src/db/VideoTable.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 304 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 304 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "DELETE FROM VideoTable WHERE filename=?", -1, &_tmp1_, NULL);
#line 304 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 304 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 304 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 305 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 307 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 307 "../src/db/VideoTable.vala"
	_tmp4_ = g_file_get_path (file);
#line 307 "../src/db/VideoTable.vala"
	_tmp5_ = g_free;
#line 307 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 308 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 310 "../src/db/VideoTable.vala"
	_tmp6_ = stmt;
#line 310 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp6_);
#line 311 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 312 "../src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove_by_file", res, &_inner_error0_);
#line 312 "../src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 312 "../src/db/VideoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 312 "../src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 312 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 312 "../src/db/VideoTable.vala"
				return;
#line 2121 "VideoTable.c"
			} else {
#line 312 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 312 "../src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 312 "../src/db/VideoTable.vala"
				g_clear_error (&_inner_error0_);
#line 312 "../src/db/VideoTable.vala"
				return;
#line 2131 "VideoTable.c"
			}
		}
	}
#line 302 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2137 "VideoTable.c"
}

void
video_table_remove (VideoTable* self,
                    VideoID* videoID,
                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	VideoID _tmp4_;
	sqlite3_stmt* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 315 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 315 "../src/db/VideoTable.vala"
	g_return_if_fail (videoID != NULL);
#line 317 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 317 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "DELETE FROM VideoTable WHERE id=?", -1, &_tmp1_, NULL);
#line 317 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 317 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 317 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 318 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 320 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 320 "../src/db/VideoTable.vala"
	_tmp4_ = *videoID;
#line 320 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 321 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 323 "../src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 323 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp5_);
#line 324 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 325 "../src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove", res, &_inner_error0_);
#line 325 "../src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 325 "../src/db/VideoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 325 "../src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 325 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 325 "../src/db/VideoTable.vala"
				return;
#line 2196 "VideoTable.c"
			} else {
#line 325 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 325 "../src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 325 "../src/db/VideoTable.vala"
				g_clear_error (&_inner_error0_);
#line 325 "../src/db/VideoTable.vala"
				return;
#line 2206 "VideoTable.c"
			}
		}
	}
#line 315 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2212 "VideoTable.c"
}

gboolean
video_table_is_video_stored (VideoTable* self,
                             GFile* file)
{
	gboolean result = FALSE;
	VideoID _tmp0_ = {0};
#line 328 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 328 "../src/db/VideoTable.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 329 "../src/db/VideoTable.vala"
	video_table_get_id (self, file, &_tmp0_);
#line 329 "../src/db/VideoTable.vala"
	result = video_id_is_valid (&_tmp0_);
#line 329 "../src/db/VideoTable.vala"
	return result;
#line 2231 "VideoTable.c"
}

void
video_table_get_id (VideoTable* self,
                    GFile* file,
                    VideoID* result)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	VideoID _tmp7_ = {0};
#line 332 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 332 "../src/db/VideoTable.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 334 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 334 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT ID FROM VideoTable WHERE filename=?", -1, &_tmp1_, NULL);
#line 334 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 334 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 334 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 335 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 337 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 337 "../src/db/VideoTable.vala"
	_tmp4_ = g_file_get_path (file);
#line 337 "../src/db/VideoTable.vala"
	_tmp5_ = g_free;
#line 337 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 338 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 340 "../src/db/VideoTable.vala"
	_tmp6_ = stmt;
#line 340 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp6_);
#line 342 "../src/db/VideoTable.vala"
	if (res == SQLITE_ROW) {
#line 2281 "VideoTable.c"
		sqlite3_stmt* _tmp8_;
#line 342 "../src/db/VideoTable.vala"
		_tmp8_ = stmt;
#line 342 "../src/db/VideoTable.vala"
		video_id_init (&_tmp7_, sqlite3_column_int64 (_tmp8_, 0));
#line 2287 "VideoTable.c"
	} else {
#line 342 "../src/db/VideoTable.vala"
		video_id_init (&_tmp7_, VIDEO_ID_INVALID);
#line 2291 "VideoTable.c"
	}
#line 342 "../src/db/VideoTable.vala"
	*result = _tmp7_;
#line 342 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 342 "../src/db/VideoTable.vala"
	return;
#line 2299 "VideoTable.c"
}

GeeArrayList*
video_table_get_videos (VideoTable* self,
                        GError** error)
{
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeArrayList* video_ids = NULL;
	GeeArrayList* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 345 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 347 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 347 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM VideoTable", -1, &_tmp1_, NULL);
#line 347 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 347 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 347 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 348 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 350 "../src/db/VideoTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_VIDEO_ID, (GBoxedCopyFunc) video_id_dup, (GDestroyNotify) video_id_free, NULL, NULL, NULL);
#line 350 "../src/db/VideoTable.vala"
	video_ids = _tmp3_;
#line 2333 "VideoTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 351 "../src/db/VideoTable.vala"
		_tmp4_ = TRUE;
#line 351 "../src/db/VideoTable.vala"
		while (TRUE) {
#line 2340 "VideoTable.c"
			sqlite3_stmt* _tmp5_;
			GeeArrayList* _tmp6_;
			sqlite3_stmt* _tmp7_;
			VideoID _tmp8_ = {0};
#line 351 "../src/db/VideoTable.vala"
			if (!_tmp4_) {
#line 2347 "VideoTable.c"
			}
#line 351 "../src/db/VideoTable.vala"
			_tmp4_ = FALSE;
#line 352 "../src/db/VideoTable.vala"
			_tmp5_ = stmt;
#line 352 "../src/db/VideoTable.vala"
			res = sqlite3_step (_tmp5_);
#line 353 "../src/db/VideoTable.vala"
			if (res == SQLITE_DONE) {
#line 354 "../src/db/VideoTable.vala"
				break;
#line 2359 "VideoTable.c"
			} else {
#line 355 "../src/db/VideoTable.vala"
				if (res != SQLITE_ROW) {
#line 356 "../src/db/VideoTable.vala"
					database_table_throw_error ("VideoTable.get_videos", res, &_inner_error0_);
#line 356 "../src/db/VideoTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 356 "../src/db/VideoTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 356 "../src/db/VideoTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 356 "../src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 356 "../src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 356 "../src/db/VideoTable.vala"
							return NULL;
#line 2377 "VideoTable.c"
						} else {
#line 356 "../src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 356 "../src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 356 "../src/db/VideoTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 356 "../src/db/VideoTable.vala"
							g_clear_error (&_inner_error0_);
#line 356 "../src/db/VideoTable.vala"
							return NULL;
#line 2389 "VideoTable.c"
						}
					}
				}
			}
#line 359 "../src/db/VideoTable.vala"
			_tmp6_ = video_ids;
#line 359 "../src/db/VideoTable.vala"
			_tmp7_ = stmt;
#line 359 "../src/db/VideoTable.vala"
			video_id_init (&_tmp8_, sqlite3_column_int64 (_tmp7_, 0));
#line 359 "../src/db/VideoTable.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp8_);
#line 2402 "VideoTable.c"
		}
	}
#line 362 "../src/db/VideoTable.vala"
	result = video_ids;
#line 362 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 362 "../src/db/VideoTable.vala"
	return result;
#line 2411 "VideoTable.c"
}

static sqlite3_stmt*
video_table_get_duplicate_stmt (VideoTable* self,
                                GFile* file,
                                const gchar* md5)
{
	sqlite3_stmt* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* sql = NULL;
	gchar* _tmp1_;
	gboolean first = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	gint _tmp11_;
	gint col = 0;
#line 365 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 365 "../src/db/VideoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 366 "../src/db/VideoTable.vala"
	if (file != NULL) {
#line 366 "../src/db/VideoTable.vala"
		_tmp0_ = TRUE;
#line 2439 "VideoTable.c"
	} else {
#line 366 "../src/db/VideoTable.vala"
		_tmp0_ = md5 != NULL;
#line 2443 "VideoTable.c"
	}
#line 366 "../src/db/VideoTable.vala"
	_vala_assert (_tmp0_, "file != null || md5 != null");
#line 368 "../src/db/VideoTable.vala"
	_tmp1_ = g_strdup ("SELECT id FROM VideoTable WHERE");
#line 368 "../src/db/VideoTable.vala"
	sql = _tmp1_;
#line 369 "../src/db/VideoTable.vala"
	first = TRUE;
#line 371 "../src/db/VideoTable.vala"
	if (file != NULL) {
#line 2455 "VideoTable.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 372 "../src/db/VideoTable.vala"
		_tmp2_ = sql;
#line 372 "../src/db/VideoTable.vala"
		_tmp3_ = g_strconcat (_tmp2_, " filename=?", NULL);
#line 372 "../src/db/VideoTable.vala"
		_g_free0 (sql);
#line 372 "../src/db/VideoTable.vala"
		sql = _tmp3_;
#line 373 "../src/db/VideoTable.vala"
		first = FALSE;
#line 2468 "VideoTable.c"
	}
#line 376 "../src/db/VideoTable.vala"
	if (md5 != NULL) {
#line 2472 "VideoTable.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 377 "../src/db/VideoTable.vala"
		if (!first) {
#line 2477 "VideoTable.c"
			const gchar* _tmp4_;
			gchar* _tmp5_;
#line 378 "../src/db/VideoTable.vala"
			_tmp4_ = sql;
#line 378 "../src/db/VideoTable.vala"
			_tmp5_ = g_strconcat (_tmp4_, " OR ", NULL);
#line 378 "../src/db/VideoTable.vala"
			_g_free0 (sql);
#line 378 "../src/db/VideoTable.vala"
			sql = _tmp5_;
#line 2488 "VideoTable.c"
		}
#line 380 "../src/db/VideoTable.vala"
		_tmp6_ = sql;
#line 380 "../src/db/VideoTable.vala"
		_tmp7_ = g_strconcat (_tmp6_, " md5=?", NULL);
#line 380 "../src/db/VideoTable.vala"
		_g_free0 (sql);
#line 380 "../src/db/VideoTable.vala"
		sql = _tmp7_;
#line 2498 "VideoTable.c"
	}
#line 384 "../src/db/VideoTable.vala"
	_tmp8_ = database_table_db;
#line 384 "../src/db/VideoTable.vala"
	_tmp9_ = sql;
#line 384 "../src/db/VideoTable.vala"
	_tmp11_ = sqlite3_prepare_v2 (_tmp8_, _tmp9_, -1, &_tmp10_, NULL);
#line 384 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 384 "../src/db/VideoTable.vala"
	stmt = _tmp10_;
#line 384 "../src/db/VideoTable.vala"
	res = _tmp11_;
#line 385 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 387 "../src/db/VideoTable.vala"
	col = 1;
#line 389 "../src/db/VideoTable.vala"
	if (file != NULL) {
#line 2518 "VideoTable.c"
		sqlite3_stmt* _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
		GDestroyNotify _tmp15_;
#line 390 "../src/db/VideoTable.vala"
		_tmp12_ = stmt;
#line 390 "../src/db/VideoTable.vala"
		_tmp13_ = col;
#line 390 "../src/db/VideoTable.vala"
		col = _tmp13_ + 1;
#line 390 "../src/db/VideoTable.vala"
		_tmp14_ = g_file_get_path (file);
#line 390 "../src/db/VideoTable.vala"
		_tmp15_ = g_free;
#line 390 "../src/db/VideoTable.vala"
		res = sqlite3_bind_text (_tmp12_, _tmp13_, _tmp14_, -1, _tmp15_);
#line 391 "../src/db/VideoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2537 "VideoTable.c"
	}
#line 394 "../src/db/VideoTable.vala"
	if (md5 != NULL) {
#line 2541 "VideoTable.c"
		sqlite3_stmt* _tmp16_;
		gint _tmp17_;
		gchar* _tmp18_;
		GDestroyNotify _tmp19_;
#line 395 "../src/db/VideoTable.vala"
		_tmp16_ = stmt;
#line 395 "../src/db/VideoTable.vala"
		_tmp17_ = col;
#line 395 "../src/db/VideoTable.vala"
		col = _tmp17_ + 1;
#line 395 "../src/db/VideoTable.vala"
		_tmp18_ = g_strdup (md5);
#line 395 "../src/db/VideoTable.vala"
		_tmp19_ = g_free;
#line 395 "../src/db/VideoTable.vala"
		res = sqlite3_bind_text (_tmp16_, _tmp17_, _tmp18_, -1, _tmp19_);
#line 396 "../src/db/VideoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2560 "VideoTable.c"
	}
#line 399 "../src/db/VideoTable.vala"
	result = stmt;
#line 399 "../src/db/VideoTable.vala"
	_g_free0 (sql);
#line 399 "../src/db/VideoTable.vala"
	return result;
#line 2568 "VideoTable.c"
}

gboolean
video_table_has_duplicate (VideoTable* self,
                           GFile* file,
                           const gchar* md5)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
#line 402 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 402 "../src/db/VideoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 403 "../src/db/VideoTable.vala"
	_tmp0_ = video_table_get_duplicate_stmt (self, file, md5);
#line 403 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 404 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 404 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 406 "../src/db/VideoTable.vala"
	if (res == SQLITE_DONE) {
#line 408 "../src/db/VideoTable.vala"
		result = FALSE;
#line 408 "../src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 408 "../src/db/VideoTable.vala"
		return result;
#line 2601 "VideoTable.c"
	} else {
#line 409 "../src/db/VideoTable.vala"
		if (res == SQLITE_ROW) {
#line 411 "../src/db/VideoTable.vala"
			result = TRUE;
#line 411 "../src/db/VideoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 411 "../src/db/VideoTable.vala"
			return result;
#line 2611 "VideoTable.c"
		} else {
#line 413 "../src/db/VideoTable.vala"
			database_table_fatal ("VideoTable.has_duplicate", res);
#line 2615 "VideoTable.c"
		}
	}
#line 416 "../src/db/VideoTable.vala"
	result = FALSE;
#line 416 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 416 "../src/db/VideoTable.vala"
	return result;
#line 2624 "VideoTable.c"
}

static void
_vala_array_add4 (VideoID* * array,
                  int* length,
                  int* size,
                  const VideoID* value)
{
#line 426 "../src/db/VideoTable.vala"
	if ((*length) == (*size)) {
#line 426 "../src/db/VideoTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 426 "../src/db/VideoTable.vala"
		*array = g_renew (VideoID, *array, *size);
#line 2639 "VideoTable.c"
	}
#line 426 "../src/db/VideoTable.vala"
	(*array)[(*length)++] = *value;
#line 2643 "VideoTable.c"
}

VideoID*
video_table_get_duplicate_ids (VideoTable* self,
                               GFile* file,
                               const gchar* md5,
                               gint* result_length1)
{
	VideoID* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	VideoID* ids = NULL;
	VideoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gint res = 0;
	sqlite3_stmt* _tmp2_;
	VideoID* _tmp7_;
	gint _tmp7__length1;
#line 419 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 419 "../src/db/VideoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 420 "../src/db/VideoTable.vala"
	_tmp0_ = video_table_get_duplicate_stmt (self, file, md5);
#line 420 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 422 "../src/db/VideoTable.vala"
	_tmp1_ = g_new0 (VideoID, 0);
#line 422 "../src/db/VideoTable.vala"
	ids = _tmp1_;
#line 422 "../src/db/VideoTable.vala"
	ids_length1 = 0;
#line 422 "../src/db/VideoTable.vala"
	_ids_size_ = ids_length1;
#line 424 "../src/db/VideoTable.vala"
	_tmp2_ = stmt;
#line 424 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp2_);
#line 425 "../src/db/VideoTable.vala"
	while (TRUE) {
#line 2685 "VideoTable.c"
		VideoID* _tmp3_;
		gint _tmp3__length1;
		sqlite3_stmt* _tmp4_;
		VideoID _tmp5_ = {0};
		sqlite3_stmt* _tmp6_;
#line 425 "../src/db/VideoTable.vala"
		if (!(res == SQLITE_ROW)) {
#line 425 "../src/db/VideoTable.vala"
			break;
#line 2695 "VideoTable.c"
		}
#line 426 "../src/db/VideoTable.vala"
		_tmp3_ = ids;
#line 426 "../src/db/VideoTable.vala"
		_tmp3__length1 = ids_length1;
#line 426 "../src/db/VideoTable.vala"
		_tmp4_ = stmt;
#line 426 "../src/db/VideoTable.vala"
		video_id_init (&_tmp5_, sqlite3_column_int64 (_tmp4_, 0));
#line 426 "../src/db/VideoTable.vala"
		_vala_array_add4 (&ids, &ids_length1, &_ids_size_, &_tmp5_);
#line 427 "../src/db/VideoTable.vala"
		_tmp6_ = stmt;
#line 427 "../src/db/VideoTable.vala"
		res = sqlite3_step (_tmp6_);
#line 2711 "VideoTable.c"
	}
#line 430 "../src/db/VideoTable.vala"
	_tmp7_ = ids;
#line 430 "../src/db/VideoTable.vala"
	_tmp7__length1 = ids_length1;
#line 430 "../src/db/VideoTable.vala"
	if (result_length1) {
#line 430 "../src/db/VideoTable.vala"
		*result_length1 = _tmp7__length1;
#line 2721 "VideoTable.c"
	}
#line 430 "../src/db/VideoTable.vala"
	result = _tmp7_;
#line 430 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 430 "../src/db/VideoTable.vala"
	return result;
#line 2729 "VideoTable.c"
}

GeeArrayList*
video_table_get_event_source_ids (VideoTable* self,
                                  EventID* event_id)
{
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	EventID _tmp4_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp5_;
#line 433 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 433 "../src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 435 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 435 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM VideoTable WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 435 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 435 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 435 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 436 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 438 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 438 "../src/db/VideoTable.vala"
	_tmp4_ = *event_id;
#line 438 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 439 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 441 "../src/db/VideoTable.vala"
	_tmp5_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 441 "../src/db/VideoTable.vala"
	_result_ = _tmp5_;
#line 2774 "VideoTable.c"
	{
		gboolean _tmp6_ = FALSE;
#line 442 "../src/db/VideoTable.vala"
		_tmp6_ = TRUE;
#line 442 "../src/db/VideoTable.vala"
		while (TRUE) {
#line 2781 "VideoTable.c"
			sqlite3_stmt* _tmp7_;
			GeeArrayList* _tmp8_;
			sqlite3_stmt* _tmp9_;
			VideoID _tmp10_ = {0};
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 442 "../src/db/VideoTable.vala"
			if (!_tmp6_) {
#line 2790 "VideoTable.c"
			}
#line 442 "../src/db/VideoTable.vala"
			_tmp6_ = FALSE;
#line 443 "../src/db/VideoTable.vala"
			_tmp7_ = stmt;
#line 443 "../src/db/VideoTable.vala"
			res = sqlite3_step (_tmp7_);
#line 444 "../src/db/VideoTable.vala"
			if (res == SQLITE_DONE) {
#line 445 "../src/db/VideoTable.vala"
				break;
#line 2802 "VideoTable.c"
			} else {
#line 446 "../src/db/VideoTable.vala"
				if (res != SQLITE_ROW) {
#line 447 "../src/db/VideoTable.vala"
					database_table_fatal ("get_event_source_ids", res);
#line 449 "../src/db/VideoTable.vala"
					break;
#line 2810 "VideoTable.c"
				}
			}
#line 452 "../src/db/VideoTable.vala"
			_tmp8_ = _result_;
#line 452 "../src/db/VideoTable.vala"
			_tmp9_ = stmt;
#line 452 "../src/db/VideoTable.vala"
			video_id_init (&_tmp10_, sqlite3_column_int64 (_tmp9_, 0));
#line 452 "../src/db/VideoTable.vala"
			_tmp11_ = video_id_upgrade_video_id_to_source_id (&_tmp10_);
#line 452 "../src/db/VideoTable.vala"
			_tmp12_ = _tmp11_;
#line 452 "../src/db/VideoTable.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp12_);
#line 452 "../src/db/VideoTable.vala"
			_g_free0 (_tmp12_);
#line 2827 "VideoTable.c"
		}
	}
#line 455 "../src/db/VideoTable.vala"
	result = _result_;
#line 455 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 455 "../src/db/VideoTable.vala"
	return result;
#line 2836 "VideoTable.c"
}

void
video_table_set_timestamp (VideoTable* self,
                           VideoID* video_id,
                           time_t timestamp,
                           GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 458 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 458 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 459 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 459 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "timestamp", (gint64) timestamp, &_inner_error0_);
#line 459 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 459 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 459 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 459 "../src/db/VideoTable.vala"
			return;
#line 2863 "VideoTable.c"
		} else {
#line 459 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 459 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 459 "../src/db/VideoTable.vala"
			return;
#line 2871 "VideoTable.c"
		}
	}
}

static void
video_table_class_init (VideoTableClass * klass,
                        gpointer klass_data)
{
#line 59 "../src/db/VideoTable.vala"
	video_table_parent_class = g_type_class_peek_parent (klass);
#line 59 "../src/db/VideoTable.vala"
	((DatabaseTableClass *) klass)->finalize = video_table_finalize;
#line 2884 "VideoTable.c"
}

static void
video_table_instance_init (VideoTable * self,
                           gpointer klass)
{
}

static void
video_table_finalize (DatabaseTable * obj)
{
	VideoTable * self;
#line 59 "../src/db/VideoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_TABLE, VideoTable);
#line 59 "../src/db/VideoTable.vala"
	DATABASE_TABLE_CLASS (video_table_parent_class)->finalize (obj);
#line 2901 "VideoTable.c"
}

GType
video_table_get_type (void)
{
	static volatile gsize video_table_type_id__volatile = 0;
	if (g_once_init_enter (&video_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoTable), 0, (GInstanceInitFunc) video_table_instance_init, NULL };
		GType video_table_type_id;
		video_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "VideoTable", &g_define_type_info, 0);
		g_once_init_leave (&video_table_type_id__volatile, video_table_type_id);
	}
	return video_table_type_id__volatile;
}

