/* file.c generated by valac 0.44.3, the Vala compiler
 * generated from file.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Returns true if the file is claimed, false if it exists, and throws an Error otherwise.  The file*/
/* will be created when the function exits and should be overwritten.  Note that the file is not*/
/* held open; claiming a file is merely based on its existence.*/
/**/
/* This function is thread-safe.*/

#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include <time.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

gboolean claim_file (GFile* file,
                     GError** error);
GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GError** error);
void disassemble_filename (const gchar* basename,
                           gchar* * name,
                           gchar* * ext);
glong find_last_offset (const gchar* str,
                        gchar c);
guint64 query_total_file_size (GFile* file_or_dir,
                               GCancellable* cancellable,
                               GError** error);
void delete_all_files (GFile* dir,
                       GeeSet* exceptions,
                       ProgressMonitor monitor,
                       gpointer monitor_target,
                       guint64 file_count,
                       GCancellable* cancellable,
                       GError** error);
time_t query_file_modified (GFile* file,
                            GError** error);
gboolean query_is_directory (GFile* file);
gboolean query_is_directory_empty (GFile* dir,
                                   GError** error);
gchar* get_display_pathname (GFile* file);
gchar* strip_pretty_path (const gchar* path);
gchar* get_file_info_id (GFileInfo* info);
void skip_uint64 (GInputStream* input,
                  guint64 skip_amount,
                  GError** error);
guint64 count_files_in_directory (GFile* dir,
                                  GError** error);
gboolean file_equal (GFile* a,
                     GFile* b);
guint file_hash (GFile* file);

static gpointer
_g_error_copy0 (gpointer self)
{
#line 23 "../src/util/file.vala"
	return self ? g_error_copy (self) : NULL;
#line 72 "file.c"
}

gboolean
claim_file (GFile* file,
            GError** error)
{
	gboolean result = FALSE;
	gboolean _tmp9_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 12 "../src/util/file.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 84 "file.c"
	{
		GFileOutputStream* _tmp0_;
		GFileOutputStream* _tmp1_;
#line 14 "../src/util/file.vala"
		_tmp0_ = g_file_create (file, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 14 "../src/util/file.vala"
		_tmp1_ = _tmp0_;
#line 14 "../src/util/file.vala"
		_g_object_unref0 (_tmp1_);
#line 14 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "file.c"
			goto __catch0_g_error;
		}
#line 17 "../src/util/file.vala"
		result = TRUE;
#line 17 "../src/util/file.vala"
		return result;
#line 103 "file.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
#line 13 "../src/util/file.vala"
		err = _inner_error0_;
#line 13 "../src/util/file.vala"
		_inner_error0_ = NULL;
#line 20 "../src/util/file.vala"
		_tmp2_ = err;
#line 20 "../src/util/file.vala"
		if (!g_error_matches (_tmp2_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 118 "file.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
			GError* _tmp5_;
			const gchar* _tmp6_;
			GError* _tmp7_;
			GError* _tmp8_;
#line 21 "../src/util/file.vala"
			_tmp3_ = g_file_get_path (file);
#line 21 "../src/util/file.vala"
			_tmp4_ = _tmp3_;
#line 21 "../src/util/file.vala"
			_tmp5_ = err;
#line 21 "../src/util/file.vala"
			_tmp6_ = _tmp5_->message;
#line 21 "../src/util/file.vala"
			g_warning ("file.vala:21: claim_file %s: %s", _tmp4_, _tmp6_);
#line 21 "../src/util/file.vala"
			_g_free0 (_tmp4_);
#line 23 "../src/util/file.vala"
			_tmp7_ = err;
#line 23 "../src/util/file.vala"
			_tmp8_ = _g_error_copy0 (_tmp7_);
#line 23 "../src/util/file.vala"
			_inner_error0_ = _tmp8_;
#line 23 "../src/util/file.vala"
			_g_error_free0 (err);
#line 145 "file.c"
			goto __finally0;
		}
#line 26 "../src/util/file.vala"
		result = FALSE;
#line 26 "../src/util/file.vala"
		_g_error_free0 (err);
#line 26 "../src/util/file.vala"
		return result;
#line 154 "file.c"
	}
	__finally0:
#line 13 "../src/util/file.vala"
	g_propagate_error (error, _inner_error0_);
#line 13 "../src/util/file.vala"
	return _tmp9_;
#line 161 "file.c"
}

GFile*
generate_unique_file (GFile* dir,
                      const gchar* basename,
                      gboolean* collision,
                      GError** error)
{
	gboolean _vala_collision = FALSE;
	GFile* result = NULL;
	GFile* file = NULL;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GFile* _tmp2_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 36 "../src/util/file.vala"
	g_return_val_if_fail (G_IS_FILE (dir), NULL);
#line 36 "../src/util/file.vala"
	g_return_val_if_fail (basename != NULL, NULL);
#line 38 "../src/util/file.vala"
	_tmp0_ = g_file_get_child (dir, basename);
#line 38 "../src/util/file.vala"
	file = _tmp0_;
#line 39 "../src/util/file.vala"
	_tmp2_ = file;
#line 39 "../src/util/file.vala"
	_tmp1_ = claim_file (_tmp2_, &_inner_error0_);
#line 39 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 39 "../src/util/file.vala"
		_g_object_unref0 (file);
#line 39 "../src/util/file.vala"
		return NULL;
#line 203 "file.c"
	}
#line 39 "../src/util/file.vala"
	if (_tmp1_) {
#line 40 "../src/util/file.vala"
		_vala_collision = FALSE;
#line 42 "../src/util/file.vala"
		result = file;
#line 42 "../src/util/file.vala"
		if (collision) {
#line 42 "../src/util/file.vala"
			*collision = _vala_collision;
#line 215 "file.c"
		}
#line 42 "../src/util/file.vala"
		return result;
#line 219 "file.c"
	}
#line 46 "../src/util/file.vala"
	_vala_collision = TRUE;
#line 49 "../src/util/file.vala"
	disassemble_filename (basename, &_tmp3_, &_tmp4_);
#line 49 "../src/util/file.vala"
	_g_free0 (name);
#line 49 "../src/util/file.vala"
	name = _tmp3_;
#line 49 "../src/util/file.vala"
	_g_free0 (ext);
#line 49 "../src/util/file.vala"
	ext = _tmp4_;
#line 233 "file.c"
	{
		gint ctr = 0;
#line 52 "../src/util/file.vala"
		ctr = 1;
#line 238 "file.c"
		{
			gboolean _tmp5_ = FALSE;
#line 52 "../src/util/file.vala"
			_tmp5_ = TRUE;
#line 52 "../src/util/file.vala"
			while (TRUE) {
#line 245 "file.c"
				gchar* _tmp7_ = NULL;
				const gchar* _tmp8_;
				gchar* new_name = NULL;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				GFile* _tmp16_;
				gboolean _tmp17_ = FALSE;
				GFile* _tmp18_;
#line 52 "../src/util/file.vala"
				if (!_tmp5_) {
#line 256 "file.c"
					gint _tmp6_;
#line 52 "../src/util/file.vala"
					_tmp6_ = ctr;
#line 52 "../src/util/file.vala"
					ctr = _tmp6_ + 1;
#line 262 "file.c"
				}
#line 52 "../src/util/file.vala"
				_tmp5_ = FALSE;
#line 52 "../src/util/file.vala"
				if (!(ctr < G_MAXINT)) {
#line 52 "../src/util/file.vala"
					break;
#line 270 "file.c"
				}
#line 53 "../src/util/file.vala"
				_tmp8_ = ext;
#line 53 "../src/util/file.vala"
				if (_tmp8_ != NULL) {
#line 276 "file.c"
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 53 "../src/util/file.vala"
					_tmp9_ = name;
#line 53 "../src/util/file.vala"
					_tmp10_ = ext;
#line 53 "../src/util/file.vala"
					_tmp11_ = g_strdup_printf ("%s_%d.%s", _tmp9_, ctr, _tmp10_);
#line 53 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 53 "../src/util/file.vala"
					_tmp7_ = _tmp11_;
#line 290 "file.c"
				} else {
					const gchar* _tmp12_;
					gchar* _tmp13_;
#line 53 "../src/util/file.vala"
					_tmp12_ = name;
#line 53 "../src/util/file.vala"
					_tmp13_ = g_strdup_printf ("%s_%d", _tmp12_, ctr);
#line 53 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 53 "../src/util/file.vala"
					_tmp7_ = _tmp13_;
#line 302 "file.c"
				}
#line 53 "../src/util/file.vala"
				_tmp14_ = g_strdup (_tmp7_);
#line 53 "../src/util/file.vala"
				new_name = _tmp14_;
#line 55 "../src/util/file.vala"
				_tmp15_ = new_name;
#line 55 "../src/util/file.vala"
				_tmp16_ = g_file_get_child (dir, _tmp15_);
#line 55 "../src/util/file.vala"
				_g_object_unref0 (file);
#line 55 "../src/util/file.vala"
				file = _tmp16_;
#line 56 "../src/util/file.vala"
				_tmp18_ = file;
#line 56 "../src/util/file.vala"
				_tmp17_ = claim_file (_tmp18_, &_inner_error0_);
#line 56 "../src/util/file.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/util/file.vala"
					g_propagate_error (error, _inner_error0_);
#line 56 "../src/util/file.vala"
					_g_free0 (new_name);
#line 56 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 56 "../src/util/file.vala"
					_g_free0 (ext);
#line 56 "../src/util/file.vala"
					_g_free0 (name);
#line 56 "../src/util/file.vala"
					_g_object_unref0 (file);
#line 56 "../src/util/file.vala"
					return NULL;
#line 336 "file.c"
				}
#line 56 "../src/util/file.vala"
				if (_tmp17_) {
#line 57 "../src/util/file.vala"
					result = file;
#line 57 "../src/util/file.vala"
					_g_free0 (new_name);
#line 57 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 57 "../src/util/file.vala"
					_g_free0 (ext);
#line 57 "../src/util/file.vala"
					_g_free0 (name);
#line 57 "../src/util/file.vala"
					if (collision) {
#line 57 "../src/util/file.vala"
						*collision = _vala_collision;
#line 354 "file.c"
					}
#line 57 "../src/util/file.vala"
					return result;
#line 358 "file.c"
				}
#line 52 "../src/util/file.vala"
				_g_free0 (new_name);
#line 52 "../src/util/file.vala"
				_g_free0 (_tmp7_);
#line 364 "file.c"
			}
		}
	}
#line 60 "../src/util/file.vala"
	_tmp19_ = g_file_get_path (dir);
#line 60 "../src/util/file.vala"
	_tmp20_ = _tmp19_;
#line 60 "../src/util/file.vala"
	g_warning ("file.vala:60: generate_unique_filename %s for %s: unable to claim file", _tmp20_, basename);
#line 60 "../src/util/file.vala"
	_g_free0 (_tmp20_);
#line 62 "../src/util/file.vala"
	result = NULL;
#line 62 "../src/util/file.vala"
	_g_free0 (ext);
#line 62 "../src/util/file.vala"
	_g_free0 (name);
#line 62 "../src/util/file.vala"
	_g_object_unref0 (file);
#line 62 "../src/util/file.vala"
	if (collision) {
#line 62 "../src/util/file.vala"
		*collision = _vala_collision;
#line 388 "file.c"
	}
#line 62 "../src/util/file.vala"
	return result;
#line 392 "file.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 415 "file.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 424 "file.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 443 "file.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 447 "file.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 453 "file.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 463 "file.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 471 "file.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 475 "file.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 481 "file.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 491 "file.c"
}

void
disassemble_filename (const gchar* basename,
                      gchar* * name,
                      gchar* * ext)
{
	gchar* _vala_name = NULL;
	gchar* _vala_ext = NULL;
	glong offset = 0L;
#line 65 "../src/util/file.vala"
	g_return_if_fail (basename != NULL);
#line 66 "../src/util/file.vala"
	offset = find_last_offset (basename, '.');
#line 67 "../src/util/file.vala"
	if (offset <= ((glong) 0)) {
#line 508 "file.c"
		gchar* _tmp0_;
#line 68 "../src/util/file.vala"
		_tmp0_ = g_strdup (basename);
#line 68 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 68 "../src/util/file.vala"
		_vala_name = _tmp0_;
#line 69 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 69 "../src/util/file.vala"
		_vala_ext = NULL;
#line 520 "file.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 71 "../src/util/file.vala"
		_tmp1_ = string_substring (basename, (glong) 0, offset);
#line 71 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 71 "../src/util/file.vala"
		_vala_name = _tmp1_;
#line 72 "../src/util/file.vala"
		_tmp2_ = string_substring (basename, offset + 1, (glong) -1);
#line 72 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 72 "../src/util/file.vala"
		_vala_ext = _tmp2_;
#line 536 "file.c"
	}
#line 65 "../src/util/file.vala"
	if (name) {
#line 65 "../src/util/file.vala"
		*name = _vala_name;
#line 542 "file.c"
	} else {
#line 65 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 546 "file.c"
	}
#line 65 "../src/util/file.vala"
	if (ext) {
#line 65 "../src/util/file.vala"
		*ext = _vala_ext;
#line 552 "file.c"
	} else {
#line 65 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 556 "file.c"
	}
}

guint64
query_total_file_size (GFile* file_or_dir,
                       GCancellable* cancellable,
                       GError** error)
{
	guint64 result = 0ULL;
	GFileType type = 0;
	GFileType _tmp0_;
	GFileEnumerator* enumerator = NULL;
	guint64 total_bytes = 0ULL;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
#line 77 "../src/util/file.vala"
	g_return_val_if_fail (G_IS_FILE (file_or_dir), 0ULL);
#line 77 "../src/util/file.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0ULL);
#line 78 "../src/util/file.vala"
	type = g_file_query_file_type (file_or_dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 79 "../src/util/file.vala"
	_tmp0_ = type;
#line 79 "../src/util/file.vala"
	if (_tmp0_ == G_FILE_TYPE_REGULAR) {
#line 582 "file.c"
		GFileInfo* info = NULL;
		GFileInfo* _tmp12_;
#line 80 "../src/util/file.vala"
		info = NULL;
#line 587 "file.c"
		{
			GFileInfo* _tmp1_ = NULL;
			GFileInfo* _tmp2_;
			GFileInfo* _tmp3_;
#line 82 "../src/util/file.vala"
			_tmp2_ = g_file_query_info (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 82 "../src/util/file.vala"
			_tmp1_ = _tmp2_;
#line 82 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 598 "file.c"
				goto __catch1_g_error;
			}
#line 82 "../src/util/file.vala"
			_tmp3_ = _tmp1_;
#line 82 "../src/util/file.vala"
			_tmp1_ = NULL;
#line 82 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 82 "../src/util/file.vala"
			info = _tmp3_;
#line 81 "../src/util/file.vala"
			_g_object_unref0 (_tmp1_);
#line 611 "file.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GError* _tmp4_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 81 "../src/util/file.vala"
			err = _inner_error0_;
#line 81 "../src/util/file.vala"
			_inner_error0_ = NULL;
#line 85 "../src/util/file.vala"
			_tmp4_ = err;
#line 85 "../src/util/file.vala"
			if (g_error_matches (_tmp4_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 630 "file.c"
				GError* _tmp5_;
				GError* _tmp6_;
#line 86 "../src/util/file.vala"
				_tmp5_ = err;
#line 86 "../src/util/file.vala"
				_tmp6_ = _g_error_copy0 (_tmp5_);
#line 86 "../src/util/file.vala"
				_inner_error0_ = _tmp6_;
#line 86 "../src/util/file.vala"
				_g_error_free0 (err);
#line 641 "file.c"
				goto __finally1;
			}
#line 88 "../src/util/file.vala"
			_tmp7_ = g_file_get_path (file_or_dir);
#line 88 "../src/util/file.vala"
			_tmp8_ = _tmp7_;
#line 88 "../src/util/file.vala"
			_tmp9_ = err;
#line 88 "../src/util/file.vala"
			_tmp10_ = _tmp9_->message;
#line 88 "../src/util/file.vala"
			g_debug ("file.vala:88: Unable to query filesize for %s: %s", _tmp8_, _tmp10_);
#line 88 "../src/util/file.vala"
			_g_free0 (_tmp8_);
#line 90 "../src/util/file.vala"
			result = (guint64) 0;
#line 90 "../src/util/file.vala"
			_g_error_free0 (err);
#line 90 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 90 "../src/util/file.vala"
			return result;
#line 664 "file.c"
		}
		__finally1:
#line 81 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 669 "file.c"
			guint64 _tmp11_ = 0ULL;
#line 81 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 81 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 81 "../src/util/file.vala"
			return _tmp11_;
#line 677 "file.c"
		}
#line 93 "../src/util/file.vala"
		_tmp12_ = info;
#line 93 "../src/util/file.vala"
		result = (guint64) g_file_info_get_size (_tmp12_);
#line 93 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 93 "../src/util/file.vala"
		return result;
#line 687 "file.c"
	} else {
		GFileType _tmp13_;
#line 94 "../src/util/file.vala"
		_tmp13_ = type;
#line 94 "../src/util/file.vala"
		if (_tmp13_ != G_FILE_TYPE_DIRECTORY) {
#line 95 "../src/util/file.vala"
			result = (guint64) 0;
#line 95 "../src/util/file.vala"
			return result;
#line 698 "file.c"
		}
	}
	{
		GFileEnumerator* _tmp14_ = NULL;
		GFileEnumerator* _tmp15_;
		GFileEnumerator* _tmp16_;
		GFileEnumerator* _tmp17_;
#line 100 "../src/util/file.vala"
		_tmp15_ = g_file_enumerate_children (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 100 "../src/util/file.vala"
		_tmp14_ = _tmp15_;
#line 100 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 712 "file.c"
			goto __catch2_g_error;
		}
#line 100 "../src/util/file.vala"
		_tmp16_ = _tmp14_;
#line 100 "../src/util/file.vala"
		_tmp14_ = NULL;
#line 100 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 100 "../src/util/file.vala"
		enumerator = _tmp16_;
#line 102 "../src/util/file.vala"
		_tmp17_ = enumerator;
#line 102 "../src/util/file.vala"
		if (_tmp17_ == NULL) {
#line 103 "../src/util/file.vala"
			result = (guint64) 0;
#line 103 "../src/util/file.vala"
			_g_object_unref0 (_tmp14_);
#line 103 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 103 "../src/util/file.vala"
			return result;
#line 735 "file.c"
		}
#line 99 "../src/util/file.vala"
		_g_object_unref0 (_tmp14_);
#line 739 "file.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* err = NULL;
		gboolean _tmp18_ = FALSE;
		GError* _tmp19_;
		GError* _tmp21_;
		GError* _tmp22_;
#line 99 "../src/util/file.vala"
		err = _inner_error0_;
#line 99 "../src/util/file.vala"
		_inner_error0_ = NULL;
#line 106 "../src/util/file.vala"
		_tmp19_ = err;
#line 106 "../src/util/file.vala"
		if (g_error_matches (_tmp19_, G_FILE_ERROR, G_FILE_ERROR_PERM)) {
#line 106 "../src/util/file.vala"
			_tmp18_ = TRUE;
#line 759 "file.c"
		} else {
			GError* _tmp20_;
#line 106 "../src/util/file.vala"
			_tmp20_ = err;
#line 106 "../src/util/file.vala"
			_tmp18_ = g_error_matches (_tmp20_, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED);
#line 766 "file.c"
		}
#line 106 "../src/util/file.vala"
		if (_tmp18_) {
#line 107 "../src/util/file.vala"
			result = (guint64) 0;
#line 107 "../src/util/file.vala"
			_g_error_free0 (err);
#line 107 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 107 "../src/util/file.vala"
			return result;
#line 778 "file.c"
		}
#line 109 "../src/util/file.vala"
		_tmp21_ = err;
#line 109 "../src/util/file.vala"
		_tmp22_ = _g_error_copy0 (_tmp21_);
#line 109 "../src/util/file.vala"
		_inner_error0_ = _tmp22_;
#line 109 "../src/util/file.vala"
		_g_error_free0 (err);
#line 788 "file.c"
		goto __finally2;
	}
	__finally2:
#line 99 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 794 "file.c"
		guint64 _tmp23_ = 0ULL;
#line 99 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 99 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 99 "../src/util/file.vala"
		return _tmp23_;
#line 802 "file.c"
	}
#line 112 "../src/util/file.vala"
	total_bytes = (guint64) 0;
#line 114 "../src/util/file.vala"
	info = NULL;
#line 115 "../src/util/file.vala"
	while (TRUE) {
#line 810 "file.c"
		GFileInfo* _tmp24_ = NULL;
		GFileEnumerator* _tmp25_;
		GFileInfo* _tmp26_;
		GFileInfo* _tmp28_;
		GFileInfo* _tmp29_;
		guint64 _tmp30_ = 0ULL;
		GFileInfo* _tmp31_;
		const gchar* _tmp32_;
		GFile* _tmp33_;
		GFile* _tmp34_;
		guint64 _tmp35_;
#line 115 "../src/util/file.vala"
		_tmp25_ = enumerator;
#line 115 "../src/util/file.vala"
		_tmp26_ = g_file_enumerator_next_file (_tmp25_, cancellable, &_inner_error0_);
#line 115 "../src/util/file.vala"
		_tmp24_ = _tmp26_;
#line 115 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 830 "file.c"
			guint64 _tmp27_ = 0ULL;
#line 115 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 115 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 115 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 115 "../src/util/file.vala"
			return _tmp27_;
#line 840 "file.c"
		}
#line 115 "../src/util/file.vala"
		_tmp28_ = _tmp24_;
#line 115 "../src/util/file.vala"
		_tmp24_ = NULL;
#line 115 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 115 "../src/util/file.vala"
		info = _tmp28_;
#line 115 "../src/util/file.vala"
		_tmp29_ = info;
#line 115 "../src/util/file.vala"
		if (!(_tmp29_ != NULL)) {
#line 115 "../src/util/file.vala"
			_g_object_unref0 (_tmp24_);
#line 115 "../src/util/file.vala"
			break;
#line 858 "file.c"
		}
#line 116 "../src/util/file.vala"
		_tmp31_ = info;
#line 116 "../src/util/file.vala"
		_tmp32_ = g_file_info_get_name (_tmp31_);
#line 116 "../src/util/file.vala"
		_tmp33_ = g_file_get_child (file_or_dir, _tmp32_);
#line 116 "../src/util/file.vala"
		_tmp34_ = _tmp33_;
#line 116 "../src/util/file.vala"
		_tmp35_ = query_total_file_size (_tmp34_, cancellable, &_inner_error0_);
#line 116 "../src/util/file.vala"
		_g_object_unref0 (_tmp34_);
#line 116 "../src/util/file.vala"
		_tmp30_ = _tmp35_;
#line 116 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 876 "file.c"
			guint64 _tmp36_ = 0ULL;
#line 116 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 116 "../src/util/file.vala"
			_g_object_unref0 (_tmp24_);
#line 116 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 116 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 116 "../src/util/file.vala"
			return _tmp36_;
#line 888 "file.c"
		}
#line 116 "../src/util/file.vala"
		total_bytes = total_bytes + _tmp30_;
#line 115 "../src/util/file.vala"
		_g_object_unref0 (_tmp24_);
#line 894 "file.c"
	}
#line 118 "../src/util/file.vala"
	result = total_bytes;
#line 118 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 118 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 118 "../src/util/file.vala"
	return result;
#line 904 "file.c"
}

void
delete_all_files (GFile* dir,
                  GeeSet* exceptions,
                  ProgressMonitor monitor,
                  gpointer monitor_target,
                  guint64 file_count,
                  GCancellable* cancellable,
                  GError** error)
{
	GFileType type = 0;
	GFileType _tmp0_;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp7_;
	GFileInfo* info = NULL;
	guint64 i = 0ULL;
	GError* _inner_error0_ = NULL;
#line 125 "../src/util/file.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 125 "../src/util/file.vala"
	g_return_if_fail ((exceptions == NULL) || GEE_IS_SET (exceptions));
#line 125 "../src/util/file.vala"
	g_return_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable));
#line 127 "../src/util/file.vala"
	type = g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 128 "../src/util/file.vala"
	_tmp0_ = type;
#line 128 "../src/util/file.vala"
	if (_tmp0_ != G_FILE_TYPE_DIRECTORY) {
#line 935 "file.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 129 "../src/util/file.vala"
		_tmp1_ = g_file_get_path (dir);
#line 129 "../src/util/file.vala"
		_tmp2_ = _tmp1_;
#line 129 "../src/util/file.vala"
		_tmp3_ = g_strdup_printf ("%s is not a directory", _tmp2_);
#line 129 "../src/util/file.vala"
		_tmp4_ = _tmp3_;
#line 129 "../src/util/file.vala"
		_tmp5_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_DIRECTORY, _tmp4_);
#line 129 "../src/util/file.vala"
		_tmp6_ = _tmp5_;
#line 129 "../src/util/file.vala"
		_g_free0 (_tmp4_);
#line 129 "../src/util/file.vala"
		_g_free0 (_tmp2_);
#line 129 "../src/util/file.vala"
		_inner_error0_ = _tmp6_;
#line 129 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 129 "../src/util/file.vala"
		return;
#line 964 "file.c"
	}
#line 131 "../src/util/file.vala"
	_tmp7_ = g_file_enumerate_children (dir, "standard::name,standard::type", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 131 "../src/util/file.vala"
	enumerator = _tmp7_;
#line 131 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 131 "../src/util/file.vala"
		return;
#line 976 "file.c"
	}
#line 133 "../src/util/file.vala"
	info = NULL;
#line 134 "../src/util/file.vala"
	i = (guint64) 0;
#line 135 "../src/util/file.vala"
	while (TRUE) {
#line 984 "file.c"
		GFileInfo* _tmp8_ = NULL;
		GFileEnumerator* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		GFileInfo* _tmp13_;
		gboolean _tmp14_ = FALSE;
		GFile* file = NULL;
		GFileInfo* _tmp17_;
		const gchar* _tmp18_;
		GFile* _tmp19_;
		gboolean _tmp26_ = FALSE;
#line 135 "../src/util/file.vala"
		_tmp9_ = enumerator;
#line 135 "../src/util/file.vala"
		_tmp10_ = g_file_enumerator_next_file (_tmp9_, cancellable, &_inner_error0_);
#line 135 "../src/util/file.vala"
		_tmp8_ = _tmp10_;
#line 135 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 135 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 135 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 135 "../src/util/file.vala"
			return;
#line 1013 "file.c"
		}
#line 135 "../src/util/file.vala"
		_tmp11_ = _tmp8_;
#line 135 "../src/util/file.vala"
		_tmp8_ = NULL;
#line 135 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 135 "../src/util/file.vala"
		info = _tmp11_;
#line 135 "../src/util/file.vala"
		_tmp12_ = info;
#line 135 "../src/util/file.vala"
		if (!(_tmp12_ != NULL)) {
#line 135 "../src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 135 "../src/util/file.vala"
			break;
#line 1031 "file.c"
		}
#line 136 "../src/util/file.vala"
		_tmp13_ = info;
#line 136 "../src/util/file.vala"
		if (g_file_info_get_file_type (_tmp13_) != G_FILE_TYPE_REGULAR) {
#line 137 "../src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 137 "../src/util/file.vala"
			continue;
#line 1041 "file.c"
		}
#line 139 "../src/util/file.vala"
		if (exceptions != NULL) {
#line 1045 "file.c"
			GFileInfo* _tmp15_;
			const gchar* _tmp16_;
#line 139 "../src/util/file.vala"
			_tmp15_ = info;
#line 139 "../src/util/file.vala"
			_tmp16_ = g_file_info_get_name (_tmp15_);
#line 139 "../src/util/file.vala"
			_tmp14_ = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (exceptions, GEE_TYPE_COLLECTION, GeeCollection), _tmp16_);
#line 1054 "file.c"
		} else {
#line 139 "../src/util/file.vala"
			_tmp14_ = FALSE;
#line 1058 "file.c"
		}
#line 139 "../src/util/file.vala"
		if (_tmp14_) {
#line 140 "../src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 140 "../src/util/file.vala"
			continue;
#line 1066 "file.c"
		}
#line 142 "../src/util/file.vala"
		_tmp17_ = info;
#line 142 "../src/util/file.vala"
		_tmp18_ = g_file_info_get_name (_tmp17_);
#line 142 "../src/util/file.vala"
		_tmp19_ = g_file_get_child (dir, _tmp18_);
#line 142 "../src/util/file.vala"
		file = _tmp19_;
#line 1076 "file.c"
		{
			GFile* _tmp20_;
#line 144 "../src/util/file.vala"
			_tmp20_ = file;
#line 144 "../src/util/file.vala"
			g_file_delete (_tmp20_, cancellable, &_inner_error0_);
#line 144 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1085 "file.c"
				goto __catch3_g_error;
			}
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError* err = NULL;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 143 "../src/util/file.vala"
			err = _inner_error0_;
#line 143 "../src/util/file.vala"
			_inner_error0_ = NULL;
#line 146 "../src/util/file.vala"
			_tmp21_ = file;
#line 146 "../src/util/file.vala"
			_tmp22_ = g_file_get_path (_tmp21_);
#line 146 "../src/util/file.vala"
			_tmp23_ = _tmp22_;
#line 146 "../src/util/file.vala"
			_tmp24_ = err;
#line 146 "../src/util/file.vala"
			_tmp25_ = _tmp24_->message;
#line 146 "../src/util/file.vala"
			g_warning ("file.vala:146: Unable to delete file %s: %s", _tmp23_, _tmp25_);
#line 146 "../src/util/file.vala"
			_g_free0 (_tmp23_);
#line 143 "../src/util/file.vala"
			_g_error_free0 (err);
#line 1118 "file.c"
		}
		__finally3:
#line 143 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 143 "../src/util/file.vala"
			_g_object_unref0 (file);
#line 143 "../src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 143 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 143 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 143 "../src/util/file.vala"
			return;
#line 1135 "file.c"
		}
#line 149 "../src/util/file.vala"
		if (monitor != NULL) {
#line 149 "../src/util/file.vala"
			_tmp26_ = file_count > ((guint64) 0);
#line 1141 "file.c"
		} else {
#line 149 "../src/util/file.vala"
			_tmp26_ = FALSE;
#line 1145 "file.c"
		}
#line 149 "../src/util/file.vala"
		if (_tmp26_) {
#line 150 "../src/util/file.vala"
			i = i + 1;
#line 150 "../src/util/file.vala"
			monitor (file_count, i, TRUE, monitor_target);
#line 1153 "file.c"
		}
#line 135 "../src/util/file.vala"
		_g_object_unref0 (file);
#line 135 "../src/util/file.vala"
		_g_object_unref0 (_tmp8_);
#line 1159 "file.c"
	}
#line 125 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 125 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 1165 "file.c"
}

time_t
query_file_modified (GFile* file,
                     GError** error)
{
	time_t result = 0;
	GFileInfo* info = NULL;
	GFileInfo* _tmp0_;
	GTimeVal _tmp2_ = {0};
	GError* _inner_error0_ = NULL;
#line 154 "../src/util/file.vala"
	g_return_val_if_fail (G_IS_FILE (file), 0);
#line 155 "../src/util/file.vala"
	_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 155 "../src/util/file.vala"
	info = _tmp0_;
#line 155 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1185 "file.c"
		time_t _tmp1_ = 0;
#line 155 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 155 "../src/util/file.vala"
		return _tmp1_;
#line 1191 "file.c"
	}
#line 158 "../src/util/file.vala"
	g_file_info_get_modification_time (info, &_tmp2_);
#line 158 "../src/util/file.vala"
	result = (time_t) _tmp2_.tv_sec;
#line 158 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 158 "../src/util/file.vala"
	return result;
#line 1201 "file.c"
}

gboolean
query_is_directory (GFile* file)
{
	gboolean result = FALSE;
#line 161 "../src/util/file.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 162 "../src/util/file.vala"
	result = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) == G_FILE_TYPE_DIRECTORY;
#line 162 "../src/util/file.vala"
	return result;
#line 1214 "file.c"
}

gboolean
query_is_directory_empty (GFile* dir,
                          GError** error)
{
	gboolean result = FALSE;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileEnumerator* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	GFileEnumerator* _tmp4_;
	GFileInfo* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 165 "../src/util/file.vala"
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
#line 166 "../src/util/file.vala"
	if (g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 167 "../src/util/file.vala"
		result = FALSE;
#line 167 "../src/util/file.vala"
		return result;
#line 1237 "file.c"
	}
#line 169 "../src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::name", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 169 "../src/util/file.vala"
	enumerator = _tmp0_;
#line 169 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1245 "file.c"
		gboolean _tmp1_ = FALSE;
#line 169 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 169 "../src/util/file.vala"
		return _tmp1_;
#line 1251 "file.c"
	}
#line 171 "../src/util/file.vala"
	_tmp2_ = enumerator;
#line 171 "../src/util/file.vala"
	if (_tmp2_ == NULL) {
#line 172 "../src/util/file.vala"
		result = FALSE;
#line 172 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 172 "../src/util/file.vala"
		return result;
#line 1263 "file.c"
	}
#line 174 "../src/util/file.vala"
	_tmp4_ = enumerator;
#line 174 "../src/util/file.vala"
	_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
#line 174 "../src/util/file.vala"
	_tmp3_ = _tmp5_;
#line 174 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1273 "file.c"
		gboolean _tmp6_ = FALSE;
#line 174 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 174 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 174 "../src/util/file.vala"
		return _tmp6_;
#line 1281 "file.c"
	}
#line 174 "../src/util/file.vala"
	result = _tmp3_ == NULL;
#line 174 "../src/util/file.vala"
	_g_object_unref0 (_tmp3_);
#line 174 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 174 "../src/util/file.vala"
	return result;
#line 1291 "file.c"
}

gchar*
get_display_pathname (GFile* file)
{
	gchar* result = NULL;
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* home = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 177 "../src/util/file.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 179 "../src/util/file.vala"
	_tmp0_ = g_file_get_parse_name (file);
#line 179 "../src/util/file.vala"
	path = _tmp0_;
#line 180 "../src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 180 "../src/util/file.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 180 "../src/util/file.vala"
	home = _tmp2_;
#line 182 "../src/util/file.vala"
	_tmp3_ = path;
#line 182 "../src/util/file.vala"
	_tmp4_ = home;
#line 182 "../src/util/file.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 1325 "file.c"
		gchar* _tmp5_;
#line 183 "../src/util/file.vala"
		_tmp5_ = g_strdup ("~");
#line 183 "../src/util/file.vala"
		result = _tmp5_;
#line 183 "../src/util/file.vala"
		_g_free0 (home);
#line 183 "../src/util/file.vala"
		_g_free0 (path);
#line 183 "../src/util/file.vala"
		return result;
#line 1337 "file.c"
	}
#line 185 "../src/util/file.vala"
	_tmp6_ = path;
#line 185 "../src/util/file.vala"
	_tmp7_ = home;
#line 185 "../src/util/file.vala"
	if (g_str_has_prefix (_tmp6_, _tmp7_)) {
#line 1345 "file.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 186 "../src/util/file.vala"
		_tmp8_ = path;
#line 186 "../src/util/file.vala"
		_tmp9_ = home;
#line 186 "../src/util/file.vala"
		_tmp10_ = strlen (_tmp9_);
#line 186 "../src/util/file.vala"
		_tmp11_ = _tmp10_;
#line 186 "../src/util/file.vala"
		_tmp12_ = string_substring (_tmp8_, (glong) _tmp11_, (glong) -1);
#line 186 "../src/util/file.vala"
		_tmp13_ = _tmp12_;
#line 186 "../src/util/file.vala"
		_tmp14_ = g_strdup_printf ("~%s", _tmp13_);
#line 186 "../src/util/file.vala"
		_tmp15_ = _tmp14_;
#line 186 "../src/util/file.vala"
		_g_free0 (_tmp13_);
#line 186 "../src/util/file.vala"
		result = _tmp15_;
#line 186 "../src/util/file.vala"
		_g_free0 (home);
#line 186 "../src/util/file.vala"
		_g_free0 (path);
#line 186 "../src/util/file.vala"
		return result;
#line 1380 "file.c"
	}
#line 188 "../src/util/file.vala"
	result = path;
#line 188 "../src/util/file.vala"
	_g_free0 (home);
#line 188 "../src/util/file.vala"
	return result;
#line 1388 "file.c"
}

gchar*
strip_pretty_path (const gchar* path)
{
	gchar* result = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 191 "../src/util/file.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 192 "../src/util/file.vala"
	if (!g_str_has_prefix (path, "~")) {
#line 1404 "file.c"
		gchar* _tmp0_;
#line 193 "../src/util/file.vala"
		_tmp0_ = g_strdup (path);
#line 193 "../src/util/file.vala"
		result = _tmp0_;
#line 193 "../src/util/file.vala"
		return result;
#line 1412 "file.c"
	}
#line 195 "../src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 195 "../src/util/file.vala"
	_tmp2_ = string_substring (path, (glong) 1, (glong) -1);
#line 195 "../src/util/file.vala"
	_tmp3_ = _tmp2_;
#line 195 "../src/util/file.vala"
	_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 195 "../src/util/file.vala"
	_tmp5_ = _tmp4_;
#line 195 "../src/util/file.vala"
	_g_free0 (_tmp3_);
#line 195 "../src/util/file.vala"
	result = _tmp5_;
#line 195 "../src/util/file.vala"
	return result;
#line 1430 "file.c"
}

gchar*
get_file_info_id (GFileInfo* info)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 198 "../src/util/file.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), NULL);
#line 199 "../src/util/file.vala"
	_tmp0_ = g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE);
#line 199 "../src/util/file.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 199 "../src/util/file.vala"
	result = _tmp1_;
#line 199 "../src/util/file.vala"
	return result;
#line 1449 "file.c"
}

void
skip_uint64 (GInputStream* input,
             guint64 skip_amount,
             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 203 "../src/util/file.vala"
	g_return_if_fail (G_IS_INPUT_STREAM (input));
#line 204 "../src/util/file.vala"
	while (TRUE) {
#line 204 "../src/util/file.vala"
		if (!(skip_amount > ((guint64) 0))) {
#line 204 "../src/util/file.vala"
			break;
#line 1466 "file.c"
		}
#line 206 "../src/util/file.vala"
		if (skip_amount >= ((guint64) G_MAXSSIZE)) {
#line 207 "../src/util/file.vala"
			g_input_stream_skip (input, (gsize) G_MAXSSIZE, NULL, &_inner_error0_);
#line 207 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "../src/util/file.vala"
				g_propagate_error (error, _inner_error0_);
#line 207 "../src/util/file.vala"
				return;
#line 1478 "file.c"
			}
#line 208 "../src/util/file.vala"
			skip_amount = skip_amount - G_MAXSSIZE;
#line 1482 "file.c"
		} else {
#line 210 "../src/util/file.vala"
			g_input_stream_skip (input, (gsize) skip_amount, NULL, &_inner_error0_);
#line 210 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 210 "../src/util/file.vala"
				g_propagate_error (error, _inner_error0_);
#line 210 "../src/util/file.vala"
				return;
#line 1492 "file.c"
			}
#line 211 "../src/util/file.vala"
			skip_amount = (guint64) 0;
#line 1496 "file.c"
		}
	}
}

guint64
count_files_in_directory (GFile* dir,
                          GError** error)
{
	guint64 result = 0ULL;
	guint64 count = 0ULL;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
#line 217 "../src/util/file.vala"
	g_return_val_if_fail (G_IS_FILE (dir), 0ULL);
#line 218 "../src/util/file.vala"
	if (!query_is_directory (dir)) {
#line 219 "../src/util/file.vala"
		result = (guint64) 0;
#line 219 "../src/util/file.vala"
		return result;
#line 1519 "file.c"
	}
#line 221 "../src/util/file.vala"
	count = (guint64) 0;
#line 222 "../src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 222 "../src/util/file.vala"
	enumerator = _tmp0_;
#line 222 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1529 "file.c"
		guint64 _tmp1_ = 0ULL;
#line 222 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 222 "../src/util/file.vala"
		return _tmp1_;
#line 1535 "file.c"
	}
#line 225 "../src/util/file.vala"
	info = NULL;
#line 226 "../src/util/file.vala"
	while (TRUE) {
#line 1541 "file.c"
		GFileInfo* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		guint64 _tmp8_;
#line 226 "../src/util/file.vala"
		_tmp3_ = enumerator;
#line 226 "../src/util/file.vala"
		_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error0_);
#line 226 "../src/util/file.vala"
		_tmp2_ = _tmp4_;
#line 226 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1556 "file.c"
			guint64 _tmp5_ = 0ULL;
#line 226 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 226 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 226 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 226 "../src/util/file.vala"
			return _tmp5_;
#line 1566 "file.c"
		}
#line 226 "../src/util/file.vala"
		_tmp6_ = _tmp2_;
#line 226 "../src/util/file.vala"
		_tmp2_ = NULL;
#line 226 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 226 "../src/util/file.vala"
		info = _tmp6_;
#line 226 "../src/util/file.vala"
		_tmp7_ = info;
#line 226 "../src/util/file.vala"
		if (!(_tmp7_ != NULL)) {
#line 226 "../src/util/file.vala"
			_g_object_unref0 (_tmp2_);
#line 226 "../src/util/file.vala"
			break;
#line 1584 "file.c"
		}
#line 227 "../src/util/file.vala"
		_tmp8_ = count;
#line 227 "../src/util/file.vala"
		count = _tmp8_ + 1;
#line 226 "../src/util/file.vala"
		_g_object_unref0 (_tmp2_);
#line 1592 "file.c"
	}
#line 229 "../src/util/file.vala"
	result = count;
#line 229 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 229 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 229 "../src/util/file.vala"
	return result;
#line 1602 "file.c"
}

gboolean
file_equal (GFile* a,
            GFile* b)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 233 "../src/util/file.vala"
	g_return_val_if_fail ((a == NULL) || G_IS_FILE (a), FALSE);
#line 233 "../src/util/file.vala"
	g_return_val_if_fail ((b == NULL) || G_IS_FILE (b), FALSE);
#line 234 "../src/util/file.vala"
	if (a != NULL) {
#line 234 "../src/util/file.vala"
		_tmp1_ = b != NULL;
#line 1620 "file.c"
	} else {
#line 234 "../src/util/file.vala"
		_tmp1_ = FALSE;
#line 1624 "file.c"
	}
#line 234 "../src/util/file.vala"
	if (_tmp1_) {
#line 234 "../src/util/file.vala"
		_tmp0_ = g_file_equal (a, b);
#line 1630 "file.c"
	} else {
#line 234 "../src/util/file.vala"
		_tmp0_ = FALSE;
#line 1634 "file.c"
	}
#line 234 "../src/util/file.vala"
	result = _tmp0_;
#line 234 "../src/util/file.vala"
	return result;
#line 1640 "file.c"
}

guint
file_hash (GFile* file)
{
	guint result = 0U;
	guint _tmp0_ = 0U;
#line 238 "../src/util/file.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), 0U);
#line 239 "../src/util/file.vala"
	if (file != NULL) {
#line 239 "../src/util/file.vala"
		_tmp0_ = g_file_hash (file);
#line 1654 "file.c"
	} else {
#line 239 "../src/util/file.vala"
		_tmp0_ = (guint) 0;
#line 1658 "file.c"
	}
#line 239 "../src/util/file.vala"
	result = _tmp0_;
#line 239 "../src/util/file.vala"
	return result;
#line 1664 "file.c"
}

