/* string.c generated by valac 0.44.3, the Vala compiler
 * generated from string.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

gint64 g_ascii_strtoll (const gchar* str,
                        gchar** endptr,
                        guint num_base);
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
gboolean is_string_empty (const gchar* s);
gint utf8_cs_compare (void* a,
                      void* b);
gint utf8_ci_compare (void* a,
                      void* b);
gchar* uchar_array_to_string (guchar* data,
                              gint data_length1,
                              gint length);
guchar* string_to_uchar_array (const gchar* str,
                               gint* result_length1);
static void _vala_array_add1 (guchar* * array,
                       int* length,
                       int* size,
                       guchar value);
gchar* guarded_markup_escape_text (const gchar* plain);
glong find_last_offset (const gchar* str,
                        gchar c);
gboolean is_in_ci_array (const gchar* str,
                         gchar** strings,
                         gint strings_length1);
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
gchar* guess_convert (const gchar* text);
gchar* prepare_input_text (const gchar* text,
                           PrepareInputTextOptions options,
                           gint dest_length);
gint64 parse_int64 (const gchar* str,
                    gint num_base);
gboolean string_contains_char (const gchar* haystack,
                               gunichar needle);
gboolean string_contains_str (const gchar* haystack,
                              const gchar* needle);
gchar* string_sliced_at (const gchar* str,
                         gint index);
gchar* string_sliced_at_first_str (const gchar* haystack,
                                   const gchar* needle,
                                   gint start_index);
gchar* string_sliced_at_last_str (const gchar* haystack,
                                  const gchar* needle,
                                  gint start_index);
gchar* string_sliced_at_first_char (const gchar* haystack,
                                    gunichar ch,
                                    gint start_index);
gchar* string_sliced_at_last_char (const gchar* haystack,
                                   gunichar ch,
                                   gint start_index);
gchar* string_strip_leading_zeroes (const gchar* str);
gchar* string_remove_diacritics (const gchar* istring);
gchar* string_to_hex_string (const gchar* str);
guint string_collated_hash (void* ptr);
guint string_precollated_hash (void* ptr);
gint string_collated_compare (void* a,
                              void* b);
gint string_precollated_compare (const gchar* astr,
                                 const gchar* akey,
                                 const gchar* bstr,
                                 const gchar* bkey);
gboolean string_collated_equals (void* a,
                                 void* b);
gboolean string_precollated_equals (const gchar* astr,
                                    const gchar* akey,
                                    const gchar* bstr,
                                    const gchar* bkey);

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 112 "string.c"
}

inline gboolean
is_string_empty (const gchar* s)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 12 "../src/util/string.vala"
	if (s == NULL) {
#line 12 "../src/util/string.vala"
		_tmp0_ = TRUE;
#line 124 "string.c"
	} else {
#line 12 "../src/util/string.vala"
		_tmp0_ = string_get (s, (glong) 0) == '\0';
#line 128 "string.c"
	}
#line 12 "../src/util/string.vala"
	result = _tmp0_;
#line 12 "../src/util/string.vala"
	return result;
#line 134 "string.c"
}

gint
utf8_cs_compare (void* a,
                 void* b)
{
	gint result = 0;
#line 17 "../src/util/string.vala"
	result = g_utf8_collate ((const gchar*) a, (const gchar*) b);
#line 17 "../src/util/string.vala"
	return result;
#line 146 "string.c"
}

gint
utf8_ci_compare (void* a,
                 void* b)
{
	gint result = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
#line 22 "../src/util/string.vala"
	_tmp0_ = g_utf8_strdown ((const gchar*) a, (gssize) -1);
#line 22 "../src/util/string.vala"
	_tmp1_ = _tmp0_;
#line 22 "../src/util/string.vala"
	_tmp2_ = g_utf8_strdown ((const gchar*) b, (gssize) -1);
#line 22 "../src/util/string.vala"
	_tmp3_ = _tmp2_;
#line 22 "../src/util/string.vala"
	_tmp4_ = g_utf8_collate (_tmp1_, _tmp3_);
#line 22 "../src/util/string.vala"
	_g_free0 (_tmp3_);
#line 22 "../src/util/string.vala"
	_g_free0 (_tmp1_);
#line 22 "../src/util/string.vala"
	result = _tmp4_;
#line 22 "../src/util/string.vala"
	return result;
#line 177 "string.c"
}

gchar*
uchar_array_to_string (guchar* data,
                       gint data_length1,
                       gint length)
{
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 27 "../src/util/string.vala"
	if (length < 0) {
#line 28 "../src/util/string.vala"
		length = data_length1;
#line 195 "string.c"
	}
#line 30 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 30 "../src/util/string.vala"
	builder = _tmp0_;
#line 201 "string.c"
	{
		gint ctr = 0;
#line 31 "../src/util/string.vala"
		ctr = 0;
#line 206 "string.c"
		{
			gboolean _tmp1_ = FALSE;
#line 31 "../src/util/string.vala"
			_tmp1_ = TRUE;
#line 31 "../src/util/string.vala"
			while (TRUE) {
#line 213 "string.c"
				guchar _tmp3_;
#line 31 "../src/util/string.vala"
				if (!_tmp1_) {
#line 217 "string.c"
					gint _tmp2_;
#line 31 "../src/util/string.vala"
					_tmp2_ = ctr;
#line 31 "../src/util/string.vala"
					ctr = _tmp2_ + 1;
#line 223 "string.c"
				}
#line 31 "../src/util/string.vala"
				_tmp1_ = FALSE;
#line 31 "../src/util/string.vala"
				if (!(ctr < length)) {
#line 31 "../src/util/string.vala"
					break;
#line 231 "string.c"
				}
#line 32 "../src/util/string.vala"
				_tmp3_ = data[ctr];
#line 32 "../src/util/string.vala"
				if (_tmp3_ != ((guchar) '\0')) {
#line 237 "string.c"
					GString* _tmp4_;
					guchar _tmp5_;
#line 33 "../src/util/string.vala"
					_tmp4_ = builder;
#line 33 "../src/util/string.vala"
					_tmp5_ = data[ctr];
#line 33 "../src/util/string.vala"
					g_string_append_c (_tmp4_, (gchar) _tmp5_);
#line 246 "string.c"
				} else {
#line 35 "../src/util/string.vala"
					break;
#line 250 "string.c"
				}
			}
		}
	}
#line 38 "../src/util/string.vala"
	_tmp6_ = builder;
#line 38 "../src/util/string.vala"
	_tmp7_ = _tmp6_->str;
#line 38 "../src/util/string.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 38 "../src/util/string.vala"
	result = _tmp8_;
#line 38 "../src/util/string.vala"
	_g_string_free0 (builder);
#line 38 "../src/util/string.vala"
	return result;
#line 267 "string.c"
}

static void
_vala_array_add1 (guchar* * array,
                  int* length,
                  int* size,
                  guchar value)
{
#line 45 "../src/util/string.vala"
	if ((*length) == (*size)) {
#line 45 "../src/util/string.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 45 "../src/util/string.vala"
		*array = g_renew (guchar, *array, *size);
#line 282 "string.c"
	}
#line 45 "../src/util/string.vala"
	(*array)[(*length)++] = value;
#line 286 "string.c"
}

guchar*
string_to_uchar_array (const gchar* str,
                       gint* result_length1)
{
	guchar* result = NULL;
	guchar* data = NULL;
	guchar* _tmp0_;
	gint data_length1;
	gint _data_size_;
	guchar* _tmp6_;
	gint _tmp6__length1;
#line 42 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 43 "../src/util/string.vala"
	_tmp0_ = g_new0 (guchar, 0);
#line 43 "../src/util/string.vala"
	data = _tmp0_;
#line 43 "../src/util/string.vala"
	data_length1 = 0;
#line 43 "../src/util/string.vala"
	_data_size_ = data_length1;
#line 310 "string.c"
	{
		gint ctr = 0;
#line 44 "../src/util/string.vala"
		ctr = 0;
#line 315 "string.c"
		{
			gboolean _tmp1_ = FALSE;
#line 44 "../src/util/string.vala"
			_tmp1_ = TRUE;
#line 44 "../src/util/string.vala"
			while (TRUE) {
#line 322 "string.c"
				gint _tmp3_;
				gint _tmp4_;
				guchar* _tmp5_;
				gint _tmp5__length1;
#line 44 "../src/util/string.vala"
				if (!_tmp1_) {
#line 329 "string.c"
					gint _tmp2_;
#line 44 "../src/util/string.vala"
					_tmp2_ = ctr;
#line 44 "../src/util/string.vala"
					ctr = _tmp2_ + 1;
#line 335 "string.c"
				}
#line 44 "../src/util/string.vala"
				_tmp1_ = FALSE;
#line 44 "../src/util/string.vala"
				_tmp3_ = strlen (str);
#line 44 "../src/util/string.vala"
				_tmp4_ = _tmp3_;
#line 44 "../src/util/string.vala"
				if (!(ctr < _tmp4_)) {
#line 44 "../src/util/string.vala"
					break;
#line 347 "string.c"
				}
#line 45 "../src/util/string.vala"
				_tmp5_ = data;
#line 45 "../src/util/string.vala"
				_tmp5__length1 = data_length1;
#line 45 "../src/util/string.vala"
				_vala_array_add1 (&data, &data_length1, &_data_size_, (guchar) string_get (str, (glong) ctr));
#line 355 "string.c"
			}
		}
	}
#line 47 "../src/util/string.vala"
	_tmp6_ = data;
#line 47 "../src/util/string.vala"
	_tmp6__length1 = data_length1;
#line 47 "../src/util/string.vala"
	if (result_length1) {
#line 47 "../src/util/string.vala"
		*result_length1 = _tmp6__length1;
#line 367 "string.c"
	}
#line 47 "../src/util/string.vala"
	result = _tmp6_;
#line 47 "../src/util/string.vala"
	return result;
#line 373 "string.c"
}

inline gchar*
guarded_markup_escape_text (const gchar* plain)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 58 "../src/util/string.vala"
	if (!is_string_empty (plain)) {
#line 58 "../src/util/string.vala"
		_tmp1_ = g_utf8_validate (plain, (gssize) -1, NULL);
#line 386 "string.c"
	} else {
#line 58 "../src/util/string.vala"
		_tmp1_ = FALSE;
#line 390 "string.c"
	}
#line 58 "../src/util/string.vala"
	if (_tmp1_) {
#line 394 "string.c"
		gchar* _tmp2_;
#line 58 "../src/util/string.vala"
		_tmp2_ = g_markup_escape_text (plain, (gssize) -1);
#line 58 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 58 "../src/util/string.vala"
		_tmp0_ = _tmp2_;
#line 402 "string.c"
	} else {
		gchar* _tmp3_;
#line 58 "../src/util/string.vala"
		_tmp3_ = g_strdup ("");
#line 58 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 58 "../src/util/string.vala"
		_tmp0_ = _tmp3_;
#line 411 "string.c"
	}
#line 58 "../src/util/string.vala"
	result = _tmp0_;
#line 58 "../src/util/string.vala"
	return result;
#line 417 "string.c"
}

glong
find_last_offset (const gchar* str,
                  gchar c)
{
	glong result = 0L;
	glong offset = 0L;
	gint _tmp0_;
	gint _tmp1_;
#line 61 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, 0L);
#line 62 "../src/util/string.vala"
	_tmp0_ = strlen (str);
#line 62 "../src/util/string.vala"
	_tmp1_ = _tmp0_;
#line 62 "../src/util/string.vala"
	offset = (glong) _tmp1_;
#line 63 "../src/util/string.vala"
	while (TRUE) {
#line 63 "../src/util/string.vala"
		offset = offset - 1;
#line 63 "../src/util/string.vala"
		if (!(offset >= ((glong) 0))) {
#line 63 "../src/util/string.vala"
			break;
#line 444 "string.c"
		}
#line 64 "../src/util/string.vala"
		if (string_get (str, offset) == c) {
#line 65 "../src/util/string.vala"
			result = offset;
#line 65 "../src/util/string.vala"
			return result;
#line 452 "string.c"
		}
	}
#line 68 "../src/util/string.vala"
	result = (glong) -1;
#line 68 "../src/util/string.vala"
	return result;
#line 459 "string.c"
}

gboolean
is_in_ci_array (const gchar* str,
                gchar** strings,
                gint strings_length1)
{
	gboolean result = FALSE;
	gchar* strdown = NULL;
	gchar* _tmp0_;
#line 73 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 74 "../src/util/string.vala"
	_tmp0_ = g_utf8_strdown (str, (gssize) -1);
#line 74 "../src/util/string.vala"
	strdown = _tmp0_;
#line 476 "string.c"
	{
		gchar** str_element_collection = NULL;
		gint str_element_collection_length1 = 0;
		gint _str_element_collection_size_ = 0;
		gint str_element_it = 0;
#line 75 "../src/util/string.vala"
		str_element_collection = strings;
#line 75 "../src/util/string.vala"
		str_element_collection_length1 = strings_length1;
#line 75 "../src/util/string.vala"
		for (str_element_it = 0; str_element_it < strings_length1; str_element_it = str_element_it + 1) {
#line 488 "string.c"
			gchar* _tmp1_;
			gchar* str_element = NULL;
#line 75 "../src/util/string.vala"
			_tmp1_ = g_strdup (str_element_collection[str_element_it]);
#line 75 "../src/util/string.vala"
			str_element = _tmp1_;
#line 495 "string.c"
			{
				const gchar* _tmp2_;
				const gchar* _tmp3_;
#line 76 "../src/util/string.vala"
				_tmp2_ = strdown;
#line 76 "../src/util/string.vala"
				_tmp3_ = str_element;
#line 76 "../src/util/string.vala"
				if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 77 "../src/util/string.vala"
					result = TRUE;
#line 77 "../src/util/string.vala"
					_g_free0 (str_element);
#line 77 "../src/util/string.vala"
					_g_free0 (strdown);
#line 77 "../src/util/string.vala"
					return result;
#line 513 "string.c"
				}
#line 75 "../src/util/string.vala"
				_g_free0 (str_element);
#line 517 "string.c"
			}
		}
	}
#line 80 "../src/util/string.vala"
	result = FALSE;
#line 80 "../src/util/string.vala"
	_g_free0 (strdown);
#line 80 "../src/util/string.vala"
	return result;
#line 527 "string.c"
}

GType
prepare_input_text_options_get_type (void)
{
	static volatile gsize prepare_input_text_options_type_id__volatile = 0;
	if (g_once_init_enter (&prepare_input_text_options_type_id__volatile)) {
		static const GFlagsValue values[] = {{PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL", "empty-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_VALIDATE, "PREPARE_INPUT_TEXT_OPTIONS_VALIDATE", "validate"}, {PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL", "invalid-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP, "PREPARE_INPUT_TEXT_OPTIONS_STRIP", "strip"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF, "PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF", "strip-crlf"}, {PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE, "PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE", "normalize"}, {PREPARE_INPUT_TEXT_OPTIONS_DEFAULT, "PREPARE_INPUT_TEXT_OPTIONS_DEFAULT", "default"}, {0, NULL, NULL}};
		GType prepare_input_text_options_type_id;
		prepare_input_text_options_type_id = g_flags_register_static ("PrepareInputTextOptions", values);
		g_once_init_leave (&prepare_input_text_options_type_id__volatile, prepare_input_text_options_type_id);
	}
	return prepare_input_text_options_type_id__volatile;
}

gchar*
guess_convert (const gchar* text)
{
	gchar* result = NULL;
	gchar* output = NULL;
	gsize bytes_read = 0UL;
	const gchar* charset = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gint _tmp22_;
	gint _tmp23_;
	GError* _inner_error0_ = NULL;
#line 94 "../src/util/string.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 95 "../src/util/string.vala"
	output = NULL;
#line 96 "../src/util/string.vala"
	bytes_read = (gsize) 0;
#line 97 "../src/util/string.vala"
	charset = NULL;
#line 98 "../src/util/string.vala"
	g_debug ("string.vala:98: CONVERT: Text did not validate as UTF-8, trying conver" \
"sion");
#line 101 "../src/util/string.vala"
	_tmp1_ = g_get_charset (&_tmp0_);
#line 101 "../src/util/string.vala"
	charset = _tmp0_;
#line 101 "../src/util/string.vala"
	if (!_tmp1_) {
#line 571 "string.c"
		gint _tmp2_;
		gint _tmp3_;
		gsize _tmp4_ = 0UL;
		gchar* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 102 "../src/util/string.vala"
		_tmp2_ = strlen (text);
#line 102 "../src/util/string.vala"
		_tmp3_ = _tmp2_;
#line 102 "../src/util/string.vala"
		_tmp5_ = g_locale_to_utf8 (text, (gssize) _tmp3_, &_tmp4_, NULL, NULL);
#line 102 "../src/util/string.vala"
		bytes_read = _tmp4_;
#line 102 "../src/util/string.vala"
		_g_free0 (output);
#line 102 "../src/util/string.vala"
		output = _tmp5_;
#line 103 "../src/util/string.vala"
		_tmp6_ = strlen (text);
#line 103 "../src/util/string.vala"
		_tmp7_ = _tmp6_;
#line 103 "../src/util/string.vala"
		if (bytes_read == ((gsize) _tmp7_)) {
#line 596 "string.c"
			const gchar* _tmp8_;
#line 104 "../src/util/string.vala"
			_tmp8_ = charset;
#line 104 "../src/util/string.vala"
			g_debug ("string.vala:104: CONVERT: Locale is not UTF-8, convert from %s", _tmp8_);
#line 105 "../src/util/string.vala"
			result = output;
#line 105 "../src/util/string.vala"
			return result;
#line 606 "string.c"
		}
	}
	{
		gchar* _tmp9_ = NULL;
		gint _tmp10_;
		gint _tmp11_;
		gsize _tmp12_ = 0UL;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 110 "../src/util/string.vala"
		_tmp10_ = strlen (text);
#line 110 "../src/util/string.vala"
		_tmp11_ = _tmp10_;
#line 110 "../src/util/string.vala"
		_tmp13_ = g_convert (text, (gssize) _tmp11_, "UTF-8", "WINDOWS-1252", &_tmp12_, NULL, &_inner_error0_);
#line 110 "../src/util/string.vala"
		bytes_read = _tmp12_;
#line 110 "../src/util/string.vala"
		_tmp9_ = _tmp13_;
#line 110 "../src/util/string.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 110 "../src/util/string.vala"
			if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 630 "string.c"
				goto __catch7_g_convert_error;
			}
#line 110 "../src/util/string.vala"
			_g_free0 (output);
#line 110 "../src/util/string.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 110 "../src/util/string.vala"
			g_clear_error (&_inner_error0_);
#line 110 "../src/util/string.vala"
			return NULL;
#line 641 "string.c"
		}
#line 110 "../src/util/string.vala"
		_tmp14_ = _tmp9_;
#line 110 "../src/util/string.vala"
		_tmp9_ = NULL;
#line 110 "../src/util/string.vala"
		_g_free0 (output);
#line 110 "../src/util/string.vala"
		output = _tmp14_;
#line 111 "../src/util/string.vala"
		charset = "WINDOWS-1252";
#line 109 "../src/util/string.vala"
		_g_free0 (_tmp9_);
#line 655 "string.c"
	}
	goto __finally7;
	__catch7_g_convert_error:
	{
		GError* _error_ = NULL;
		GError* _tmp15_;
#line 109 "../src/util/string.vala"
		_error_ = _inner_error0_;
#line 109 "../src/util/string.vala"
		_inner_error0_ = NULL;
#line 113 "../src/util/string.vala"
		_tmp15_ = _error_;
#line 113 "../src/util/string.vala"
		if (g_error_matches (_tmp15_, G_CONVERT_ERROR, G_CONVERT_ERROR_NO_CONVERSION)) {
#line 670 "string.c"
			{
				gchar* _tmp16_ = NULL;
				gint _tmp17_;
				gint _tmp18_;
				gsize _tmp19_ = 0UL;
				gchar* _tmp20_;
				gchar* _tmp21_;
#line 115 "../src/util/string.vala"
				_tmp17_ = strlen (text);
#line 115 "../src/util/string.vala"
				_tmp18_ = _tmp17_;
#line 115 "../src/util/string.vala"
				_tmp20_ = g_convert (text, (gssize) _tmp18_, "UTF-8", "ISO-8859-1", &_tmp19_, NULL, &_inner_error0_);
#line 115 "../src/util/string.vala"
				bytes_read = _tmp19_;
#line 115 "../src/util/string.vala"
				_tmp16_ = _tmp20_;
#line 115 "../src/util/string.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 690 "string.c"
					goto __catch8_g_error;
				}
#line 115 "../src/util/string.vala"
				_tmp21_ = _tmp16_;
#line 115 "../src/util/string.vala"
				_tmp16_ = NULL;
#line 115 "../src/util/string.vala"
				_g_free0 (output);
#line 115 "../src/util/string.vala"
				output = _tmp21_;
#line 116 "../src/util/string.vala"
				charset = "ISO-8859-1";
#line 114 "../src/util/string.vala"
				_g_free0 (_tmp16_);
#line 705 "string.c"
			}
			goto __finally8;
			__catch8_g_error:
			{
				GError* _error_ = NULL;
#line 114 "../src/util/string.vala"
				_error_ = _inner_error0_;
#line 114 "../src/util/string.vala"
				_inner_error0_ = NULL;
#line 114 "../src/util/string.vala"
				_g_error_free0 (_error_);
#line 717 "string.c"
			}
			__finally8:
#line 114 "../src/util/string.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../src/util/string.vala"
				_g_error_free0 (_error_);
#line 114 "../src/util/string.vala"
				_g_error_free0 (_error_);
#line 114 "../src/util/string.vala"
				_g_free0 (output);
#line 114 "../src/util/string.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "../src/util/string.vala"
				g_clear_error (&_inner_error0_);
#line 114 "../src/util/string.vala"
				return NULL;
#line 734 "string.c"
			}
		}
#line 109 "../src/util/string.vala"
		_g_error_free0 (_error_);
#line 739 "string.c"
	}
	__finally7:
#line 109 "../src/util/string.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "../src/util/string.vala"
		_g_free0 (output);
#line 109 "../src/util/string.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "../src/util/string.vala"
		g_clear_error (&_inner_error0_);
#line 109 "../src/util/string.vala"
		return NULL;
#line 752 "string.c"
	}
#line 121 "../src/util/string.vala"
	_tmp22_ = strlen (text);
#line 121 "../src/util/string.vala"
	_tmp23_ = _tmp22_;
#line 121 "../src/util/string.vala"
	if (bytes_read == ((gsize) _tmp23_)) {
#line 760 "string.c"
		const gchar* _tmp24_;
#line 122 "../src/util/string.vala"
		_tmp24_ = charset;
#line 122 "../src/util/string.vala"
		g_debug ("string.vala:122: CONVERT: Guessed conversion from %s", _tmp24_);
#line 124 "../src/util/string.vala"
		result = output;
#line 124 "../src/util/string.vala"
		return result;
#line 770 "string.c"
	}
#line 127 "../src/util/string.vala"
	result = NULL;
#line 127 "../src/util/string.vala"
	_g_free0 (output);
#line 127 "../src/util/string.vala"
	return result;
#line 778 "string.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 802 "string.c"
}

static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1315 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1315 "glib-2.0.vapi"
	g_return_val_if_fail (delimiters != NULL, NULL);
#line 1316 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1316 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1317 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1317 "glib-2.0.vapi"
	g_strdelimit (_tmp1_, delimiters, new_delimiter);
#line 1318 "glib-2.0.vapi"
	result = _result_;
#line 1318 "glib-2.0.vapi"
	return result;
#line 830 "string.c"
}

gchar*
prepare_input_text (const gchar* text,
                    PrepareInputTextOptions options,
                    gint dest_length)
{
	gchar* result = NULL;
	gchar* prepped = NULL;
	gchar* _tmp0_;
	gboolean _tmp11_ = FALSE;
#line 131 "../src/util/string.vala"
	if (text == NULL) {
#line 132 "../src/util/string.vala"
		result = NULL;
#line 132 "../src/util/string.vala"
		return result;
#line 848 "string.c"
	}
#line 134 "../src/util/string.vala"
	_tmp0_ = g_strdup (text);
#line 134 "../src/util/string.vala"
	prepped = _tmp0_;
#line 135 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) == PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) {
#line 136 "../src/util/string.vala"
		if (!g_utf8_validate (text, (gssize) -1, NULL)) {
#line 858 "string.c"
			gchar* _tmp1_;
			const gchar* _tmp2_;
#line 137 "../src/util/string.vala"
			_tmp1_ = guess_convert (text);
#line 137 "../src/util/string.vala"
			_g_free0 (prepped);
#line 137 "../src/util/string.vala"
			prepped = _tmp1_;
#line 139 "../src/util/string.vala"
			_tmp2_ = prepped;
#line 139 "../src/util/string.vala"
			if (_tmp2_ == NULL) {
#line 871 "string.c"
				const gchar* _tmp3_ = NULL;
				gchar* _tmp4_;
#line 140 "../src/util/string.vala"
				if ((options & PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) != 0) {
#line 140 "../src/util/string.vala"
					_tmp3_ = NULL;
#line 878 "string.c"
				} else {
#line 140 "../src/util/string.vala"
					_tmp3_ = "";
#line 882 "string.c"
				}
#line 140 "../src/util/string.vala"
				_tmp4_ = g_strdup (_tmp3_);
#line 140 "../src/util/string.vala"
				result = _tmp4_;
#line 140 "../src/util/string.vala"
				_g_free0 (prepped);
#line 140 "../src/util/string.vala"
				return result;
#line 892 "string.c"
			}
		}
	}
#line 149 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) != 0) {
#line 898 "string.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 150 "../src/util/string.vala"
		_tmp5_ = prepped;
#line 150 "../src/util/string.vala"
		_tmp6_ = g_utf8_normalize (_tmp5_, (gssize) -1, G_NORMALIZE_NFC);
#line 150 "../src/util/string.vala"
		_g_free0 (prepped);
#line 150 "../src/util/string.vala"
		prepped = _tmp6_;
#line 909 "string.c"
	}
#line 152 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP) != 0) {
#line 913 "string.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 153 "../src/util/string.vala"
		_tmp7_ = prepped;
#line 153 "../src/util/string.vala"
		_tmp8_ = string_strip (_tmp7_);
#line 153 "../src/util/string.vala"
		_g_free0 (prepped);
#line 153 "../src/util/string.vala"
		prepped = _tmp8_;
#line 924 "string.c"
	}
#line 157 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) != 0) {
#line 928 "string.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 158 "../src/util/string.vala"
		_tmp9_ = prepped;
#line 158 "../src/util/string.vala"
		_tmp10_ = string_delimit (_tmp9_, "\n\r", ' ');
#line 158 "../src/util/string.vala"
		_g_free0 (prepped);
#line 158 "../src/util/string.vala"
		prepped = _tmp10_;
#line 939 "string.c"
	}
#line 160 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) != 0) {
#line 943 "string.c"
		const gchar* _tmp12_;
#line 160 "../src/util/string.vala"
		_tmp12_ = prepped;
#line 160 "../src/util/string.vala"
		_tmp11_ = is_string_empty (_tmp12_);
#line 949 "string.c"
	} else {
#line 160 "../src/util/string.vala"
		_tmp11_ = FALSE;
#line 953 "string.c"
	}
#line 160 "../src/util/string.vala"
	if (_tmp11_) {
#line 161 "../src/util/string.vala"
		result = NULL;
#line 161 "../src/util/string.vala"
		_g_free0 (prepped);
#line 161 "../src/util/string.vala"
		return result;
#line 963 "string.c"
	}
#line 166 "../src/util/string.vala"
	if (dest_length >= 0) {
#line 967 "string.c"
		GString* sb = NULL;
		const gchar* _tmp13_;
		GString* _tmp14_;
		GString* _tmp15_;
		GString* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 167 "../src/util/string.vala"
		_tmp13_ = prepped;
#line 167 "../src/util/string.vala"
		_tmp14_ = g_string_new (_tmp13_);
#line 167 "../src/util/string.vala"
		sb = _tmp14_;
#line 168 "../src/util/string.vala"
		_tmp15_ = sb;
#line 168 "../src/util/string.vala"
		g_string_truncate (_tmp15_, (gsize) dest_length);
#line 169 "../src/util/string.vala"
		_tmp16_ = sb;
#line 169 "../src/util/string.vala"
		_tmp17_ = _tmp16_->str;
#line 169 "../src/util/string.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 169 "../src/util/string.vala"
		result = _tmp18_;
#line 169 "../src/util/string.vala"
		_g_string_free0 (sb);
#line 169 "../src/util/string.vala"
		_g_free0 (prepped);
#line 169 "../src/util/string.vala"
		return result;
#line 999 "string.c"
	}
#line 173 "../src/util/string.vala"
	result = prepped;
#line 173 "../src/util/string.vala"
	return result;
#line 1005 "string.c"
}

gint64
parse_int64 (const gchar* str,
             gint num_base)
{
	gint64 result = 0LL;
#line 176 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, 0LL);
#line 177 "../src/util/string.vala"
	result = g_ascii_strtoll (str, NULL, (guint) num_base);
#line 177 "../src/util/string.vala"
	return result;
#line 1019 "string.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1101 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1102 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1102 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1104 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1104 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1041 "string.c"
		gchar* _tmp2_;
#line 1105 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1105 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1105 "glib-2.0.vapi"
		return result;
#line 1049 "string.c"
	} else {
#line 1107 "glib-2.0.vapi"
		result = -1;
#line 1107 "glib-2.0.vapi"
		return result;
#line 1055 "string.c"
	}
}

inline gboolean
string_contains_char (const gchar* haystack,
                      gunichar needle)
{
	gboolean result = FALSE;
#line 182 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, FALSE);
#line 183 "../src/util/string.vala"
	result = string_index_of_char (haystack, needle, 0) >= 0;
#line 183 "../src/util/string.vala"
	return result;
#line 1070 "string.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1094 "string.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 1102 "string.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 1108 "string.c"
	}
}

inline gboolean
string_contains_str (const gchar* haystack,
                     const gchar* needle)
{
	gboolean result = FALSE;
#line 186 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, FALSE);
#line 186 "../src/util/string.vala"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 187 "../src/util/string.vala"
	result = string_index_of (haystack, needle, 0) >= 0;
#line 187 "../src/util/string.vala"
	return result;
#line 1125 "string.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
#line 1428 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1429 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1429 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1429 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1430 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1431 "glib-2.0.vapi"
		start = string_length + start;
#line 1152 "string.c"
	}
#line 1433 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1434 "glib-2.0.vapi"
		end = string_length + end;
#line 1158 "string.c"
	}
#line 1436 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1164 "string.c"
	} else {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1168 "string.c"
	}
#line 1436 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1437 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1176 "string.c"
	} else {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1180 "string.c"
	}
#line 1437 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1438 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1439 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1439 "glib-2.0.vapi"
	result = _tmp4_;
#line 1439 "glib-2.0.vapi"
	return result;
#line 1192 "string.c"
}

inline gchar*
string_sliced_at (const gchar* str,
                  gint index)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 190 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 191 "../src/util/string.vala"
	if (index >= 0) {
#line 1205 "string.c"
		gint _tmp1_;
		gint _tmp2_;
		gchar* _tmp3_;
#line 191 "../src/util/string.vala"
		_tmp1_ = strlen (str);
#line 191 "../src/util/string.vala"
		_tmp2_ = _tmp1_;
#line 191 "../src/util/string.vala"
		_tmp3_ = string_slice (str, (glong) index, (glong) _tmp2_);
#line 191 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 191 "../src/util/string.vala"
		_tmp0_ = _tmp3_;
#line 1219 "string.c"
	} else {
#line 191 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 191 "../src/util/string.vala"
		_tmp0_ = NULL;
#line 1225 "string.c"
	}
#line 191 "../src/util/string.vala"
	result = _tmp0_;
#line 191 "../src/util/string.vala"
	return result;
#line 1231 "string.c"
}

inline gchar*
string_sliced_at_first_str (const gchar* haystack,
                            const gchar* needle,
                            gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 194 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 194 "../src/util/string.vala"
	g_return_val_if_fail (needle != NULL, NULL);
#line 195 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_index_of (haystack, needle, start_index));
#line 195 "../src/util/string.vala"
	result = _tmp0_;
#line 195 "../src/util/string.vala"
	return result;
#line 1251 "string.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1092 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1092 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1094 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1094 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1275 "string.c"
		gchar* _tmp2_;
#line 1095 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1095 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1095 "glib-2.0.vapi"
		return result;
#line 1283 "string.c"
	} else {
#line 1097 "glib-2.0.vapi"
		result = -1;
#line 1097 "glib-2.0.vapi"
		return result;
#line 1289 "string.c"
	}
}

inline gchar*
string_sliced_at_last_str (const gchar* haystack,
                           const gchar* needle,
                           gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 198 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 198 "../src/util/string.vala"
	g_return_val_if_fail (needle != NULL, NULL);
#line 199 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_last_index_of (haystack, needle, start_index));
#line 199 "../src/util/string.vala"
	result = _tmp0_;
#line 199 "../src/util/string.vala"
	return result;
#line 1310 "string.c"
}

inline gchar*
string_sliced_at_first_char (const gchar* haystack,
                             gunichar ch,
                             gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 202 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 203 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_index_of_char (haystack, ch, start_index));
#line 203 "../src/util/string.vala"
	result = _tmp0_;
#line 203 "../src/util/string.vala"
	return result;
#line 1328 "string.c"
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1111 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1112 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1112 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1114 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1114 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1350 "string.c"
		gchar* _tmp2_;
#line 1115 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1115 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1115 "glib-2.0.vapi"
		return result;
#line 1358 "string.c"
	} else {
#line 1117 "glib-2.0.vapi"
		result = -1;
#line 1117 "glib-2.0.vapi"
		return result;
#line 1364 "string.c"
	}
}

inline gchar*
string_sliced_at_last_char (const gchar* haystack,
                            gunichar ch,
                            gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 206 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 207 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_last_index_of_char (haystack, ch, start_index));
#line 207 "../src/util/string.vala"
	result = _tmp0_;
#line 207 "../src/util/string.vala"
	return result;
#line 1383 "string.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1210 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1211 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1211 "glib-2.0.vapi"
	return result;
#line 1397 "string.c"
}

gchar*
string_strip_leading_zeroes (const gchar* str)
{
	gchar* result = NULL;
	GString* stripped = NULL;
	GString* _tmp0_;
	gboolean prev_is_space = FALSE;
	GString* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
#line 211 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 212 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 212 "../src/util/string.vala"
	stripped = _tmp0_;
#line 213 "../src/util/string.vala"
	prev_is_space = TRUE;
#line 1418 "string.c"
	{
		const gchar* iter = NULL;
#line 214 "../src/util/string.vala"
		iter = str;
#line 1423 "string.c"
		{
			gboolean _tmp1_ = FALSE;
#line 214 "../src/util/string.vala"
			_tmp1_ = TRUE;
#line 214 "../src/util/string.vala"
			while (TRUE) {
#line 1430 "string.c"
				const gchar* _tmp4_;
				gunichar ch = 0U;
				const gchar* _tmp5_;
				gboolean _tmp6_ = FALSE;
#line 214 "../src/util/string.vala"
				if (!_tmp1_) {
#line 1437 "string.c"
					const gchar* _tmp2_;
					const gchar* _tmp3_;
#line 214 "../src/util/string.vala"
					_tmp2_ = iter;
#line 214 "../src/util/string.vala"
					_tmp3_ = g_utf8_next_char (_tmp2_);
#line 214 "../src/util/string.vala"
					iter = _tmp3_;
#line 1446 "string.c"
				}
#line 214 "../src/util/string.vala"
				_tmp1_ = FALSE;
#line 214 "../src/util/string.vala"
				_tmp4_ = iter;
#line 214 "../src/util/string.vala"
				if (!(string_get_char (_tmp4_, (glong) 0) != ((gunichar) 0))) {
#line 214 "../src/util/string.vala"
					break;
#line 1456 "string.c"
				}
#line 215 "../src/util/string.vala"
				_tmp5_ = iter;
#line 215 "../src/util/string.vala"
				ch = string_get_char (_tmp5_, (glong) 0);
#line 217 "../src/util/string.vala"
				if (!prev_is_space) {
#line 217 "../src/util/string.vala"
					_tmp6_ = TRUE;
#line 1466 "string.c"
				} else {
#line 217 "../src/util/string.vala"
					_tmp6_ = ch != ((gunichar) '0');
#line 1470 "string.c"
				}
#line 217 "../src/util/string.vala"
				if (_tmp6_) {
#line 1474 "string.c"
					GString* _tmp7_;
#line 218 "../src/util/string.vala"
					_tmp7_ = stripped;
#line 218 "../src/util/string.vala"
					g_string_append_unichar (_tmp7_, ch);
#line 219 "../src/util/string.vala"
					prev_is_space = g_unichar_isspace (ch);
#line 1482 "string.c"
				}
			}
		}
	}
#line 223 "../src/util/string.vala"
	_tmp8_ = stripped;
#line 223 "../src/util/string.vala"
	_tmp9_ = _tmp8_->str;
#line 223 "../src/util/string.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 223 "../src/util/string.vala"
	result = _tmp10_;
#line 223 "../src/util/string.vala"
	_g_string_free0 (stripped);
#line 223 "../src/util/string.vala"
	return result;
#line 1499 "string.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1199 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1200 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1201 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 1515 "string.c"
		gchar* _tmp0_;
#line 1202 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1202 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1203 "glib-2.0.vapi"
		result = TRUE;
#line 1203 "glib-2.0.vapi"
		if (c) {
#line 1203 "glib-2.0.vapi"
			*c = _vala_c;
#line 1527 "string.c"
		}
#line 1203 "glib-2.0.vapi"
		return result;
#line 1531 "string.c"
	} else {
#line 1205 "glib-2.0.vapi"
		result = FALSE;
#line 1205 "glib-2.0.vapi"
		if (c) {
#line 1205 "glib-2.0.vapi"
			*c = _vala_c;
#line 1539 "string.c"
		}
#line 1205 "glib-2.0.vapi"
		return result;
#line 1543 "string.c"
	}
#line 1199 "glib-2.0.vapi"
	if (c) {
#line 1199 "glib-2.0.vapi"
		*c = _vala_c;
#line 1549 "string.c"
	}
}

gchar*
string_remove_diacritics (const gchar* istring)
{
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	gunichar ch = 0U;
	gint i = 0;
	GString* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
#line 226 "../src/util/string.vala"
	g_return_val_if_fail (istring != NULL, NULL);
#line 227 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 227 "../src/util/string.vala"
	builder = _tmp0_;
#line 229 "../src/util/string.vala"
	i = 0;
#line 230 "../src/util/string.vala"
	while (TRUE) {
#line 1574 "string.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_;
		gboolean _tmp5_;
		GString* _tmp6_;
#line 230 "../src/util/string.vala"
		_tmp1_ = g_utf8_normalize (istring, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 230 "../src/util/string.vala"
		_tmp2_ = _tmp1_;
#line 230 "../src/util/string.vala"
		_tmp4_ = string_get_next_char (_tmp2_, &i, &_tmp3_);
#line 230 "../src/util/string.vala"
		ch = _tmp3_;
#line 230 "../src/util/string.vala"
		_tmp5_ = !_tmp4_;
#line 230 "../src/util/string.vala"
		_g_free0 (_tmp2_);
#line 230 "../src/util/string.vala"
		if (_tmp5_) {
#line 230 "../src/util/string.vala"
			break;
#line 1597 "string.c"
		}
#line 231 "../src/util/string.vala"
		switch (g_unichar_type (ch)) {
#line 231 "../src/util/string.vala"
			case G_UNICODE_CONTROL:
#line 231 "../src/util/string.vala"
			case G_UNICODE_FORMAT:
#line 231 "../src/util/string.vala"
			case G_UNICODE_UNASSIGNED:
#line 231 "../src/util/string.vala"
			case G_UNICODE_NON_SPACING_MARK:
#line 231 "../src/util/string.vala"
			case G_UNICODE_COMBINING_MARK:
#line 231 "../src/util/string.vala"
			case G_UNICODE_ENCLOSING_MARK:
#line 1613 "string.c"
			{
#line 239 "../src/util/string.vala"
				continue;
#line 1617 "string.c"
			}
			default:
#line 231 "../src/util/string.vala"
			break;
#line 1622 "string.c"
		}
#line 241 "../src/util/string.vala"
		_tmp6_ = builder;
#line 241 "../src/util/string.vala"
		g_string_append_unichar (_tmp6_, ch);
#line 1628 "string.c"
	}
#line 243 "../src/util/string.vala"
	_tmp7_ = builder;
#line 243 "../src/util/string.vala"
	_tmp8_ = _tmp7_->str;
#line 243 "../src/util/string.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 243 "../src/util/string.vala"
	result = _tmp9_;
#line 243 "../src/util/string.vala"
	_g_string_free0 (builder);
#line 243 "../src/util/string.vala"
	return result;
#line 1642 "string.c"
}

gchar*
string_to_hex_string (const gchar* str)
{
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	guint8* data = NULL;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 246 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 247 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 247 "../src/util/string.vala"
	builder = _tmp0_;
#line 249 "../src/util/string.vala"
	data = (guint8*) str;
#line 250 "../src/util/string.vala"
	while (TRUE) {
#line 1665 "string.c"
		guint8* _tmp1_;
		const gchar* _tmp2_ = NULL;
		guint8* _tmp3_;
		GString* _tmp4_;
		guint8* _tmp5_;
#line 250 "../src/util/string.vala"
		_tmp1_ = data;
#line 250 "../src/util/string.vala"
		if (!(((gint) (*_tmp1_)) != 0)) {
#line 250 "../src/util/string.vala"
			break;
#line 1677 "string.c"
		}
#line 251 "../src/util/string.vala"
		_tmp3_ = data;
#line 251 "../src/util/string.vala"
		if (((gint) (*_tmp3_)) != 0) {
#line 251 "../src/util/string.vala"
			_tmp2_ = " ";
#line 1685 "string.c"
		} else {
#line 251 "../src/util/string.vala"
			_tmp2_ = "";
#line 1689 "string.c"
		}
#line 251 "../src/util/string.vala"
		_tmp4_ = builder;
#line 251 "../src/util/string.vala"
		_tmp5_ = data;
#line 251 "../src/util/string.vala"
		data = _tmp5_ + 1;
#line 251 "../src/util/string.vala"
		g_string_append_printf (_tmp4_, "%02Xh%s", (guint) (*_tmp5_), _tmp2_);
#line 1699 "string.c"
	}
#line 253 "../src/util/string.vala"
	_tmp6_ = builder;
#line 253 "../src/util/string.vala"
	_tmp7_ = _tmp6_->str;
#line 253 "../src/util/string.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 253 "../src/util/string.vala"
	result = _tmp8_;
#line 253 "../src/util/string.vala"
	_g_string_free0 (builder);
#line 253 "../src/util/string.vala"
	return result;
#line 1713 "string.c"
}

guint
string_collated_hash (void* ptr)
{
	guint result = 0U;
	gchar* str = NULL;
	gchar* _tmp0_;
	GHashFunc _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint _tmp4_;
#line 273 "../src/util/string.vala"
	_tmp0_ = g_strdup ((const gchar*) ptr);
#line 273 "../src/util/string.vala"
	str = _tmp0_;
#line 275 "../src/util/string.vala"
	_tmp1_ = g_str_hash;
#line 275 "../src/util/string.vala"
	_tmp2_ = g_utf8_collate_key (str, (gssize) -1);
#line 275 "../src/util/string.vala"
	_tmp3_ = _tmp2_;
#line 275 "../src/util/string.vala"
	_tmp4_ = _tmp1_ (_tmp3_);
#line 275 "../src/util/string.vala"
	_g_free0 (_tmp3_);
#line 275 "../src/util/string.vala"
	result = _tmp4_;
#line 275 "../src/util/string.vala"
	_g_free0 (str);
#line 275 "../src/util/string.vala"
	return result;
#line 1746 "string.c"
}

guint
string_precollated_hash (void* ptr)
{
	guint result = 0U;
	GHashFunc _tmp0_;
#line 280 "../src/util/string.vala"
	_tmp0_ = g_str_hash;
#line 280 "../src/util/string.vala"
	result = _tmp0_ ((const gchar*) ptr);
#line 280 "../src/util/string.vala"
	return result;
#line 1760 "string.c"
}

gint
string_collated_compare (void* a,
                         void* b)
{
	gint result = 0;
	gchar* astr = NULL;
	gchar* _tmp0_;
	gchar* bstr = NULL;
	gchar* _tmp1_;
	gint _result_ = 0;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_ = 0;
#line 285 "../src/util/string.vala"
	_tmp0_ = g_strdup ((const gchar*) a);
#line 285 "../src/util/string.vala"
	astr = _tmp0_;
#line 286 "../src/util/string.vala"
	_tmp1_ = g_strdup ((const gchar*) b);
#line 286 "../src/util/string.vala"
	bstr = _tmp1_;
#line 288 "../src/util/string.vala"
	_tmp2_ = astr;
#line 288 "../src/util/string.vala"
	_tmp3_ = bstr;
#line 288 "../src/util/string.vala"
	_result_ = g_utf8_collate (_tmp2_, _tmp3_);
#line 290 "../src/util/string.vala"
	if (_result_ != 0) {
#line 290 "../src/util/string.vala"
		_tmp4_ = _result_;
#line 1794 "string.c"
	} else {
		GCompareFunc _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 290 "../src/util/string.vala"
		_tmp5_ = ((GCompareFunc) g_strcmp0);
#line 290 "../src/util/string.vala"
		_tmp6_ = astr;
#line 290 "../src/util/string.vala"
		_tmp7_ = bstr;
#line 290 "../src/util/string.vala"
		_tmp4_ = _tmp5_ (_tmp6_, _tmp7_);
#line 1807 "string.c"
	}
#line 290 "../src/util/string.vala"
	result = _tmp4_;
#line 290 "../src/util/string.vala"
	_g_free0 (bstr);
#line 290 "../src/util/string.vala"
	_g_free0 (astr);
#line 290 "../src/util/string.vala"
	return result;
#line 1817 "string.c"
}

gint
string_precollated_compare (const gchar* astr,
                            const gchar* akey,
                            const gchar* bstr,
                            const gchar* bkey)
{
	gint result = 0;
	gint _result_ = 0;
	GCompareFunc _tmp0_;
	gint _tmp1_ = 0;
#line 294 "../src/util/string.vala"
	g_return_val_if_fail (astr != NULL, 0);
#line 294 "../src/util/string.vala"
	g_return_val_if_fail (akey != NULL, 0);
#line 294 "../src/util/string.vala"
	g_return_val_if_fail (bstr != NULL, 0);
#line 294 "../src/util/string.vala"
	g_return_val_if_fail (bkey != NULL, 0);
#line 295 "../src/util/string.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 295 "../src/util/string.vala"
	_result_ = _tmp0_ (akey, bkey);
#line 297 "../src/util/string.vala"
	if (_result_ != 0) {
#line 297 "../src/util/string.vala"
		_tmp1_ = _result_;
#line 1846 "string.c"
	} else {
		GCompareFunc _tmp2_;
#line 297 "../src/util/string.vala"
		_tmp2_ = ((GCompareFunc) g_strcmp0);
#line 297 "../src/util/string.vala"
		_tmp1_ = _tmp2_ (astr, bstr);
#line 1853 "string.c"
	}
#line 297 "../src/util/string.vala"
	result = _tmp1_;
#line 297 "../src/util/string.vala"
	return result;
#line 1859 "string.c"
}

gboolean
string_collated_equals (void* a,
                        void* b)
{
	gboolean result = FALSE;
#line 302 "../src/util/string.vala"
	result = string_collated_compare (a, b) == 0;
#line 302 "../src/util/string.vala"
	return result;
#line 1871 "string.c"
}

gboolean
string_precollated_equals (const gchar* astr,
                           const gchar* akey,
                           const gchar* bstr,
                           const gchar* bkey)
{
	gboolean result = FALSE;
#line 306 "../src/util/string.vala"
	g_return_val_if_fail (astr != NULL, FALSE);
#line 306 "../src/util/string.vala"
	g_return_val_if_fail (akey != NULL, FALSE);
#line 306 "../src/util/string.vala"
	g_return_val_if_fail (bstr != NULL, FALSE);
#line 306 "../src/util/string.vala"
	g_return_val_if_fail (bkey != NULL, FALSE);
#line 307 "../src/util/string.vala"
	result = string_precollated_compare (astr, akey, bstr, bkey) == 0;
#line 307 "../src/util/string.vala"
	return result;
#line 1893 "string.c"
}

